/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
export let FinancialChart = /*@__PURE__*/ (() => {
    class FinancialChart extends XYChart {
        sv(a, b, c) {
            super.sv(a, b, c);
            switch (a) {
                case "ToolbarTemplate":
                case "RangeSelectorTemplate":
                    this.adv = new FinancialChartToolbar(this, this.aic);
                    break;
                case "Toolbar":
                    let d = b;
                    if (d != null) {
                        d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.ak6));
                        d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.ak9));
                        d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.ala));
                        d.l(null);
                    }
                    if (this.adv != null) {
                        this.adv.ac = this.ad2;
                        this.adv.ai = this.dp;
                        this.adv.y = this.adx;
                        this.adv.al = this.afv;
                        if (this.ahj != null) {
                            this.adv.l(this.ahj);
                        }
                        let e = this.adv;
                        e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.ak6));
                        ;
                        let f = this.adv;
                        f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.ak9));
                        let g = this.adv;
                        g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.ala));
                    }
                    break;
                case "ChartType":
                    if (this.adv != null) {
                        this.adv.y = this.adx;
                    }
                    break;
                case "VolumeType":
                    if (this.adv != null) {
                        this.adv.ac = this.ad2;
                    }
                    break;
                case "TrendLineType":
                    if (this.adv != null) {
                        this.adv.ai = this.dp;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.adv == null) {
                        break;
                    }
                    this.adv.al = this.afv;
                    this.setGridRows();
                    break;
            }
        }
        ala(a, b) {
            this.ad2 = this.adv.ac;
        }
        ak9(a, b) {
            this.dp = this.adv.ai;
        }
        ak6(a, b) {
            this.adx = this.adv.y;
        }
        alj() {
            this.aeo = new IndicatorPane();
            this.aef = TypeRegistrar.create("FinancialLegend");
        }
        provideGrid(a) {
            this.ahm = a;
            this.al4();
            this.setGridRows();
            if (this.adv != null) {
                this.adv.bg(a);
            }
        }
        onDocumentClick(a) {
            if (this.adv != null) {
                this.adv.bl(a);
            }
        }
        getContext() {
            let a = this.adv.v();
            let b = new FinancialChartContext();
            b.vm = new FinancialChartViewModel();
            b.vm.toolbar = a;
            b.container = this.j5;
            b.toolbarContainer = this.ahj;
            b.legendContainer = this.ahi;
            b.indicatorsContainer = this.ahh;
            b.volumeContainer = this.ahk;
            b.zoomContainer = this.ahl;
            return b;
        }
        provideContainer(a) {
            let b = a;
            if (b != null) {
                let c = "financialChartMainGrid";
                let d = b.createElement("div");
                d.setStyleProperty("width", "100%");
                d.setStyleProperty("height", "100%");
                if (this.adv == null) {
                    this.adv = new FinancialChartToolbar(this, this.aic);
                }
                this.adv.w.isIndicatorMenuVisible = this.afm && this.afn;
                this.ahj = b.getSubRenderer(d);
                this.adv.l(this.ahj);
                let e = b.createElement("div");
                e.setStyleProperty("width", "100%");
                e.setStyleProperty("height", "100%");
                let f = b.createElement("div");
                f.setStyleProperty("width", "100%");
                f.setStyleProperty("height", "100%");
                this.ahi = b.getSubRenderer(f);
                let g = b.createElement("div");
                g.setStyleProperty("width", "100%");
                g.setStyleProperty("height", "100%");
                this.ahh = b.getSubRenderer(g);
                let h = b.createElement("div");
                h.setStyleProperty("width", "100%");
                h.setStyleProperty("height", "100%");
                this.ahk = b.getSubRenderer(h);
                let i = b.createElement("div");
                i.setStyleProperty("width", "100%");
                i.setStyleProperty("height", "100%");
                this.ahl = b.getSubRenderer(i);
                a = b.getSubRenderer(e);
            }
            else {
                this.ahj = null;
                if (this.adv != null) {
                    this.adv.l(null);
                }
                if (this.afd != null) {
                    this.afd.provideContainer(null);
                    this.afd = null;
                }
                if (this.aef != null) {
                    this.aef.provideContainer(null);
                }
            }
            super.provideContainer(a);
            if (b != null) {
                if (this.volumeChart != null) {
                    this.volumeChart.provideContainer(this.ahk);
                }
                if (this.aeo != null) {
                    this.aeo.h(this.ahh);
                }
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.provideContainer(this.ahl);
                    if (a != null) {
                        this.akq();
                    }
                    else {
                        this.afd = null;
                    }
                }
                if (this.aef != null) {
                    this.aef.provideContainer(this.ahi);
                }
                this.setGridRows();
            }
        }
        alu(a, b, c) {
            if (a != null) {
                a.provideContainer(null);
            }
            if (b != null) {
                b.provideContainer(c);
            }
            this.setGridRows();
        }
        al8(a, b) {
            this.alu(a, b, this.ahl);
            if (b == null) {
                return;
            }
            this.akq();
        }
        akq() {
            if (this.ahl == null) {
                return;
            }
            if (this.afd != null) {
                this.afd.provideContainer(null);
            }
            this.afd = TypeRegistrar.create("ZoomSlider");
            this.afd.provideContainer(this.ahl);
            let a = this.afd;
            a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
                if (this.dataChart != null) {
                    this.dataChart.tq = new Rect(0, this.afd.windowRect.left, this.dataChart.ta.top, this.afd.windowRect.width, this.dataChart.ta.height);
                }
            });
            this.akr();
        }
        al6(a, b) {
            this.alu(a, b, this.ahk);
        }
        setGridRows() {
            if (this.ahm == null) {
                return;
            }
            let a = new Array(6);
            a[0] = (this.afv ? this.ag3 : 0) + "px";
            a[1] = this.afr ? "min-content" : "0px";
            a[2] = "auto";
            a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
            a[4] = this.volumeChart == null ? "0px" : "100px";
            a[5] = this.zoomSliderChart == null ? "0px" : "100px";
            if (this.afd != null) {
                if (a[5] == "0px") {
                    this.afd.hide();
                }
                else {
                    this.afd.show();
                }
            }
            this.ahm.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
            this.ahm.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
            if (this.j5 == null) {
                return;
            }
            if (this.dataChart != null) {
                this.dataChart.notifyContainerResized();
            }
            if (this.aeo != null) {
                this.aeo.f();
            }
            if (this.volumeChart != null) {
                this.volumeChart.notifyContainerResized();
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.notifyContainerResized();
            }
            if (this.afd != null) {
                this.afd.notifySizeChanged();
            }
        }
        r5() {
            super.r5();
            this.wa = 1;
            this.abp = 0;
            this.x7 = 0;
            this.acj = null;
            this.acc = AxisDefaults.g;
            this.xr = AxisDefaults.e;
            this.xq = AxisDefaults.f;
            this.acd = AxisDefaults.j;
            this.ab9 = null;
            this.ama = AxisDefaults.h;
            this.ahg = AxisDefaults.b;
            this.fq = true;
            this.fj = true;
            this.fk = false;
            this.a9 = 0;
            this.h6 = Defaults.j;
            this.uk = Defaults.ae;
            this.uf = Defaults.af;
            this.ug = Defaults.ag;
            this.is = NaN;
            this.ij = 40;
            this.fz = true;
            this.f6 = false;
            if (this.dataChart != null) {
                let a = this.dataChart.cu.j.e();
                this.ac6 = a.d;
                this.ac7 = a.e;
                this.ac5 = a.d;
                this.ama = this.dataChart.xv;
            }
            let b = new BrushCollection();
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8BDC5C";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#8961A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#6DB1FF";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#82E9D9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#EA3C63";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#735656";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#F8CE4F";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#A8A8B7";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#E051A9";
                return $ret;
            })()));
            b.add(((() => {
                let $ret = new Brush();
                $ret.fill = "#FF903B";
                return $ret;
            })()));
            let c = new BrushCollection();
            for (let d of fromEnum(b)) {
                c.add(BrushUtil.m(d, 0.3));
            }
            this.ac8 = c;
            this.ac9 = b;
        }
        alq() {
            if (this.aeo != null) {
                this.aeo.b = null;
                this.aeo.b = this.indicatorCharts;
            }
            this.setGridRows();
        }
        alr() {
            this.setGridRows();
        }
        al0() {
            this.alq();
        }
        akp() {
            if (this.afd == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
                return;
            }
            let a = this.j5.rootWrapper.width();
            let b = this.dataChart.tp.left + this.dataChart.tp.width;
            let c = this.dataChart.tp.left;
            let d = a - b;
            this.afd.startInset = c - this.afd.trackStartInset;
            this.afd.endInset = d - this.afd.trackEndInset;
            if (this.afd.endInset < 0) {
                let e = this.afd.endInset;
                this.afd.endInset = 0;
                this.dataChart.g2 += (e * -1);
            }
            if (this.afd.startInset < 0) {
                let f = this.afd.startInset;
                this.afd.startInset = 0;
                this.dataChart.gx += (f * -1);
            }
            this.zoomSliderChart.gx = c;
            this.zoomSliderChart.g2 = d;
            this.zoomSliderChart.gk = this.afd.barExtent;
        }
        alg() {
            this.akp();
        }
        r2(a) {
            super.r2(a);
            if (a != null) {
                a.gj = 0;
            }
        }
        amb(a) {
            return a.s3();
        }
        ame() {
            return this.ahi == null ? null : this.amd(this.ahi.rootWrapper);
        }
        amc(a) {
            if (a == null || a.d == null) {
                return null;
            }
            return this.amd(a.d.rootWrapper);
        }
        amd(a) {
            if (a == null) {
                return null;
            }
            let b = a.getOffset();
            return new Rect(0, b.left, b.top, a.width(), a.height());
        }
        agy() {
            if (this.ahm == null) {
                return NaN;
            }
            let a = this.ahm.getOffset();
            return this.ahm.width() + (a == null ? 0 : a.left);
        }
        sd(source_, a, b) {
            super.sd(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mh(source_, a, b);
            }
        }
        se(source_, a, b) {
            super.se(source_, a, b);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mi(source_, a, b);
            }
        }
        sc(source_) {
            super.sc(source_);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.ma(source_);
            }
        }
        sg(source_, a, b, c) {
            super.sg(source_, a, b, c);
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.mj(source_, a, b, c);
            }
        }
        r8(a, b) {
            super.r8(a, b);
            if (this.afs(a)) {
                a.toolTip = null;
            }
        }
        get adv() {
            return this.adu;
        }
        set adv(a) {
            let b = this.adv;
            if (a != b) {
                this.adu = a;
                this.sr("Toolbar", b, this.adv);
            }
        }
        get aib() {
            return this.ah4;
        }
        set aib(a) {
            let b = this.aib;
            if (a != b) {
                this.ah4 = a;
                this.sr("RangeSelectorTemplate", b, this.aib);
            }
        }
        get aic() {
            return this.ah5;
        }
        set aic(a) {
            let b = this.aic;
            if (a != b) {
                this.ah5 = a;
                this.sr("ToolbarTemplate", b, this.aic);
            }
        }
        get ah8() {
            return this.ah1;
        }
        set ah8(a) {
            let b = this.ah8;
            if (a != b) {
                this.ah1 = a;
                this.sr("ChartTypePickerTemplate", b, this.ah8);
            }
        }
        get aid() {
            return this.ah6;
        }
        set aid(a) {
            let b = this.aid;
            if (a != b) {
                this.ah6 = a;
                this.sr("TrendLineTypePickerTemplate", b, this.aid);
            }
        }
        get aie() {
            return this.ah7;
        }
        set aie(a) {
            let b = this.aie;
            if (a != b) {
                this.ah7 = a;
                this.sr("VolumeTypePickerTemplate", b, this.aie);
            }
        }
        get ah9() {
            return this.ah2;
        }
        set ah9(a) {
            let b = this.ah9;
            if (a != b) {
                this.ah2 = a;
                this.sr("IndicatorMenuTemplate", b, this.ah9);
            }
        }
        get aia() {
            return this.ah3;
        }
        set aia(a) {
            let b = this.aia;
            if (a != b) {
                this.ah3 = a;
                this.sr("OverlayPickerTemplate", b, this.aia);
            }
        }
        get afd() {
            return this.afc;
        }
        set afd(a) {
            let b = this.afd;
            if (a != b) {
                this.afc = a;
                this.sr("ZoomSlider", b, this.afd);
            }
        }
        get_ij() {
            return super.get_ij();
        }
        set_ij(a) {
            super.set_ij(a);
        }
        get_fz() {
            return super.get_fz();
        }
        set_fz(a) {
            super.set_fz(a);
        }
        get ag3() {
            return this.agm;
        }
        set ag3(a) {
            let b = this.ag3;
            if (a != b) {
                this.agm = a;
                this.sr("ToolbarHeight", b, this.ag3);
            }
        }
        constructor() {
            super();
            this.aeo = null;
            this.ahm = null;
            this.ahk = null;
            this.ahh = null;
            this.ahj = null;
            this.ahl = null;
            this.ahi = null;
            this.adu = null;
            this.ah4 = null;
            this.ah5 = null;
            this.ah1 = null;
            this.ah6 = null;
            this.ah7 = null;
            this.ah2 = null;
            this.ah3 = null;
            this.afc = null;
            this.agm = 40;
            this.aei = null;
            this.aeg = null;
            this.aek = null;
            this.aep = null;
            this.aif = null;
            this.ae8 = null;
            this.afy = false;
            this.afx = false;
            this.af5 = false;
            this.afk = false;
            this.ahs = 10;
            this.agt = NaN;
            this.agv = NaN;
            this.agu = NaN;
            this.agw = 0;
            this.ad0 = 0;
            this.ad3 = 0;
            this.ago = 3;
            this.agr = NaN;
            this.agp = NaN;
            this.agq = NaN;
            this.ags = NaN;
            this.ad5 = 0;
            this.aff = true;
            this.adw = 0;
            this.afg = false;
            this.aea = null;
            this.aec = null;
            this.af7 = null;
            this.afi = true;
            this.afh = false;
            this.afj = false;
            this.ae9 = null;
            this.ad7 = 1;
            this.acy = null;
            this.acz = null;
            this.ac0 = null;
            this.ac1 = null;
            this.ac3 = null;
            this.ac2 = null;
            this.acx = null;
            this.acw = null;
            this.agn = 1;
            this.agl = 1;
            this.agk = 2;
            this.agj = 1;
            this.aem = null;
            this.aho = -2147483648;
            this.agi = 2;
            this.ahr = 3;
            this.ahp = 10;
            this.ahn = 30;
            this.ahq = 9;
            this.adr = null;
            this.ads = null;
            this.adn = null;
            this.applyCustomIndicators = null;
            this.al9 = null;
            this.agx = 1;
            this.afe = false;
            this.aee = null;
            this.agf = dateMinValue();
            this.age = dateMaxValue();
            this.agc = null;
            this.rn();
            this.agc = new ObservableCollection$1(Base.$, 0);
            if (this.xAxisBreaks != null) {
                let a = this.xAxisBreaks;
                a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.aly());
            }
            this.alj();
        }
        vz() {
            return this.xAxis;
        }
        v0() {
            return this.yAxis;
        }
        onAttachedToUI() {
            super.onAttachedToUI();
            if (this.afd != null) {
                this.afd.onAttachedToUI();
            }
        }
        onDetachedFromUI() {
            super.onDetachedFromUI();
            if (this.afd != null) {
                this.afd.onDetachedFromUI();
            }
        }
        bc(a) {
            return 20;
        }
        get_go() {
            return ((() => {
                let $ret = new List$1(DataSeriesType_$type, 0);
                $ret.add(20);
                return $ret;
            })());
        }
        get go() {
            return this.get_go();
        }
        get_gn() {
            return ((() => {
                let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
                $ret.add(new SimpleFinancialPriceSeriesRule());
                $ret.add(new SubCollectionsRule());
                return $ret;
            })());
        }
        get gn() {
            return this.get_gn();
        }
        adh(a) {
            return this.adi(a);
        }
        aev(a) {
            return this.aew(a);
        }
        adg(a) {
            let b = this.adh(0);
            b.name = a;
            return b;
        }
        rj() {
            this.xAxis = this.adg("xAxis");
            this.yAxis = this.aev(0);
            this.yAxis.name = "yAxis";
            this.volumeAxis = this.aev(0);
            this.volumeAxis.name = "volumeAxis";
            this.volumeXAxis = this.adg("volumeXAxis");
            this.af9 = new List$1(NumericYAxis.$, 0);
            this.agb = new List$1(CategoryAxisBase.$, 0);
            this.indicatorAxis = this.aev(0);
            this.indicatorAxis.name = "indicatorAxis";
            this.indicatorXAxis = this.adg("indicatorXAxis_0");
            this.af9.add(this.indicatorAxis);
            this.agb.add(this.indicatorXAxis);
            if (this.xAxis.ay == null) {
                this.xAxis.ay = new AxisLabelSettings();
            }
            if (this.yAxis.ay == null) {
                this.yAxis.ay = new AxisLabelSettings();
            }
            if (this.volumeAxis.ay == null) {
                this.volumeAxis.ay = new AxisLabelSettings();
            }
            if (this.volumeXAxis.ay == null) {
                this.volumeAxis.ay = new AxisLabelSettings();
            }
            if (this.indicatorAxis.ay == null) {
                this.indicatorAxis.ay = new AxisLabelSettings();
            }
            if (this.indicatorXAxis.ay == null) {
                this.indicatorXAxis.ay = new AxisLabelSettings();
            }
            this.zoomSliderAxis = this.aev(0);
            this.zoomSliderAxis.name = "zoomSliderAxis";
            this.zoomSliderXAxis = this.adg("zoomSliderXAxis");
            if (this.zoomSliderAxis.ay == null) {
                this.zoomSliderAxis.ay = new AxisLabelSettings();
            }
            if (this.zoomSliderXAxis.ay == null) {
                this.zoomSliderXAxis.ay = new AxisLabelSettings();
            }
        }
        rf(a, b) {
            let c = typeCast(MarkerSeries.$, a);
            if (c != null) {
                c.ql = this.cr(a, b);
            }
        }
        cq(a) {
            if (a != null) {
                return 1;
            }
            return super.cq(a);
        }
        tb(a) {
            if (a.suggestedSecondaryAxis == 2) {
                this.yAxis.lh = true;
                this.yAxis.l8 = 10;
            }
        }
        te() {
            this.yAxis.lh = this.af2;
            this.yAxis.l8 = this.ah0;
        }
        adz(a) {
            let b;
            if (this.adx == 0) {
                if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                    b = 4;
                }
                else {
                    b = 2;
                }
            }
            else {
                b = this.adx;
            }
            b = this.ady(b);
            return b;
        }
        ady(a) {
            if ((a == 1 || a == 2)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ad8(a) {
            if ((a == 2 || a == 3)) {
                if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                    return a;
                }
                a = 5;
            }
            if (a == 5) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 6;
            }
            if (a == 6) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 4;
            }
            if (a == 4) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ad1(a) {
            if (a == 2) {
                if (TypeRegistrar.isRegistered("LineSeries")) {
                    return a;
                }
                a = 3;
            }
            if (a == 3) {
                if (TypeRegistrar.isRegistered("AreaSeries")) {
                    return a;
                }
                a = 1;
            }
            if (a == 1) {
                if (TypeRegistrar.isRegistered("ColumnSeries")) {
                    return a;
                }
            }
            return a;
        }
        ain(a) {
            let b = a.getMemberPathFor(14);
            if (stringIsNullOrEmpty(b)) {
                b = a.getMemberPathFor(11);
            }
            return b;
        }
        adi(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createXAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("TimeXAxis")) {
                            a = TypeRegistrar.create("TimeXAxis");
                        }
                        else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                            a = TypeRegistrar.create("OrdinalTimeXAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        aew(axisType_) {
            if ((this.externalObject)) {
                return (this.externalObject.createYAxis(axisType_).i);
            }
            else {
                let a;
                switch (axisType_) {
                    case 0:
                        if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                    case 1:
                        if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                            a = TypeRegistrar.create("PercentChangeYAxis");
                        }
                        else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                            a = TypeRegistrar.create("NumericYAxis");
                        }
                        else {
                            throw new BaseError(1, "no valid axes loaded");
                        }
                        return a;
                }
                return null;
            }
        }
        ae2() {
            return this.c2(1);
        }
        ae3() {
            return this.c2(0);
        }
        ae1() {
            return this.c2(2);
        }
        ae4() {
            return this.c2(20);
        }
        get afl() {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        }
        get aej() {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        }
        get afo() {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        }
        get aeh() {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get afm() {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        }
        get ael() {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        }
        get afn() {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        }
        get aeq() {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        }
        c0(a, b) {
            let c = this.ain(a);
            switch (this.adz(a)) {
                case 3:
                    let d = this.ae2();
                    this.aej.setValueMemberPath(d, c);
                    this.aej.setXAxis(d, this.xAxis);
                    this.aej.setYAxis(d, this.yAxis);
                    this.aej.setCategoryMode(d, 1);
                    return d;
                case 4:
                    let e = this.ae3();
                    this.aej.setValueMemberPath(e, c);
                    this.aej.setXAxis(e, this.xAxis);
                    this.aej.setYAxis(e, this.yAxis);
                    this.aej.setCategoryMode(e, 1);
                    return e;
                default:
                case 1:
                case 2:
                    let f = this.ae4();
                    this.aeh.setOpenMemberPath(f, a.getMemberPathFor(11));
                    this.aeh.setHighMemberPath(f, a.getMemberPathFor(12));
                    this.aeh.setLowMemberPath(f, a.getMemberPathFor(13));
                    this.aeh.setCloseMemberPath(f, a.getMemberPathFor(14));
                    this.aeh.setVolumeMemberPath(f, a.getMemberPathFor(15));
                    this.aeh.setXAxis(f, this.xAxis);
                    this.aeh.setYAxis(f, this.yAxis);
                    this.aeh.setDisplayType(f, this.adx == 1 ? 1 : 0);
                    this.aeh.setCategoryMode(f, 1);
                    return f;
            }
        }
        td() {
            super.td();
            this.ale(this.xAxis);
            this.al2(false);
            if (this.ad2 != 0 && this.volumeChart != null) {
                this.all();
            }
            this.ale(this.volumeXAxis);
            this.ale(this.indicatorXAxis);
            this.alz();
            this.al1();
            if (this.ad9 != 0) {
                this.alm();
                this.ale(this.zoomSliderXAxis);
            }
        }
        abb(a, b) {
            super.abb(a, b);
            a(this.volumeXAxis);
            if (this.agb != null) {
                for (let c of fromEnum(this.agb)) {
                    a(c);
                }
            }
            let d = true;
            switch (b) {
                case "XAxisMajorStroke":
                case "XAxisMajorStrokeThickness":
                    d = false;
                    break;
            }
            if (d) {
                a(this.zoomSliderXAxis);
            }
        }
        abg(a, b) {
            super.abg(a, b);
            if (b) {
                a(this.volumeAxis);
                if (this.af9 != null) {
                    for (let c of fromEnum(this.af9)) {
                        a(c);
                    }
                }
                a(this.zoomSliderAxis);
            }
        }
        ali(a) {
            let b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
            if (b != null) {
                a(b);
            }
        }
        abe(a) {
            super.abe(a);
            this.aa5(this.volumeXAxis, a);
            this.aa5(this.indicatorXAxis, a);
            this.aa5(this.zoomSliderXAxis, a);
        }
        abj(a) {
            super.abj(a);
            this.aa5(this.volumeAxis, a);
            this.aa5(this.indicatorAxis, a);
            this.aa5(this.zoomSliderAxis, a);
        }
        abh(a) {
            super.abh(a);
            this.aa4(this.volumeAxis, a);
            this.aa4(this.indicatorAxis, a);
            this.aa4(this.zoomSliderAxis, a);
        }
        abc(a) {
            super.abc(a);
            this.aa4(this.volumeXAxis, a);
            this.aa4(this.indicatorXAxis, a);
            this.aa4(this.zoomSliderXAxis, a);
        }
        r1(a) {
            super.r1(a);
            if (a == null) {
                return;
            }
            if (a == this.zoomSliderChart) {
                a.ul = a.uo = false;
                a.legend = null;
                if (this.dataChart != null) {
                    a.ag = this.dataChart.ag;
                    a.aj = this.dataChart.aj;
                }
            }
            else {
                SyncManager.d(a, ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = this.aji();
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })()));
                SyncManager.c(a);
            }
            a.ci = 2;
        }
        aji() {
            if (this.aif == null) {
                FinancialChart.ahz++;
                this.aif = FinancialChart.ahz.toString();
            }
            return this.aif;
        }
        ak0(a, b) {
            this.akm();
            this.alg();
        }
        akm() {
            if (this.yAxis.b7()) {
                return;
            }
            let a = this.yAxis.av.bd;
            if (this.ad2 != 0) {
                a = Math.max(a, this.volumeAxis.av.bd);
            }
            for (let b of fromEnum(this.af9)) {
                a = Math.max(a, b.av.bd);
            }
            this.akn(a);
        }
        akn(a) {
            if (this.yAxis.b7()) {
                return;
            }
            this.yAxis.er = this.volumeAxis.er = a;
            for (let b of fromEnum(this.af9)) {
                b.er = a;
            }
            this.zoomSliderAxis.er = this.yAxis.er;
        }
        aks(a) {
            if (this.indicatorCharts == null) {
                return;
            }
            for (let b = 0; b < this.indicatorCharts.count; b++) {
                let c = this.indicatorCharts._inner[b];
                for (let d = 0; d < c.series.count; d++) {
                    let e = c.series._inner[d];
                    if (!(this.afq(e))) {
                        continue;
                    }
                    a(c.series._inner[d], b);
                }
            }
        }
        akv(a) {
            if (this.volumeChart == null) {
                return;
            }
            for (let b = 0; b < this.volumeChart.series.count; b++) {
                let c = this.volumeChart.series._inner[b];
                if (c.dd) {
                    continue;
                }
                a(this.volumeChart.series._inner[b], b);
            }
        }
        akt(a) {
            if (this.dataChart == null) {
                return;
            }
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (!this.afs(c)) {
                    continue;
                }
                a(c, b);
            }
        }
        aku(a, b) {
            if (this.dataChart == null) {
                return;
            }
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.afs(d)) {
                    continue;
                }
                let e = this.aht(d, c);
                a(d, e);
            }
            if (b) {
                this.akw(a);
            }
        }
        akw(a) {
            if (this.zoomSliderChart == null) {
                return;
            }
            for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
                let c = this.zoomSliderChart.series._inner[b];
                if (c.dd) {
                    continue;
                }
                a(this.zoomSliderChart.series._inner[b], b);
            }
        }
        aht(a, b) {
            if (a.cc != this.dataChart) {
                return b;
            }
            let c = this.bd == null || this.bd.dataSeries == null ? 0 : this.bd.dataSeries.count;
            let d = this.aed == null ? 0 : this.aed.count;
            return b - (c * d);
        }
        rr(a) {
            super.rr(a);
            this.akv(a);
            this.aks(a);
            this.akw(a);
        }
        get volumeChart() {
            return this.ae8;
        }
        set volumeChart(a) {
            let b = this.volumeChart;
            if (a != b) {
                this.ae8 = a;
                this.sr("VolumeChart", b, this.volumeChart);
            }
        }
        all() {
            if (this.dataChart == null) {
                return;
            }
            this.volumeChart.series.clear();
            let a = new List$1(Series.$, 0);
            let b = -1;
            for (let c = 0; c < this.dataChart.series.count; c++) {
                let d = this.dataChart.series._inner[c];
                if (this.afs(d) || d.dd) {
                    continue;
                }
                b++;
                let e;
                let f = this.ad2;
                f = this.ad1(f);
                switch (f) {
                    case 2:
                        e = this.ae3();
                        break;
                    case 3:
                        e = this.ae1();
                        break;
                    default:
                    case 1:
                        e = this.ae2();
                        break;
                }
                this.aej.setCategoryMode(e, 1);
                e.name = "volumeSeries_" + b;
                e.itemsSource = d.itemsSource;
                this.aej.setXAxis(e, this.volumeXAxis);
                this.aej.setYAxis(e, this.volumeAxis);
                this.aej.setValueMemberPath(e, this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > b ? this.bd.dataSeries._inner[b].getMemberPathFor(15) : null);
                e.title = d.title + " Volume";
                e.o9 = ArrayExtension.getModulus$1(Brush.$, this.ada, b);
                e.pe = ArrayExtension.getModulus$1(Brush.$, this.adb, b);
                e.g4 = this.ag4;
                a.add(e);
            }
            let g = this.gk("volume", false);
            if (g != null) {
                a.o(g);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.volumeChart.series.add(i);
                this.r6(i, h);
            }
        }
        afp(a) {
            if (!this.afl) {
                return false;
            }
            return this.aej.matchesType(a);
        }
        aft(a) {
            if (!this.afo) {
                return false;
            }
            return this.aeh.matchesType(a);
        }
        afq(a) {
            if (!this.afm) {
                return false;
            }
            return this.ael.matchesType(a);
        }
        afs(a) {
            if (!this.afn) {
                return false;
            }
            return this.aeq.matchesType(a);
        }
        alk() {
            if (this.dataChart == null) {
                return;
            }
            let a = 0;
            let b = this.aeb == null ? 0 : this.aeb.count;
            let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let d = b + c;
            for (let e = 0; e < d; e++) {
                let f = new List$1(Series.$, 0);
                let g = this.indicatorCharts._inner[e];
                let h = e >= b;
                let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.aeb._inner[e]);
                let j = -1;
                for (let k = 0; k < this.dataChart.series.count; k++) {
                    let l = this.dataChart.series._inner[k];
                    if (this.afs(l) || l.dd) {
                        continue;
                    }
                    j++;
                    let m;
                    if (h) {
                        let n = this.ae5("Custom");
                        this.ael.handleCustomIndicatorEvent(n, runOn(this, this.aky));
                        m = n;
                    }
                    else {
                        m = this.ae7(this.aeb._inner[e]);
                    }
                    if (m == null) {
                        continue;
                    }
                    m.name = "indicator_" + a++;
                    this.ael.setXAxis(m, this.agb._inner[e]);
                    this.ael.setYAxis(m, this.af9._inner[e]);
                    m.itemsSource = l.itemsSource;
                    this.ael.setOpenMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(11));
                    this.ael.setHighMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(12));
                    this.ael.setLowMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(13));
                    this.ael.setCloseMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(14));
                    this.ael.setVolumeMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(15));
                    m.title = l.title + " " + i;
                    m.o9 = ArrayExtension.getModulus$1(Brush.$, this.ac4, e);
                    m.g4 = this.ag0;
                    if (this.afq(m)) {
                        this.ael.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ac5, e));
                        this.ael.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aen, e));
                    }
                    if (this.ahv != -2147483648 && this.afq(m)) {
                        this.ael.setPeriodOverride(m, this.ahv);
                    }
                    if (this.afq(m)) {
                        this.ael.setSmoothingPeriod(m, this.ahy);
                    }
                    if (this.afq(m)) {
                        this.ael.setSignalPeriod(m, this.ahx);
                    }
                    if (this.afq(m)) {
                        this.ael.setShortPeriod(m, this.ahw);
                        this.ael.setLongPeriod(m, this.ahu);
                    }
                    this.r6(m, e);
                    f.add(m);
                }
                let o = this.gk(i, false);
                for (let p = 0; p < f.count; p++) {
                    let q = f._inner[p];
                    g.series.add(q);
                }
                if (o != null) {
                    for (let r = 0; r < o.count; r++) {
                        let s = o._inner[r];
                        g.series.add(s);
                        this.r6(s, r);
                    }
                }
            }
        }
        ae5(indicatorName_) {
            return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
        }
        ae7(a) {
            return this.ae5(EnumUtil.getName(FinancialIndicatorType_$type, a));
        }
        al2(a) {
            if (this.adv == null) {
                return;
            }
            let b = this.xAxis;
            if (b.actualMinimumValue > b.actualMaximumValue) {
                return;
            }
            this.adv.as = b.actualMinimumValue;
            this.adv.ar = b.actualMaximumValue;
            if (a) {
                this.adv.au = b.visibleMinimum;
                this.adv.at = b.visibleMaximum;
            }
            this.adv.bn();
        }
        j6() {
            let a = ((() => {
                let $ret = new FinancialChartVisualData();
                $ret.mainChart = super.j6();
                $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.vx();
                $ret.toolbar = this.adv == null ? null : this.adv.aj();
                $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.vx();
                return $ret;
            })());
            if (this.indicatorCharts != null) {
                a.indicatorCharts = new List$1(Base.$, 0);
                for (let b of fromEnum(this.indicatorCharts)) {
                    a.indicatorCharts.add1(b.vx());
                }
            }
            if (this.dataChart != null) {
                a.mainChartLeft = this.amb(this.dataChart).x;
                a.mainChartTop = this.amb(this.dataChart).y;
            }
            if (this.volumeChart != null) {
                a.volumeChartLeft = this.amb(this.volumeChart).x;
                a.volumeChartTop = this.amb(this.volumeChart).y;
            }
            if (this.zoomSliderChart != null) {
                a.zoomChartLeft = this.amb(this.zoomSliderChart).x;
                a.zoomChartTop = this.amb(this.zoomSliderChart).y;
            }
            if (this.adv != null) {
                let c = this.amc(this.adv);
                a.toolbarLeft = c.left;
                a.toolbarTop = c.top;
                a.toolbarWidth = c.width;
                a.toolbarHeight = c.height;
            }
            if (this.indicatorCharts != null) {
                a.indicatorChartLefts = new List$1(Number_$type, 0);
                a.indicatorChartTops = new List$1(Number_$type, 0);
                for (let d of fromEnum(this.indicatorCharts)) {
                    a.indicatorChartLefts.add(this.amb(d).x);
                    a.indicatorChartTops.add(this.amb(d).y);
                }
            }
            let e = this.ame();
            a.legendLeft = e.left;
            a.legendTop = e.top;
            a.legendWidth = e.width;
            a.legendHeight = e.height;
            a.legend = this.aef == null ? null : this.aef.exportVisualData();
            return a;
        }
        aik() {
            let a = this.j6();
            a.scaleByViewport();
            return a.serialize();
        }
        ae6(overlayName_) {
            return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
        }
        al1() {
            if (this.dataChart == null) {
                return;
            }
            let a = new List$1(Series.$, 0);
            for (let b of fromEnum(this.dataChart.series)) {
                if (this.afs(b)) {
                    a.add(b);
                }
            }
            for (let c of fromEnum(a)) {
                this.dataChart.series.remove(c);
            }
            if (this.aed == null) {
                return;
            }
            let d = new List$1(Series.$, 0);
            let e = -1;
            for (let f = 0; f < this.dataChart.series.count; f++) {
                let g = this.dataChart.series._inner[f];
                if (this.afs(g) || g.dd) {
                    continue;
                }
                e++;
                for (let h = 0; h < this.aed.count; h++) {
                    let i = this.aed._inner[h];
                    let j;
                    switch (i) {
                        case 1:
                            j = this.ae6(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                        default:
                        case 0:
                            j = this.ae6(EnumUtil.getName(FinancialOverlayType_$type, i));
                            break;
                    }
                    j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                    this.aeq.setXAxis(j, this.xAxis);
                    this.aeq.setYAxis(j, this.yAxis);
                    j.itemsSource = g.itemsSource;
                    let k = e * this.aed.count + h;
                    j.o9 = ArrayExtension.getModulus$1(Brush.$, this.ac8, k);
                    j.pe = ArrayExtension.getModulus$1(Brush.$, this.ac9, k);
                    j.g4 = this.ag2;
                    j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                    let l = g;
                    if (l == null) {
                        continue;
                    }
                    let m = this.bd.dataSeries._inner[e];
                    this.aeq.setOpenMemberPath(j, m.getMemberPathFor(11));
                    this.aeq.setHighMemberPath(j, m.getMemberPathFor(12));
                    this.aeq.setLowMemberPath(j, m.getMemberPathFor(13));
                    this.aeq.setCloseMemberPath(j, m.getMemberPathFor(14));
                    this.aeq.setVolumeMemberPath(j, m.getMemberPathFor(15));
                    d.add(j);
                }
            }
            let n = new Array(this.dataChart.series.count);
            this.dataChart.series.copyTo(n, 0);
            this.dataChart.skipDataCleanup = true;
            this.dataChart.series.clear();
            this.dataChart.skipDataCleanup = false;
            for (let o = 0; o < n.length; o++) {
                n[o].index = -1;
            }
            d.o(n);
            for (let p = 0; p < d.count; p++) {
                let q = d._inner[p];
                this.dataChart.series.add(q);
                this.r6(q, p);
            }
        }
        alz() {
            if (this.afy) {
                return;
            }
            this.afy = true;
            if (this.indicatorCharts != null) {
                let a = this.indicatorCharts;
                this.indicatorCharts = null;
                for (let b of fromEnum(a)) {
                    this.alf(b);
                }
            }
            if ((this.aeb == null || this.aeb.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
                this.indicatorCharts = null;
                if (this.af9 != null) {
                    this.af9.clear();
                }
                if (this.agb != null) {
                    this.agb.clear();
                }
                this.alq();
                this.al0();
                this.afy = false;
                return;
            }
            if (this.indicatorCharts == null) {
                this.indicatorCharts = new List$1(XamDataChart.$, 0);
            }
            this.indicatorCharts.clear();
            this.af9.clear();
            this.agb.clear();
            let c = this.aeb == null ? 0 : this.aeb.count;
            let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
            let e = c + d;
            for (let f = 0; f < e; f++) {
                let g = new XamDataChart();
                this.indicatorCharts.add(g);
                this.ald(g);
                let h = f >= c;
                if (h) {
                    g.kh = this.customIndicatorNames._inner[f - c];
                }
                else {
                    g.kh = this.aim(this.aeb._inner[f]);
                }
                if (this.indicatorAxis != null) {
                    let i;
                    let j;
                    if (f == 0) {
                        i = this.indicatorAxis;
                        j = this.indicatorXAxis;
                    }
                    else {
                        i = new NumericYAxis();
                        if (!this.indicatorXAxis.cd) {
                            j = this.adh(0);
                        }
                        else {
                            j = this.adh(1);
                        }
                    }
                    j.name = "indicatorXAxis_" + f;
                    i.name = "indicatorAxis_" + f;
                    g.axes.add(i);
                    g.axes.add(j);
                    this.af9.add(i);
                    this.agb.add(j);
                    if (this.fg) {
                        this.aa8(i);
                    }
                    if (this.fg) {
                        this.aa6(j);
                    }
                }
            }
            this.alk();
            this.alq();
            if (this.adv != null) {
                this.adv.ae = this.aeb;
            }
            this.ako();
            this.al0();
            this.afy = false;
        }
        ry() {
            super.ry();
            this.aa6(this.xAxis);
            this.aa6(this.volumeXAxis);
            if (this.agb != null) {
                for (let a of fromEnum(this.agb)) {
                    this.aa6(a);
                }
            }
            this.aa8(this.yAxis);
            this.aa8(this.volumeAxis);
            if (this.af9 != null) {
                for (let b of fromEnum(this.af9)) {
                    this.aa8(b);
                }
            }
            this.aa6(this.zoomSliderXAxis);
            this.aa8(this.zoomSliderAxis);
        }
        get_f5() {
            return !this.afw;
        }
        get af4() {
            return (this.externalObject._dynamicContent);
        }
        al7(a, b) {
            this.alt(a, b);
            this.ako();
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
            }
            this.alm();
            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
            this.alr();
            this.al8(a, b);
        }
        alm() {
            if (this.dataChart == null || this.zoomSliderChart == null) {
                return;
            }
            this.zoomSliderChart.series.clear();
            let a = new List$1(Series.$, 0);
            for (let b = 0; b < this.dataChart.series.count; b++) {
                let c = this.dataChart.series._inner[b];
                if (this.afs(c) || c.dd) {
                    continue;
                }
                let d;
                let e = this.ad9;
                e = this.ad8(e);
                let f = this.aht(c, b);
                if (e == 1) {
                    switch (this.adz(this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null)) {
                        case 1:
                            e = 2;
                            break;
                        case 2:
                            e = 3;
                            break;
                        case 3:
                            e = 4;
                            break;
                        case 4:
                            e = 5;
                            break;
                    }
                }
                switch (e) {
                    case 2:
                        d = this.ae4();
                        this.aeh.setDisplayType(d, 1);
                        break;
                    case 3:
                        d = this.ae4();
                        this.aeh.setDisplayType(d, 0);
                        break;
                    case 5:
                        d = this.ae3();
                        break;
                    case 6:
                        d = this.ae1();
                        break;
                    default:
                    case 4:
                        d = this.ae2();
                        break;
                }
                let g = this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null;
                if (d.dj && !d.ds) {
                    this.aej.setCategoryMode(d, 1);
                    this.aej.setXAxis(d, this.zoomSliderXAxis);
                    this.aej.setYAxis(d, this.zoomSliderAxis);
                    this.aej.setValueMemberPath(d, g == null ? null : this.ain(g));
                }
                else if (d.ds) {
                    this.aeh.setCategoryMode(d, 1);
                    this.aeh.setXAxis(d, this.zoomSliderXAxis);
                    this.aeh.setYAxis(d, this.zoomSliderAxis);
                    if (g != null) {
                        this.aeh.setOpenMemberPath(d, g.getMemberPathFor(11));
                        this.aeh.setHighMemberPath(d, g.getMemberPathFor(12));
                        this.aeh.setLowMemberPath(d, g.getMemberPathFor(13));
                        this.aeh.setCloseMemberPath(d, g.getMemberPathFor(14));
                        this.aeh.setVolumeMemberPath(d, g.getMemberPathFor(15));
                    }
                }
                d.name = "zoomSliderSeries_" + f;
                d.itemsSource = c.itemsSource;
                d.title = c.title;
                d.g4 = this.iy;
                a.add(d);
            }
            for (let h = 0; h < a.count; h++) {
                let i = a._inner[h];
                this.zoomSliderChart.series.add(i);
                this.r6(i, h);
            }
        }
        sl(a, b, c) {
            super.sl(a, b, c);
            if (a == null || !b) {
                return;
            }
            let d = true;
            let e = true;
            switch (c) {
                case "Brushes":
                case "Outlines":
                    d = e = false;
                    break;
            }
            if (this.indicatorCharts != null && d) {
                for (let f of fromEnum(this.indicatorCharts)) {
                    a(f);
                }
            }
            if (this.volumeChart != null && e) {
                a(this.volumeChart);
            }
            if (this.zoomSliderChart != null) {
                a(this.zoomSliderChart);
            }
        }
        aky(a, b) {
            let c = b;
            let d = a;
            let e = -1;
            if (this.indicatorCharts != null) {
                e = this.indicatorCharts.indexOf(d.cc);
            }
            e -= this.aeb == null ? 0 : this.aeb.count;
            if (this.applyCustomIndicators != null) {
                this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
            }
        }
        alv(a, b, c) {
            if (a != null) {
                if (b != null) {
                    a.axes.remove(b);
                }
                a.axes.add(c);
            }
            if (this.fg) {
                this.aa6(c);
            }
        }
        get af3() {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        }
        akz(a, b) {
            this.alz();
        }
        afu(a, b) {
            if (b <= (0)) {
                return false;
            }
            switch (a) {
                case 5: return true;
                case 4:
                case 3: return b >= timeSpanFromDays(365);
                case 2: return b >= timeSpanFromDays(180);
                case 1: return b >= timeSpanFromDays(90);
                case 0: return b >= timeSpanFromDays(30);
            }
            return false;
        }
        alp() {
            let a = this.adt != null ? this.adt : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
            let b = new FinancialChartRangeSelectorOptionCollection(0);
            let c = this.xAxis;
            let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
            for (let e of fromEnum(a)) {
                if (this.afu(e, d)) {
                    b.add(e);
                }
            }
            this.ads = b;
            if (this.adv != null) {
                this.adv.u = this.ads;
            }
        }
        ak3(a, b) {
            this.alp();
        }
        ak8(a, b) {
            this.aed = this.adv.ag;
        }
        ak7(a, b) {
            this.aeb = this.adv.ae;
        }
        ak1(a, b) {
            this.alz();
        }
        ak2(a, b) {
            this.al1();
        }
        alc(a, b) {
            let c = a;
            if (c.bf == null) {
                return;
            }
            if (this.afw) {
                this.alo(c.bf);
            }
        }
        alf(a) {
            SyncManager.e(a);
            a.axes.clear();
            a.series.clear();
            a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ak0));
            a.provideContainer(null);
            if (this.volumeChart == null && this.indicatorCharts == null) {
                this.yAxis.er = this.volumeAxis.er = this.indicatorAxis.er = 0;
                this.xAxis.ay.visibility = this.acu;
            }
        }
        ald(a) {
            let b = a != this.zoomSliderChart;
            if (b) {
                if (this.dataChart != null) {
                    a.tq = new Rect(0, this.dataChart.ta.x, a.tq.y, this.dataChart.ta.width, a.tq.height);
                }
                let c = ((() => {
                    let $ret = new SyncSettings();
                    $ret.syncChannel = "one";
                    $ret.synchronizeHorizontally = true;
                    $ret.synchronizeVertically = false;
                    return $ret;
                })());
                SyncManager.d(a, c);
                SyncManager.c(a);
            }
            a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ak0));
            this.r0(a);
        }
        ako() {
            if (this.indicatorCharts != null || this.volumeChart != null) {
                this.aa4(this.xAxis, (a) => a.visibility = 1);
            }
            for (let a = 0; a < this.agb.count; a++) {
                let b = this.agb._inner[a];
                let c = a < this.agb.count - 1 || this.volumeChart != null;
                this.aa4(b, (d) => d.visibility = c ? 1 : 0);
            }
        }
        alt(a, b) {
            if (a != null) {
                this.alf(a);
            }
            if (b != null) {
                this.ald(b);
            }
        }
        al5(a, b) {
            this.alt(a, b);
            this.ako();
            if (this.volumeChart != null) {
                if (this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.volumeChart.axes.add(this.volumeXAxis);
                }
                this.all();
                this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
            }
            this.al6(a, b);
        }
        ak4(a, b) {
            this.al3();
        }
        al3() {
            if (this.adv == null || +(this.adv.au) == +(dateMaxValue()) || +(this.adv.at) == +(dateMinValue()) || this.dataChart == null) {
                return;
            }
            let a = this.xAxis;
            let b = a.getWindowRectForSelection(this.adv.au, this.adv.at);
            if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
                return;
            }
            this.afx = true;
            this.dataChart.tq = new Rect(0, b.left, this.dataChart.tq.top, b.width, this.dataChart.tq.height);
            if (this.afd != null) {
                this.afd.windowRect = this.dataChart.ta;
            }
            if (this.afw) {
                this.alo(this.dataChart);
            }
            this.afx = false;
        }
        alb(a, b) {
            this.alp();
            this.al2(!this.afx);
        }
        akx(a, b) {
            if (!this.afx) {
                if (this.afw) {
                    this.alo(a);
                }
                let c = false;
                let d = this.sy(() => this.al2(true), c);
                c = d.p1;
                if (this.afd != null) {
                    this.afd.windowRect = this.dataChart.ta;
                }
            }
        }
        alx(a, b, c, d) {
            if (a == null || b == null) {
                return;
            }
            if (c != -1) {
                this.afx = true;
                a.tq = new Rect(0, d, a.ta.top, c, a.ta.height);
                this.afx = false;
            }
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(0, g, g, this.yAxis.cg, a.te);
            for (let i of fromEnum(a.series)) {
                h.b = i.gg();
                let j = i.ar(a.ta);
                let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                let l = b.ei(j.c, h);
                let m = b.ei(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
            let n = a.ta.width;
            if (c != -1) {
                n = c;
            }
            let o = a.ta.left;
            if (d != -1) {
                o = d;
            }
            if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
                return;
            }
            this.afx = true;
            let p = new Rect(0, o, e, n, f - e);
            a.tq = p;
            this.afx = false;
        }
        alw(a) {
            if (a == null) {
                return;
            }
            if (a == this.dataChart) {
                this.alx(this.dataChart, this.yAxis, -1, -1);
                if (this.volumeChart != null) {
                    this.alx(this.volumeChart, this.volumeAxis, this.dataChart.ta.width, this.dataChart.ta.left);
                }
            }
            else if (a == this.volumeChart) {
                this.alx(this.volumeChart, this.volumeAxis, -1, -1);
                this.alx(this.dataChart, this.yAxis, this.volumeChart.ta.width, this.volumeChart.ta.left);
            }
        }
        alo(a) {
            this.sx(() => this.alw(a));
        }
        ak5(a, b) {
            if (this.afw) {
                this.alo(a);
            }
        }
        al4() {
            if (!this.af4) {
                return;
            }
            this.akr();
            if (this.ad9 == 0) {
                this.zoomSliderChart = null;
            }
            else if (this.zoomSliderChart == null) {
                this.zoomSliderChart = ((() => {
                    let $ret = new XamDataChart();
                    $ret.name = "ZoomSliderChart";
                    return $ret;
                })());
            }
            else {
                this.alm();
            }
        }
        akr() {
            let container_ = this.ahl.rootWrapper.getNativeElement();
            let containerParent_ = container_.parentElement;
            if (this.afd != null && containerParent_ != null && !this.af5) {
                this.af5 = true;
                if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                    let z_ = this.afd;
                    let f_ = this.externalObject;
                    let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                    let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                    sliderInstance_._implementation = z_;
                    sliderComponent_._staticStyling(container_, sliderInstance_, f_);
                }
            }
        }
        aly() {
            if (this.ad4 != 1) {
                return;
            }
            this.aba((a) => {
                let b;
                b = a.breaks;
                b.clear();
                if (this.xAxisBreaks == null) {
                    return;
                }
                for (let c of fromEnum(this.xAxisBreaks)) {
                    b.add(c);
                }
            });
        }
        tj(a, b, c) {
            super.tj(a, b, c);
            if (this.bd.dataSeries.count > 0) {
                if (this.ad4 == 1 && stringIsNullOrEmpty(this.li)) {
                    this.b3.setXMemberPath(a, c.getMemberPathFor(17));
                }
                if (stringIsNullOrEmpty(this.lk)) {
                    this.b3.setYMemberPath(a, this.ain(c));
                }
                if (stringIsNullOrEmpty(this.le)) {
                    this.b3.setLabelMemberPath(a, this.ain(c));
                }
                if (stringIsNullOrEmpty(this.lb)) {
                    this.b3.setContentMemberPath(a, this.ain(c));
                }
            }
        }
        aim(a) {
            switch (a) {
                case 0: return "Absolute Volume Oscillator";
                case 1: return "Accumulation/Distribution Indicator";
                case 2: return "Average Directional Index";
                case 3: return "Average True Range Indicator";
                case 4: return "Bollinger Bandwidth";
                case 5: return "Chaikin Oscillator";
                case 6: return "Chaikin Volatility Indicator";
                case 7: return "Commodity Channel Index";
                case 8: return "Detrended Price Oscillator";
                case 9: return "Ease of Movement Indicator";
                case 10: return "Fast Stochastic Oscillator";
                case 11: return "Force Index Indicator";
                case 12: return "Full Stochastic Oscillator";
                case 13: return "Market Facilitation Index";
                case 14: return "Mass Index Indicator";
                case 15: return "Median Price Indicator";
                case 16: return "Money Flow Index";
                case 17: return "MACD Indicator";
                case 18: return "Negative Volume Index";
                case 19: return "On Balance Volume Indicator";
                case 20: return "Percentage Price Oscillator";
                case 21: return "Percentage Volume Oscillator";
                case 22: return "Positive Volume Index";
                case 23: return "Price Volume Trend";
                case 24: return "ROC - Rate of Change Indicator";
                case 25: return "RSI - Relative Strength Index";
                case 26: return "Slow Stochastic Oscillator";
                case 27: return "Standard Deviation Indicator";
                case 28: return "Stoch RSI";
                case 29: return "TRIX Indicator";
                case 30: return "Typical Price Indicator";
                case 31: return "Ultimate Oscillator";
                case 32: return "Weighted Close Indicator";
                case 33: return "Williams %R Indicator";
                default: return "Unknown";
            }
        }
        aa6(a) {
            super.aa6(a);
            let b = a;
            this.ale(b);
            if (a.bf != null) {
                for (let c of fromEnum(a.bf.series)) {
                    if (this.afp(c)) {
                        this.aej.setXAxis(c, b);
                    }
                    else if (this.aft(c)) {
                        this.aeh.setXAxis(c, b);
                    }
                    else if (this.afq(c)) {
                        this.ael.setXAxis(c, b);
                    }
                    else if (this.afs(c)) {
                        this.aeq.setXAxis(c, b);
                    }
                }
            }
            this.ali((d) => {
                d.zoomMaximumCategoryRange = this.ag5;
                d.zoomMaximumItemSpan = this.ag6;
                d.zoomToCategoryRange = this.ag7;
                d.zoomToCategoryStart = this.ag8;
                d.zoomToItemSpan = this.ag9;
            });
            let d = a == this.zoomSliderXAxis;
            if (d) {
                a.jv = this.ama;
                a.eq = this.ahg;
                this.aa4(a, (e) => e.visibility = 1);
            }
            let e = a;
            e.minimumValue = this.agh;
            e.maximumValue = this.agg;
            a.b0 = this.afz;
        }
        aa8(a) {
            super.aa8(a);
            if (a.bf != null && a == this.yAxis) {
                for (let b of fromEnum(a.bf.series)) {
                    if (this.afp(b)) {
                        this.aej.setYAxis(b, this.yAxis);
                    }
                    else if (this.aft(b)) {
                        this.aeh.setYAxis(b, this.yAxis);
                    }
                    else if (this.afq(b)) {
                        this.ael.setYAxis(b, this.yAxis);
                    }
                    else if (this.afs(b)) {
                        this.aeq.setYAxis(b, this.yAxis);
                    }
                }
            }
            a.k9 = this.af0;
            a.l4 = this.ahe;
            a.l3 = this.ahd;
            if (a == this.yAxis) {
                a.l0 = this.ahc;
            }
            let c = a == this.zoomSliderAxis;
            if (c) {
                this.aa4(a, (d) => d.visibility = 1);
            }
            a.b0 = this.af1;
        }
        ale(a) {
            a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
            a.fz = XYChart.yt(a, this.bd.dataSeries);
            if (this.bd.dataSeries.count > 0) {
                let b = this.bd.dataSeries._inner[0].getMemberPathFor(17);
                a.hx(b);
            }
        }
        r6(a, b) {
            super.r6(a, b);
            if (a == null) {
                return;
            }
            let c = this.zoomSliderChart == a.cc;
            let d = this.dataChart != null && this.dataChart.series.contains(a);
            if ((d || c) && a.d6) {
                a.ms(this.ac6 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac6, b) : null, this.ac7 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac7, b) : null);
            }
            let e = this.afq(a);
            if (this.afs(a)) {
                a.o9 = this.ac8 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac8, b) : null;
                a.pe = this.ac9 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac9, b) : null;
                a.g4 = this.ag2;
            }
            else if (e) {
                a.o9 = this.ac4 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac4, b) : null;
                a.g4 = this.ag0;
            }
            else if (!a.dd && (d || c)) {
                a.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, b) : null;
                a.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, b) : null;
            }
            let f = this.volumeChart != null && this.volumeChart == a.cc;
            if (f) {
                a.g4 = this.ag4;
            }
            a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.afr ? this.aef : null;
        }
        sr(a, b, c) {
            super.sr(a, b, c);
            switch (a) {
                case "YAxisIsLogarithmic":
                    this.yAxis.lh = this.af2;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.lh = this.af2;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.lh = this.af2;
                    }
                    break;
                case "YAxisLogarithmBase":
                    this.yAxis.l8 = this.ah0;
                    if (this.volumeAxis != null) {
                        this.volumeAxis.l8 = this.ah0;
                    }
                    if (this.zoomSliderAxis != null) {
                        this.zoomSliderAxis.l8 = this.ah0;
                    }
                    break;
                case "VolumeType":
                    let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                    if (this.ad2 == 0) {
                        this.volumeChart = null;
                    }
                    else if (this.volumeChart == null) {
                        this.volumeChart = ((() => {
                            let $ret = new XamDataChart();
                            $ret.name = "VolumeChart";
                            return $ret;
                        })());
                    }
                    else {
                        this.all();
                    }
                    break;
                case "VolumeChart":
                    this.al5(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "DataChart":
                    if (typeCast(XamDataChart.$, b) !== null) {
                        let e = b;
                        e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ak0));
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.akx));
                        e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.ak5));
                    }
                    if (this.dataChart != null) {
                        let f = this.dataChart;
                        f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ak0));
                        let g = this.dataChart;
                        g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.akx));
                        let h = this.dataChart;
                        h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.ak5));
                    }
                    this.al4();
                    break;
                case "XAxisMode":
                    this.xAxis = this.adh(this.ad4);
                    this.xAxis.name = "xAxis";
                    this.volumeXAxis = this.adh(this.ad4);
                    this.volumeXAxis.name = "volumeXAxis";
                    this.indicatorXAxis = this.adh(this.ad4);
                    this.indicatorXAxis.name = "indicatorXAxis_0";
                    this.zoomSliderXAxis = this.adh(this.ad4);
                    this.zoomSliderXAxis.name = "zoomSliderXAxis";
                    this.aa4(this.zoomSliderXAxis, (i) => i.visibility = 1);
                    this.ako();
                    if (this.ad4 == 1) {
                        this.aly();
                    }
                    break;
                case "YAxisMode":
                    this.yAxis = this.aev(this.ad6);
                    this.yAxis.name = "yAxis";
                    this.zoomSliderAxis = this.aev(this.ad6);
                    this.zoomSliderAxis.name = "zoomSliderAxis";
                    this.volumeAxis = this.aev(this.ad6);
                    this.volumeAxis.name = "volumeAxis";
                    break;
                case "Toolbar":
                    let i = typeCast(FinancialChartToolbar.$, b);
                    if (i != null) {
                        i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.ak4));
                        i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.ak7));
                        i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.ak8));
                    }
                    if (this.adv != null) {
                        this.adv.ae = this.aeb;
                        this.adv.ag = this.aed;
                        this.adv.u = this.ads;
                        this.al2(true);
                        let j = this.adv;
                        j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.ak4));
                        let k = this.adv;
                        k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.ak7));
                        let l = this.adv;
                        l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.ak8));
                    }
                    break;
                case "XAxis":
                    let m = typeCast(CategoryAxisBase.$, b);
                    if (m != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(m);
                        }
                    }
                    let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                    if (n != null) {
                        n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.alb));
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.xAxis);
                    }
                    if (this.fg) {
                        this.aa6(this.xAxis);
                        this.ro();
                    }
                    this.al2(false);
                    this.al3();
                    this.alp();
                    let o = this.xAxis;
                    o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.alb));
                    break;
                case "XAxisZoomMaximumCategoryRange":
                    this.ali((p) => p.zoomMaximumCategoryRange = this.ag5);
                    break;
                case "XAxisZoomMaximumItemSpan":
                    this.ali((p) => p.zoomMaximumItemSpan = this.ag6);
                    break;
                case "XAxisZoomToCategoryRange":
                    this.ali((p) => p.zoomToCategoryRange = this.ag7);
                    break;
                case "XAxisZoomToCategoryStart":
                    this.ali((p) => p.zoomToCategoryStart = this.ag8);
                    break;
                case "XAxisZoomToItemSpan":
                    this.ali((p) => p.zoomToItemSpan = this.ag9);
                    break;
                case "ChartType":
                    this.td();
                    break;
                case "VolumeXAxis":
                    this.alv(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                    break;
                case "ZoomSliderXAxis":
                    this.alv(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                    break;
                case "IndicatorXAxis":
                    this.alz();
                    break;
                case "YAxis":
                    let p = typeCast(NumericYAxis.$, b);
                    if (p != null) {
                        if (this.dataChart != null) {
                            this.dataChart.axes.remove(p);
                        }
                    }
                    if (this.dataChart != null) {
                        this.dataChart.axes.add(this.yAxis);
                    }
                    if (this.fg) {
                        this.aa8(this.yAxis);
                        this.aa8(this.yAxis);
                    }
                    let q = this.yAxis;
                    q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.alc));
                    break;
                case "VolumeAxis":
                    let r = typeCast(Axis.$, b);
                    if (this.volumeChart != null && r != null) {
                        this.volumeChart.axes.remove(r);
                    }
                    if (this.volumeChart != null && this.volumeAxis != null) {
                        this.volumeChart.axes.add(this.volumeAxis);
                        this.all();
                    }
                    if (this.fg) {
                        this.aa8(this.volumeAxis);
                    }
                    let s = this.volumeAxis;
                    s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.alc));
                    break;
                case "IndicatorAxis":
                    if (this.indicatorCharts != null) {
                        for (let t = 0; t < this.indicatorCharts.count; t++) {
                            let u = this.indicatorCharts._inner[t];
                            let v = new List$1(Axis.$, 0);
                            for (let w of fromEnum(u.axes)) {
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                            for (let x of fromEnum(v)) {
                                u.axes.remove(x);
                            }
                            let y = null;
                            if (t == 0) {
                                y = this.indicatorAxis;
                            }
                            else if (this.ad6 == 1) {
                                y = this.aev(this.ad6);
                            }
                            else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                                y = new NumericYAxis();
                            }
                            if (y != null) {
                                u.axes.add(y);
                            }
                            if (this.fg) {
                                this.aa8(y);
                            }
                        }
                    }
                    break;
                case "IsWindowSyncedToVisibleRange":
                    if (this.dataChart != null) {
                        this.dataChart.uo = this.f6 && this.f5;
                    }
                    if (this.volumeChart != null) {
                        this.volumeChart.uo = this.f6 && this.f5;
                    }
                    if (this.afw) {
                        this.alw(this.dataChart);
                    }
                    else {
                        this.volumeChart.vv = 1;
                    }
                    break;
                case "IndicatorTypes":
                    let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                    if (z != null) {
                        z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ak1));
                    }
                    let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                    if (aa != null) {
                        aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ak1));
                    }
                    this.alz();
                    break;
                case "OverlayTypes":
                    let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                    if (ab != null) {
                        ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ak2));
                    }
                    let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                    if (ac != null) {
                        ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ak2));
                    }
                    this.al1();
                    break;
                case "YAxisAbbreviateLargeNumbers":
                    this.abf((ad) => ad.k9 = this.af0);
                    break;
                case "YAxisMinimumValue":
                    this.abg((ad) => ad.l4 = this.ahe, false);
                    break;
                case "YAxisMaximumValue":
                    this.abg((ad) => ad.l3 = this.ahd, false);
                    break;
                case "YAxisInterval":
                    this.abg((ad) => ad.l0 = this.ahc, false);
                    break;
                case "Thickness":
                case "ZoomSliderType":
                    this.al4();
                    break;
                case "ZoomSliderChart":
                    if (!this.af3) {
                        return;
                    }
                    this.al7(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                    break;
                case "NegativeBrushes":
                case "NegativeOutlines":
                    this.aku((ad, ae) => {
                        if (ad.d6) {
                            ad.ms(this.ac6 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac6, ae) : null, this.ac7 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac7, ae) : null);
                        }
                    }, true);
                    break;
                case "OverlayBrushes":
                    this.akt((ad, ae) => ad.o9 = this.ac8 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac8, ae) : null);
                    break;
                case "OverlayOutlines":
                    this.akt((ad, ae) => ad.pe = this.ac9 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac9, ae) : null);
                    break;
                case "OverlayThickness":
                    this.akt((ad, ae) => ad.g4 = this.ag2);
                    break;
                case "OverlayMultiplier":
                    this.akt((ad, ae) => this.aeq.setMultiplier(ad, this.ag1));
                    break;
                case "VolumeBrushes":
                    this.akv((ad, ae) => ad.o9 = ArrayExtension.getModulus$1(Brush.$, this.ada, ae));
                    break;
                case "VolumeOutlines":
                    this.akv((ad, ae) => ad.pe = ArrayExtension.getModulus$1(Brush.$, this.adb, ae));
                    break;
                case "VolumeThickness":
                    this.akv((ad, ae) => ad.g4 = this.ag4);
                    break;
                case "IndicatorNegativeBrushes":
                    this.aks((ad, ae) => this.ael.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.ac5, ae)));
                    break;
                case "IndicatorBrushes":
                    this.aks((ad, ae) => ad.o9 = ArrayExtension.getModulus$1(Brush.$, this.ac4, ae));
                    break;
                case "IndicatorThickness":
                    this.aks((ad, ae) => ad.g4 = this.ag0);
                    break;
                case "IndicatorDisplayTypes":
                    this.aks((ad, ae) => this.ael.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aen, ae)));
                    break;
                case "IndicatorPeriod":
                    this.aks((ad, ae) => {
                        if (this.ahv == -2147483648) {
                            return;
                        }
                        this.ael.setPeriodOverride(ad, this.ahv);
                    });
                    break;
                case "IndicatorMultiplier":
                    this.aks((ad, ae) => this.ael.setMultiplier(ad, this.agz));
                    break;
                case "IndicatorSmoothingPeriod":
                    this.aks((ad, ae) => this.ael.setSmoothingPeriod(ad, this.ahy));
                    break;
                case "IndicatorShortPeriod":
                    this.aks((ad, ae) => this.ael.setShortPeriod(ad, this.ahw));
                    break;
                case "IndicatorLongPeriod":
                    this.aks((ad, ae) => this.ael.setLongPeriod(ad, this.ahu));
                    break;
                case "IndicatorSignalPeriod":
                    this.aks((ad, ae) => this.ael.setSignalPeriod(ad, this.ahx));
                    break;
                case "RangeSelectorOptions":
                    let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                    if (ad != null) {
                        ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ak3));
                    }
                    if (this.adt != null) {
                        let ae = this.adt;
                        ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ak3));
                    }
                    this.alp();
                    break;
                case "CustomIndicatorNames":
                    let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                    if (af != null) {
                        af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.akz));
                    }
                    if (this.customIndicatorNames != null) {
                        let ag = this.customIndicatorNames;
                        ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.akz));
                    }
                    this.alz();
                    break;
                case "Legend":
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.legend = null;
                    }
                    break;
                case "Brushes":
                    this.aku((ah, ai) => ah.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, ai) : null, true);
                    break;
                case "Outlines":
                    this.aku((ah, ai) => ah.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, ai) : null, true);
                    break;
                case "XAxisLabelVisibility":
                    if (this.acu == 0 && this.zoomSliderXAxis != null) {
                        this.aa4(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                    }
                    this.ako();
                    break;
                case "YAxisLabelVisibility":
                    if (this.acv != 0 || this.zoomSliderAxis == null) {
                        break;
                    }
                    this.aa4(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                    break;
                case "ZoomSliderXAxisMajorStroke":
                    this.zoomSliderXAxis.jv = this.ama;
                    break;
                case "ZoomSliderXAxisMajorStrokeThickness":
                    this.zoomSliderXAxis.eq = this.ahg;
                    break;
                case "FinancialChartLegend":
                case "IsLegendVisible":
                    let ah = this.afr && this.legend == null;
                    {
                        let ai = (aj, ak) => {
                            if (aj.isUsableInLegend) {
                                aj.legend = ah ? this.aef : null;
                            }
                        };
                        this.aku(ai, false);
                        this.akt(ai);
                    }
                    break;
                case "ZoomSliderAxis":
                    let aj = typeCast(Axis.$, b);
                    if (aj != null && this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.remove(aj);
                    }
                    if (this.zoomSliderAxis != null) {
                        if (this.zoomSliderChart != null) {
                            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                            this.alm();
                            this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                        }
                        if (this.fg) {
                            this.aa8(this.zoomSliderAxis);
                        }
                        this.aa4(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                    }
                    break;
                case "XAxisMinimumValue":
                    this.aba((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.minimumValue = this.agh;
                        }
                    });
                    break;
                case "XAxisMaximumValue":
                    this.aba((ak) => {
                        let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                        if (al != null) {
                            al.maximumValue = this.agg;
                        }
                    });
                    break;
                case FinancialChart.ajv:
                    this.abb((ak) => ak.b0 = this.afz, a);
                    break;
                case FinancialChart.aj6:
                    this.abf((ak) => ak.b0 = this.af1);
                    break;
            }
        }
        get_b1() {
            return 1;
        }
        get b1() {
            return this.get_b1();
        }
        get af2() {
            return this.afk;
        }
        set af2(a) {
            let b = this.af2;
            if (a != b) {
                this.afk = a;
                this.sr("YAxisIsLogarithmic", b, this.af2);
            }
        }
        get ah0() {
            return this.ahs;
        }
        set ah0(a) {
            let b = this.ah0;
            if (a != b) {
                this.ahs = a;
                this.sr("YAxisLogarithmBase", b, this.ah0);
            }
        }
        get ahc() {
            return this.agt;
        }
        set ahc(a) {
            let b = this.ahc;
            if (a != b) {
                this.agt = a;
                this.sr("YAxisInterval", b, this.ahc);
            }
        }
        get ahe() {
            return this.agv;
        }
        set ahe(a) {
            let b = this.ahe;
            if (a != b) {
                this.agv = a;
                this.sr("YAxisMinimumValue", b, this.ahe);
            }
        }
        get ahd() {
            return this.agu;
        }
        set ahd(a) {
            let b = this.ahd;
            if (a != b) {
                this.agu = a;
                this.sr("YAxisMaximumValue", b, this.ahd);
            }
        }
        get ahf() {
            return this.agw;
        }
        set ahf(a) {
            let b = this.ahf;
            if (a != b) {
                this.agw = a;
                this.sr("YAxisMinorInterval", b, this.ahf);
            }
        }
        get ahb() {
            return this.yAxis.lw;
        }
        get aha() {
            return this.yAxis.lv;
        }
        get ad2() {
            return this.ad0;
        }
        set ad2(a) {
            let b = this.ad2;
            if (a != b) {
                this.ad0 = a;
                this.sr("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ad2));
            }
        }
        get ad4() {
            return this.ad3;
        }
        set ad4(a) {
            let b = this.ad4;
            if (a != b) {
                this.ad3 = a;
                this.sr("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ad4));
            }
        }
        get ag5() {
            return this.ago;
        }
        set ag5(a) {
            let b = this.ag5;
            if (a != b) {
                this.ago = a;
                this.sr("XAxisZoomMaximumCategoryRange", b, this.ag5);
            }
        }
        get ag8() {
            return this.agr;
        }
        set ag8(a) {
            let b = this.ag8;
            if (a != b) {
                this.agr = a;
                this.sr("XAxisZoomToCategoryStart", b, this.ag8);
            }
        }
        get ag6() {
            return this.agp;
        }
        set ag6(a) {
            let b = this.ag6;
            if (a != b) {
                this.agp = a;
                this.sr("XAxisZoomMaximumItemSpan", b, this.ag6);
            }
        }
        get ag7() {
            return this.agq;
        }
        set ag7(a) {
            let b = this.ag7;
            if (a != b) {
                this.agq = a;
                this.sr("XAxisZoomToCategoryRange", b, this.ag7);
            }
        }
        get ag9() {
            return this.ags;
        }
        set ag9(a) {
            let b = this.ag9;
            if (a != b) {
                this.ags = a;
                this.sr("XAxisZoomToItemSpan", b, this.ag9);
            }
        }
        get ad6() {
            return this.ad5;
        }
        set ad6(a) {
            let b = this.ad6;
            if (a != b) {
                this.ad5 = a;
                this.sr("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.ad6));
            }
        }
        get afv() {
            return this.aff;
        }
        set afv(a) {
            let b = this.afv;
            if (a != b) {
                this.aff = a;
                this.sr("IsToolbarVisible", b, this.afv);
            }
        }
        get adx() {
            return this.adw;
        }
        set adx(a) {
            let b = this.adx;
            if (a != b) {
                this.adw = a;
                this.sr("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.adx));
            }
        }
        get_abp() {
            return super.get_abp();
        }
        set_abp(a) {
            super.set_abp(a);
        }
        get afw() {
            return this.afg;
        }
        set afw(a) {
            let b = this.afw;
            if (a != b) {
                this.afg = a;
                this.sr("IsWindowSyncedToVisibleRange", b, this.afw);
            }
        }
        get aeb() {
            return this.aea;
        }
        set aeb(a) {
            let b = this.aeb;
            if (a != b) {
                this.aea = a;
                this.sr("IndicatorTypes", b, this.aeb);
            }
        }
        get aed() {
            return this.aec;
        }
        set aed(a) {
            let b = this.aed;
            if (a != b) {
                this.aec = a;
                this.sr("OverlayTypes", b, this.aed);
            }
        }
        get indicatorCharts() {
            return this.af7;
        }
        set indicatorCharts(a) {
            let b = this.indicatorCharts;
            if (a != b) {
                this.af7 = a;
                this.sr("IndicatorCharts", b, this.indicatorCharts);
            }
        }
        get af0() {
            return this.afi;
        }
        set af0(a) {
            let b = this.af0;
            if (a != b) {
                this.afi = a;
                this.sr("YAxisAbbreviateLargeNumbers", b, this.af0);
            }
        }
        get_is() {
            return super.get_is();
        }
        set_is(a) {
            super.set_is(a);
        }
        get afz() {
            return this.afh;
        }
        set afz(a) {
            let b = this.afz;
            if (a != b) {
                this.afh = a;
                this.sr(FinancialChart.ajv, b, this.afz);
            }
        }
        get af1() {
            return this.afj;
        }
        set af1(a) {
            let b = this.af1;
            if (a != b) {
                this.afj = a;
                this.sr(FinancialChart.aj6, b, this.af1);
            }
        }
        get zoomSliderChart() {
            return this.ae9;
        }
        set zoomSliderChart(a) {
            let b = this.zoomSliderChart;
            if (a != b) {
                this.ae9 = a;
                this.sr("ZoomSliderChart", b, this.zoomSliderChart);
            }
        }
        get zoomSliderAxis() {
            return this.aeu;
        }
        set zoomSliderAxis(a) {
            let b = this.zoomSliderAxis;
            if (a != b) {
                this.aeu = a;
                this.sr("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        }
        get zoomSliderXAxis() {
            return this.adf;
        }
        set zoomSliderXAxis(a) {
            let b = this.zoomSliderXAxis;
            if (a != b) {
                this.adf = a;
                this.sr("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        }
        get ad9() {
            return this.ad7;
        }
        set ad9(a) {
            let b = this.ad9;
            if (a != b) {
                this.ad7 = a;
                this.sr("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.ad9));
            }
        }
        get ac6() {
            return this.acy;
        }
        set ac6(a) {
            let b = this.ac6;
            if (a != b) {
                this.acy = a;
                this.sr("NegativeBrushes", b, this.ac6);
            }
        }
        get ac7() {
            return this.acz;
        }
        set ac7(a) {
            let b = this.ac7;
            if (a != b) {
                this.acz = a;
                this.sr("NegativeOutlines", b, this.ac7);
            }
        }
        get ac8() {
            return this.ac0;
        }
        set ac8(a) {
            let b = this.ac8;
            if (a != b) {
                this.ac0 = a;
                this.sr("OverlayBrushes", b, this.ac8);
            }
        }
        get ac9() {
            return this.ac1;
        }
        set ac9(a) {
            let b = this.ac9;
            if (a != b) {
                this.ac1 = a;
                this.sr("OverlayOutlines", b, this.ac9);
            }
        }
        get adb() {
            return this.ac3;
        }
        set adb(a) {
            let b = this.adb;
            if (a != b) {
                this.ac3 = a;
                this.sr("VolumeOutlines", b, this.adb);
            }
        }
        get ada() {
            return this.ac2;
        }
        set ada(a) {
            let b = this.ada;
            if (a != b) {
                this.ac2 = a;
                this.sr("VolumeBrushes", b, this.ada);
            }
        }
        get ac5() {
            return this.acx;
        }
        set ac5(a) {
            let b = this.ac5;
            if (a != b) {
                this.acx = a;
                this.sr("IndicatorNegativeBrushes", b, this.ac5);
            }
        }
        get ac4() {
            return this.acw;
        }
        set ac4(a) {
            let b = this.ac4;
            if (a != b) {
                this.acw = a;
                this.sr("IndicatorBrushes", b, this.ac4);
            }
        }
        get ag4() {
            return this.agn;
        }
        set ag4(a) {
            let b = this.ag4;
            if (a != b) {
                this.agn = a;
                this.sr("VolumeThickness", b, this.ag4);
            }
        }
        get ag2() {
            return this.agl;
        }
        set ag2(a) {
            let b = this.ag2;
            if (a != b) {
                this.agl = a;
                this.sr("OverlayThickness", b, this.ag2);
            }
        }
        get ag1() {
            return this.agk;
        }
        set ag1(a) {
            let b = this.ag1;
            if (a != b) {
                this.agk = a;
                this.sr("OverlayMultiplier", b, this.ag1);
            }
        }
        get ag0() {
            return this.agj;
        }
        set ag0(a) {
            let b = this.ag0;
            if (a != b) {
                this.agj = a;
                this.sr("IndicatorThickness", b, this.ag0);
            }
        }
        get aen() {
            return this.aem;
        }
        set aen(a) {
            let b = this.aen;
            if (a != b) {
                this.aem = a;
                this.sr("IndicatorDisplayTypes", b, this.aen);
            }
        }
        get ahv() {
            return this.aho;
        }
        set ahv(a) {
            let b = this.ahv;
            if (a != b) {
                this.aho = a;
                this.sr("IndicatorPeriod", b, this.ahv);
            }
        }
        get agz() {
            return this.agi;
        }
        set agz(a) {
            let b = this.agz;
            if (a != b) {
                this.agi = a;
                this.sr("IndicatorMultiplier", b, this.agz);
            }
        }
        get ahy() {
            return this.ahr;
        }
        set ahy(a) {
            let b = this.ahy;
            if (a != b) {
                this.ahr = a;
                this.sr("IndicatorSmoothingPeriod", b, this.ahy);
            }
        }
        get ahw() {
            return this.ahp;
        }
        set ahw(a) {
            let b = this.ahw;
            if (a != b) {
                this.ahp = a;
                this.sr("IndicatorShortPeriod", b, this.ahw);
            }
        }
        get ahu() {
            return this.ahn;
        }
        set ahu(a) {
            let b = this.ahu;
            if (a != b) {
                this.ahn = a;
                this.sr("IndicatorLongPeriod", b, this.ahu);
            }
        }
        get ahx() {
            return this.ahq;
        }
        set ahx(a) {
            let b = this.ahx;
            if (a != b) {
                this.ahq = a;
                this.sr("IndicatorSignalPeriod", b, this.ahx);
            }
        }
        get adt() {
            return this.adr;
        }
        set adt(a) {
            let b = this.adt;
            if (a != b) {
                this.adr = a;
                this.sr("RangeSelectorOptions", b, this.adt);
            }
        }
        get customIndicatorNames() {
            return this.adn;
        }
        set customIndicatorNames(a) {
            let b = this.adn;
            if (a != b) {
                this.adn = a;
                this.sr("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        }
        get_f6() {
            return super.get_f6();
        }
        set_f6(a) {
            super.set_f6(a);
        }
        get ama() {
            return this.al9;
        }
        set ama(a) {
            let b = this.ama;
            if (a != b) {
                this.al9 = a;
                this.sr("ZoomSliderXAxisMajorStroke", b, this.ama);
            }
        }
        get ahg() {
            return this.agx;
        }
        set ahg(a) {
            let b = this.ahg;
            if (a != b) {
                this.agx = a;
                this.sr("ZoomSliderXAxisMajorStrokeThickness", b, this.ahg);
            }
        }
        get afr() {
            return this.afe;
        }
        set afr(a) {
            let b = this.afr;
            if (a != b) {
                this.afe = a;
                this.sr("IsLegendVisible", b, this.afr);
            }
        }
        get aef() {
            return this.aee;
        }
        set aef(a) {
            let b = this.aef;
            if (a != b) {
                this.aee = a;
                this.sr("FinancialChartLegend", b, this.aef);
            }
        }
        get xAxis() {
            return this.ade;
        }
        set xAxis(a) {
            let b = this.xAxis;
            if (a != b) {
                this.ade = a;
                this.sr("XAxis", b, this.xAxis);
            }
        }
        get yAxis() {
            return this.aet;
        }
        set yAxis(a) {
            let b = this.yAxis;
            if (a != b) {
                this.aet = a;
                this.sr("YAxis", b, this.yAxis);
            }
        }
        get volumeAxis() {
            return this.aes;
        }
        set volumeAxis(a) {
            let b = this.volumeAxis;
            if (a != b) {
                this.aes = a;
                this.sr("VolumeAxis", b, this.volumeAxis);
            }
        }
        get volumeXAxis() {
            return this.add;
        }
        set volumeXAxis(a) {
            let b = this.volumeXAxis;
            if (a != b) {
                this.add = a;
                this.sr("VolumeXAxis", b, this.volumeXAxis);
            }
        }
        get indicatorAxis() {
            return this.aer;
        }
        set indicatorAxis(a) {
            let b = this.indicatorAxis;
            if (a != b) {
                this.aer = a;
                this.sr("IndicatorAxis", b, this.indicatorAxis);
            }
        }
        get indicatorXAxis() {
            return this.adc;
        }
        set indicatorXAxis(a) {
            let b = this.indicatorXAxis;
            if (a != b) {
                this.adc = a;
                this.sr("IndicatorXAxis", b, this.indicatorXAxis);
            }
        }
        get af9() {
            return this.af6;
        }
        set af9(a) {
            let b = this.af9;
            if (a != b) {
                this.af6 = a;
                this.sr("IndicatorAxes", b, this.af9);
            }
        }
        get agb() {
            return this.af8;
        }
        set agb(a) {
            let b = this.agb;
            if (a != b) {
                this.af8 = a;
                this.sr("IndicatorXAxes", b, this.agb);
            }
        }
        get agh() {
            return this.agf;
        }
        set agh(a) {
            let b = this.agh;
            if (+a != +b) {
                this.agf = a;
                this.sr("XAxisMinimumValue", b, this.agh);
            }
        }
        get agg() {
            return this.age;
        }
        set agg(a) {
            let b = this.agg;
            if (+a != +b) {
                this.age = a;
                this.sr("XAxisMaximumValue", b, this.agg);
            }
        }
        get xAxisBreaks() {
            return this.agc;
        }
    }
    FinancialChart.$t = /*@__PURE__*/ markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ahz = 0;
    FinancialChart.ajv = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.aj6 = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
})();
/**
 * @hidden
 */
export let FinancialChartToolbar = /*@__PURE__*/ (() => {
    class FinancialChartToolbar extends TemplatedHtmlControl {
        bg(a) {
            let b = a.querySelectorAll(".financialChartToolbarArea");
            if (b != null && b.length > 0) {
                this.g = b[0];
                if (!this.al) {
                    this.g.hide();
                }
            }
            let c = a.querySelectorAll(".financialChartIndicatorMenu");
            if (c != null && c.length > 0) {
                this.q.g = c[0];
            }
            let d = a.querySelectorAll(".financialChartRangeSelector");
            if (d != null && d.length > 0) {
                this.s.g = d[0];
            }
            let e = a.querySelectorAll(".financialChartTypePicker");
            if (e != null && e.length > 0) {
                this.aa.g = e[0];
            }
        }
        bl(a) {
            this.q.u(a);
            this.aa.u(a);
        }
        constructor(a, b) {
            super("financialChartToolbar", b, "");
            this.o = null;
            this.r = null;
            this.z = null;
            this.p = null;
            this.w = null;
            this.aq = dateMaxValue();
            this.ap = dateMinValue();
            this.ao = dateMaxValue();
            this.an = dateMinValue();
            this.rangeChanged = null;
            this.chartTypeChanged = null;
            this.trendLineTypeChanged = null;
            this.volumeTypeChanged = null;
            this.indicatorTypesChanged = null;
            this.overlayTypesChanged = null;
            this.x = 0;
            this.ah = 0;
            this.ab = 0;
            this.ad = null;
            this.af = null;
            this.t = null;
            this.ak = false;
            this.o = a;
            this.w = new FinancialChartToolbarViewModel();
            this.s = new FinancialChartRangeSelector(a != null ? a.aib : null);
            this.aa = new FinancialChartTypePicker(a != null ? a.ah8 : null);
            this.q = new FinancialChartIndicatorMenu(1, a != null ? a.ah9 : null);
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        }
        get aa() {
            return this.z;
        }
        set aa(a) {
            let b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        }
        bm(a, b, c) {
            switch (a) {
                case "RangeStart":
                    if (this.s != null) {
                        this.s.t = this.as;
                    }
                    break;
                case "RangeEnd":
                    if (this.s != null) {
                        this.s.s = this.ar;
                    }
                    break;
                case "SelectionStart":
                    if (this.s != null) {
                        this.s.v = this.au;
                    }
                    break;
                case "SelectionEnd":
                    if (this.s != null) {
                        this.s.u = this.at;
                    }
                    break;
                case "RangeSelector":
                    let d = b;
                    if (d != null) {
                        d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                    }
                    if (this.s != null) {
                        this.s.t = this.as;
                        this.s.s = this.ar;
                        this.s.o = this.u;
                        this.s.v = this.au;
                        this.s.u = this.at;
                        let e = this.s;
                        e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                    }
                    break;
                case "ChartTypePicker":
                    let f = b;
                    if (f != null) {
                        f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                    }
                    if (this.aa != null) {
                        this.aa.w = this.y;
                        let g = this.aa;
                        g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                    }
                    break;
                case "ChartType":
                    if (this.aa != null) {
                        this.aa.w = this.y;
                    }
                    break;
                case "RangeSelectorOptions":
                    if (this.s != null) {
                        this.s.o = this.u;
                    }
                    break;
                case "IsToolbarVisible":
                    if (this.g == null) {
                        break;
                    }
                    if (this.al) {
                        this.g.show();
                    }
                    else {
                        this.g.hide();
                    }
                    break;
                case "IndicatorMenu":
                    let h = typeCast(FinancialChartIndicatorMenu.$, b);
                    if (h != null) {
                        h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                    }
                    if (this.q != null) {
                        let i = this.q;
                        i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                    }
                    break;
                case "IndicatorTypes":
                    if (this.indicatorTypesChanged != null) {
                        this.indicatorTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "OverlayTypes":
                    if (this.overlayTypesChanged != null) {
                        this.overlayTypesChanged(this, EventArgs.empty);
                    }
                    break;
                case "TrendLineType":
                    if (this.trendLineTypeChanged != null) {
                        this.trendLineTypeChanged(this, EventArgs.empty);
                    }
                    break;
                case "VolumeType":
                    if (this.volumeTypeChanged != null) {
                        this.volumeTypeChanged(this, EventArgs.empty);
                    }
                    break;
            }
        }
        bh(a, b) {
            this.ag = this.q.z;
            this.ae = this.q.y;
            this.ai = this.q.aa;
            this.ac = this.q.x;
        }
        bi(a, b) {
            this.y = this.aa.w;
            if (this.chartTypeChanged != null) {
                this.chartTypeChanged(this, b);
            }
        }
        bj(a, b) {
            this.au = this.s.v;
            this.at = this.s.u;
            if (this.rangeChanged != null) {
                this.rangeChanged(this, b);
            }
        }
        v() {
            let a = new FinancialChartToolbarContext();
            a.container = this.d;
            a.vm = this.w;
            a.vm.financialChartIndicatorMenu = ((() => {
                let $ret = new FinancialChartIndicatorMenuContext();
                $ret.vm = this.q.p;
                return $ret;
            })());
            a.vm.financialChartTypePicker = ((() => {
                let $ret = new FinancialChartTypePickerContext();
                $ret.vm = this.aa.p;
                return $ret;
            })());
            a.vm.financialChartRangeSelector = ((() => {
                let $ret = new FinancialChartRangeSelectorContext();
                $ret.vm = this.s.q;
                return $ret;
            })());
            return a;
        }
        l(a) {
            super.l(a);
            if (a == null) {
                return;
            }
            this.s.l(a);
            this.aa.l(a);
            this.q.l(a);
            this.bk();
        }
        bk() {
        }
        get au() {
            return this.aq;
        }
        set au(a) {
            let b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        }
        get at() {
            return this.ap;
        }
        set at(a) {
            let b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        }
        get as() {
            return this.ao;
        }
        set as(a) {
            let b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        }
        get ar() {
            return this.an;
        }
        set ar(a) {
            let b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        }
        bn() {
            if (this.s != null) {
                this.s.ab();
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        }
        get ai() {
            return this.ah;
        }
        set ai(a) {
            let b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            let b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        }
        get ae() {
            return this.ad;
        }
        set ae(a) {
            let b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        }
        get ag() {
            return this.af;
        }
        set ag(a) {
            let b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        }
        static am(a, b) {
            if (a == b) {
                return true;
            }
            if ((a == null && b != null) || (a != null && b == null)) {
                return false;
            }
            if (a.count != b.count) {
                return false;
            }
            for (let c of fromEn(a)) {
                if (!b.contains(c)) {
                    return false;
                }
            }
            return true;
        }
        aj() {
            return ((() => {
                let $ret = new FinancialChartToolbarVisualData();
                $ret.rangeSelector = this.s == null ? null : this.s.r();
                return $ret;
            })());
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        }
    }
    FinancialChartToolbar.$t = /*@__PURE__*/ markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
})();
/**
 * @hidden
 */
export let FinancialChartRangeSelector = /*@__PURE__*/ (() => {
    class FinancialChartRangeSelector extends TemplatedHtmlControl {
        get v() {
            return this.q.selectionStart;
        }
        set v(a) {
            this.q.selectionStart = a;
        }
        get u() {
            return this.q.selectionEnd;
        }
        set u(a) {
            this.q.selectionEnd = a;
        }
        get t() {
            return this.q.rangeStart;
        }
        set t(a) {
            this.q.rangeStart = a;
        }
        get s() {
            return this.q.rangeEnd;
        }
        set s(a) {
            this.q.rangeEnd = a;
        }
        ab() {
            if (this.q.onPropertiesChanged()) {
                this.p.g(this.q);
            }
        }
        constructor(a) {
            super("financialChartRangeSelector", a, "");
            this.q = null;
            this.rangeChanged = null;
            this.p = null;
            this.p = new FinancialChartRangeSelectorView();
            this.q = new FinancialChartRangeSelectorViewModel();
            this.q.onRangeChanged = runOn(this, this.z);
            this.p.c = this.q;
        }
        l(a) {
            super.l(a);
            this.p.f(this.d, this.q);
        }
        z() {
            if (this.rangeChanged != null) {
                this.rangeChanged(this, EventArgs.empty);
            }
        }
        r() {
            return this.p.d(this.g);
        }
        get o() {
            return this.q.options;
        }
        set o(a) {
            let b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        }
        aa() {
            if (this.q != null) {
                this.q.ao();
            }
            if (this.p != null) {
                this.p.i(this.o);
            }
        }
    }
    FinancialChartRangeSelector.$t = /*@__PURE__*/ markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
})();
