/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.v1 = null;
            this.v2 = null;
            this.wi = 0;
            this.wk = 5;
            this.wj = 0;
            this.wh = 5;
            this.wz = 5;
            this.w1 = 0;
            this.w0 = 5;
            this.wy = 0;
            this.abs = null;
            this.abz = null;
            this.abq = null;
            this.abr = null;
            this.wt = 0;
            this.xa = 0;
            this.ws = NaN;
            this.w9 = NaN;
            this.wv = NaN;
            this.xc = NaN;
            this.wu = NaN;
            this.xb = NaN;
            this.wr = NaN;
            this.w8 = NaN;
            this.aby = null;
            this.ab5 = null;
            this.yk = null;
            this.yo = null;
            this.ym = null;
            this.yq = null;
            this.yf = null;
            this.yg = null;
            this.abt = null;
            this.ab0 = null;
            this.wl = DeviceUtils.g(1);
            this.w2 = DeviceUtils.g(1);
            this.wm = DeviceUtils.g(1);
            this.w3 = DeviceUtils.g(1);
            this.abv = null;
            this.ab2 = null;
            this.abw = null;
            this.ab3 = null;
            this.wn = DeviceUtils.g(1);
            this.w4 = DeviceUtils.g(1);
            this.wo = DeviceUtils.g(8);
            this.w5 = 0;
            this.abx = null;
            this.ab4 = null;
            this.wp = DeviceUtils.g(1);
            this.w6 = DeviceUtils.g(1);
            this.yl = null;
            this.yp = null;
            this.abu = null;
            this.ab1 = null;
            this.wg = 0;
            this.wx = 0;
            this.wf = NaN;
            this.ww = NaN;
            this.wq = 0;
            this.w7 = -90;
            this.wb = false;
            this.wc = false;
            this.abl = 1;
            this.aco = 1;
            this.abk = 1;
            this.abm = 2;
            this.acm = 0;
            this.acn = 1;
            this.acs = 0;
            this.act = 0;
            this.v9 = 4;
            this.v7 = 4;
            this.yj = null;
            this.vv = null;
            this.yn = null;
            this.vw = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.vz();
                let c = this.v0();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        r5() {
            super.r5();
            let a = this.vz();
            let b = this.v0();
            if (a != null && a.ay != null) {
                this.ab8 = a.ay.textColor;
            }
            if (b != null && b.ay != null) {
                this.acf = b.ay.textColor;
            }
            this.acd = AxisDefaults.j;
            this.ack = AxisDefaults.j;
            this.ab9 = AxisDefaults.h;
            this.acg = AxisDefaults.h;
            this.acc = AxisDefaults.g;
            this.acj = AxisDefaults.g;
        }
        su(a, b, c) {
            super.su(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.abc((d) => d.leftMargin = this.xk);
                    break;
                case "XAxisLabelTopMargin":
                    this.abc((d) => d.topMargin = this.xm);
                    break;
                case "XAxisLabelRightMargin":
                    this.abc((d) => d.rightMargin = this.xl);
                    break;
                case "XAxisLabelBottomMargin":
                    this.abc((d) => d.bottomMargin = this.xj);
                    break;
                case "YAxisLabelLeftMargin":
                    this.abh((d) => d.leftMargin = this.x1);
                    break;
                case "YAxisLabelTopMargin":
                    this.abh((d) => d.topMargin = this.x3);
                    break;
                case "YAxisLabelRightMargin":
                    this.abh((d) => d.rightMargin = this.x2);
                    break;
                case "YAxisLabelBottomMargin":
                    this.abh((d) => d.bottomMargin = this.x0);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.ab6 = this.u2(this.ab8);
                    this.ab7 = this.u2(this.acf);
                    break;
                case "XAxisLabelTextColor":
                    this.ab6 = this.u2(this.ab8);
                    break;
                case "YAxisLabelTextColor":
                    this.ab7 = this.u2(this.acf);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.abc((d) => d.textColor = this.ab6);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.abh((d) => d.textColor = this.ab7);
                    break;
                case "XAxisTitleMargin":
                    this.abe((d) => d.margin = this.xv);
                    break;
                case "YAxisTitleMargin":
                    this.abj((d) => d.margin = this.yc);
                    break;
                case "XAxisTitleLeftMargin":
                    this.abe((d) => d.leftMargin = this.xu);
                    break;
                case "YAxisTitleLeftMargin":
                    this.abj((d) => d.leftMargin = this.yb);
                    break;
                case "XAxisTitleTopMargin":
                    this.abe((d) => d.topMargin = this.xx);
                    break;
                case "YAxisTitleTopMargin":
                    this.abj((d) => d.topMargin = this.ye);
                    break;
                case "XAxisTitleRightMargin":
                    this.abe((d) => d.rightMargin = this.xw);
                    break;
                case "YAxisTitleRightMargin":
                    this.abj((d) => d.rightMargin = this.yd);
                    break;
                case "XAxisTitleBottomMargin":
                    this.abe((d) => d.bottomMargin = this.xt);
                    break;
                case "YAxisTitleBottomMargin":
                    this.abj((d) => d.bottomMargin = this.ya);
                    break;
                case "XAxisTitleTextColor":
                    this.abe((d) => d.textColor = this.ace);
                    break;
                case "YAxisTitleTextColor":
                    this.abj((d) => d.textColor = this.acl);
                    break;
                case "XAxisFormatLabel":
                    this.aba((d) => d.at = this.v3);
                    break;
                case "YAxisFormatLabel":
                    this.abf((d) => d.at = this.v4);
                    break;
            }
        }
        get v3() {
            return this.v1;
        }
        set v3(a) {
            let b = this.v3;
            if (a != b) {
                this.v1 = a;
                this.sr("XAxisFormatLabel", b, this.v3);
            }
        }
        get v4() {
            return this.v2;
        }
        set v4(a) {
            let b = this.v4;
            if (a != b) {
                this.v2 = a;
                this.sr("YAxisFormatLabel", b, this.v4);
            }
        }
        get xk() {
            return this.wi;
        }
        set xk(a) {
            let b = this.xk;
            if (a != b) {
                this.wi = a;
                this.sr("XAxisLabelLeftMargin", b, this.xk);
            }
        }
        get xm() {
            return this.wk;
        }
        set xm(a) {
            let b = this.xm;
            if (a != b) {
                this.wk = a;
                this.sr("XAxisLabelTopMargin", b, this.xm);
            }
        }
        get xl() {
            return this.wj;
        }
        set xl(a) {
            let b = this.xl;
            if (a != b) {
                this.wj = a;
                this.sr("XAxisLabelRightMargin", b, this.xl);
            }
        }
        get xj() {
            return this.wh;
        }
        set xj(a) {
            let b = this.xj;
            if (a != b) {
                this.wh = a;
                this.sr("XAxisLabelBottomMargin", b, this.xj);
            }
        }
        get x1() {
            return this.wz;
        }
        set x1(a) {
            let b = this.x1;
            if (a != b) {
                this.wz = a;
                this.sr("YAxisLabelLeftMargin", b, this.x1);
            }
        }
        get x3() {
            return this.w1;
        }
        set x3(a) {
            let b = this.x3;
            if (a != b) {
                this.w1 = a;
                this.sr("YAxisLabelTopMargin", b, this.x3);
            }
        }
        get x2() {
            return this.w0;
        }
        set x2(a) {
            let b = this.x2;
            if (a != b) {
                this.w0 = a;
                this.sr("YAxisLabelRightMargin", b, this.x2);
            }
        }
        get x0() {
            return this.wy;
        }
        set x0(a) {
            let b = this.x0;
            if (a != b) {
                this.wy = a;
                this.sr("YAxisLabelBottomMargin", b, this.x0);
            }
        }
        get ab8() {
            return this.abs;
        }
        set ab8(a) {
            let b = this.ab8;
            if (a != b) {
                this.abs = a;
                this.sr("XAxisLabelTextColor", b, this.ab8);
            }
        }
        get acf() {
            return this.abz;
        }
        set acf(a) {
            let b = this.acf;
            if (a != b) {
                this.abz = a;
                this.sr("YAxisLabelTextColor", b, this.acf);
            }
        }
        get ab6() {
            return this.abq;
        }
        set ab6(a) {
            let b = this.abq;
            if (a != b) {
                this.abq = a;
                this.sr("ActualXAxisLabelTextColor", b, this.ab6);
            }
        }
        get ab7() {
            return this.abr;
        }
        set ab7(a) {
            let b = this.abr;
            if (a != b) {
                this.abr = a;
                this.sr("ActualYAxisLabelTextColor", b, this.ab7);
            }
        }
        get xv() {
            return this.wt;
        }
        set xv(a) {
            let b = this.xv;
            if (a != b) {
                this.wt = a;
                this.sr("XAxisTitleMargin", b, this.xv);
            }
        }
        get yc() {
            return this.xa;
        }
        set yc(a) {
            let b = this.yc;
            if (a != b) {
                this.xa = a;
                this.sr("YAxisTitleMargin", b, this.yc);
            }
        }
        get xu() {
            return this.ws;
        }
        set xu(a) {
            let b = this.xu;
            if (a != b) {
                this.ws = a;
                this.sr("XAxisTitleLeftMargin", b, this.xu);
            }
        }
        get yb() {
            return this.w9;
        }
        set yb(a) {
            let b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.sr("YAxisTitleLeftMargin", b, this.yb);
            }
        }
        get xx() {
            return this.wv;
        }
        set xx(a) {
            let b = this.xx;
            if (a != b) {
                this.wv = a;
                this.sr("XAxisTitleTopMargin", b, this.xx);
            }
        }
        get ye() {
            return this.xc;
        }
        set ye(a) {
            let b = this.ye;
            if (a != b) {
                this.xc = a;
                this.sr("YAxisTitleTopMargin", b, this.ye);
            }
        }
        get xw() {
            return this.wu;
        }
        set xw(a) {
            let b = this.xw;
            if (a != b) {
                this.wu = a;
                this.sr("XAxisTitleRightMargin", b, this.xw);
            }
        }
        get yd() {
            return this.xb;
        }
        set yd(a) {
            let b = this.yd;
            if (a != b) {
                this.xb = a;
                this.sr("YAxisTitleRightMargin", b, this.yd);
            }
        }
        get xt() {
            return this.wr;
        }
        set xt(a) {
            let b = this.xt;
            if (a != b) {
                this.wr = a;
                this.sr("XAxisTitleBottomMargin", b, this.xt);
            }
        }
        get ya() {
            return this.w8;
        }
        set ya(a) {
            let b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.sr("YAxisTitleBottomMargin", b, this.ya);
            }
        }
        get ace() {
            return this.aby;
        }
        set ace(a) {
            let b = this.ace;
            if (a != b) {
                this.aby = a;
                this.sr("XAxisTitleTextColor", b, this.ace);
            }
        }
        get acl() {
            return this.ab5;
        }
        set acl(a) {
            let b = this.acl;
            if (a != b) {
                this.ab5 = a;
                this.sr("YAxisTitleTextColor", b, this.acl);
            }
        }
        sv(a, b, c) {
            super.sv(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.abc((d) => d.textStyle = this.y8);
                    break;
                case "YAxisLabelTextStyle":
                    this.abh((d) => d.textStyle = this.aad);
                    break;
                case "XAxisTitleTextStyle":
                    this.abe((d) => d.textStyle = this.zw);
                    break;
                case "YAxisTitleTextStyle":
                    this.abj((d) => d.textStyle = this.aa1);
                    break;
            }
        }
        get y8() {
            return this.yk;
        }
        set y8(a) {
            let b = this.y8;
            if (a != b) {
                this.yk = a;
                this.sr("XAxisLabelTextStyle", b, this.y8);
            }
        }
        get aad() {
            return this.yo;
        }
        set aad(a) {
            let b = this.aad;
            if (a != b) {
                this.yo = a;
                this.sr("YAxisLabelTextStyle", b, this.aad);
            }
        }
        get zw() {
            return this.ym;
        }
        set zw(a) {
            let b = this.zw;
            if (a != b) {
                this.ym = a;
                this.sr("XAxisTitleTextStyle", b, this.zw);
            }
        }
        get aa1() {
            return this.yq;
        }
        set aa1(a) {
            let b = this.aa1;
            if (a != b) {
                this.yq = a;
                this.sr("YAxisTitleTextStyle", b, this.aa1);
            }
        }
        aa7(a) {
            this.aa4(a, (b) => b.leftMargin = this.xk);
            this.aa4(a, (b) => b.topMargin = this.xm);
            this.aa4(a, (b) => b.rightMargin = this.xl);
            this.aa4(a, (b) => b.bottomMargin = this.xj);
            this.aa4(a, (b) => b.textColor = this.ab6);
            this.aa5(a, (b) => b.textColor = this.ace);
            this.aa5(a, (b) => b.leftMargin = this.xu);
            this.aa5(a, (b) => b.topMargin = this.xx);
            this.aa5(a, (b) => b.rightMargin = this.xw);
            this.aa5(a, (b) => b.bottomMargin = this.xt);
            this.aa4(a, (b) => b.textStyle = this.y8);
            this.aa5(a, (b) => b.textStyle = this.zw);
        }
        aa9(a) {
            this.aa4(a, (b) => b.leftMargin = this.x1);
            this.aa4(a, (b) => b.topMargin = this.x3);
            this.aa4(a, (b) => b.rightMargin = this.x2);
            this.aa4(a, (b) => b.bottomMargin = this.x0);
            this.aa4(a, (b) => b.textColor = this.ab7);
            this.aa5(a, (b) => b.textColor = this.acl);
            this.aa5(a, (b) => b.leftMargin = this.yb);
            this.aa5(a, (b) => b.topMargin = this.ye);
            this.aa5(a, (b) => b.rightMargin = this.yd);
            this.aa5(a, (b) => b.bottomMargin = this.ya);
            this.aa4(a, (b) => b.textStyle = this.aad);
            this.aa5(a, (b) => b.textStyle = this.aa1);
        }
        tc(a) {
            let b = this.bc(a);
            let c = this.c0(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.oa(a);
            c.title = this.ob(a, b);
            this.dataChart.series.add(c);
        }
        aba(a) {
            this.abb(a, null);
        }
        abb(a, b) {
            a(this.vz());
        }
        abg(a, b) {
            a(this.v0());
        }
        abf(a) {
            this.abg(a, true);
        }
        rp(a, b) {
            this.aba(a);
            this.abg(a, b);
        }
        abe(a) {
            this.aa5(this.vz(), a);
        }
        abj(a) {
            this.aa5(this.v0(), a);
        }
        abh(a) {
            this.aa4(this.v0(), a);
        }
        abc(a) {
            this.aa4(this.vz(), a);
        }
        xd(a) {
            let b = this.vz();
            return b.ei(a, new ScalerParams(1, this.va, this.u9, b.cg));
        }
        xf(a) {
            let b = this.vz();
            return b.el(a, new ScalerParams(1, this.va, this.u9, b.cg));
        }
        xe(a) {
            let b = this.v0();
            return b.ei(a, new ScalerParams(1, this.va, this.u9, b.cg));
        }
        xg(a) {
            let b = this.v0();
            return b.el(a, new ScalerParams(1, this.va, this.u9, b.cg));
        }
        s9(a) {
            super.s9(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.vz();
                let c = this.v0();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static yt(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        r0(a) {
            super.r0(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.vz());
                this.dataChart.axes.add(this.v0());
            }
        }
        aa6(a) {
            if (a != null && this.j5 != null && a.fk == null) {
                a.provideRenderer(this.j5);
            }
            a.jv = this.ab9;
            a.eq = this.xn;
            a.jw = this.aca;
            a.et = this.xo;
            a.jy = this.acc;
            a.ff = this.xp;
            a.jx = this.acb;
            a.fg = this.xq;
            a.jz = this.acd;
            a.fh = this.xr;
            a.c3 = true;
            a.ct = this.f8;
            a.cv = this.f8;
            let b = a == this.vz();
            if (b) {
                a.g5 = this.zn;
            }
            a.fz = this.yh;
            a.gf = this.yz;
            a.ag = this.vx;
            this.aa4(a, (c) => c.angle = this.xi);
            this.aa4(a, (c) => {
                if (c.extent != this.xh) {
                    c.extent = this.xh;
                }
            });
            this.aa4(a, (c) => c.horizontalAlignment = this.abn);
            this.aa4(a, (c) => c.verticalAlignment = this.acp);
            this.aa4(a, (c) => c.visibility = this.acu);
            this.aa4(a, (c) => c.location = this.v5(this.v8));
            this.aa5(a, (c) => c.horizontalAlignment = this.abo);
            this.aa5(a, (c) => c.angle = this.xs);
            this.aa7(a);
        }
        aa8(a) {
            if (a == null) {
                return;
            }
            if (this.j5 != null && a.fk == null) {
                a.provideRenderer(this.j5);
            }
            a.ct = this.f8;
            a.cv = this.f8;
            this.aa4(a, (b) => b.angle = this.xz);
            this.aa4(a, (b) => {
                if (b.extent != this.xy) {
                    b.extent = this.xy;
                }
            });
            this.aa4(a, (b) => b.horizontalAlignment = this.abp);
            this.aa4(a, (b) => b.verticalAlignment = this.acq);
            this.aa4(a, (b) => b.visibility = this.acv);
            this.aa4(a, (b) => b.location = this.v6(this.wa));
            this.aa5(a, (b) => b.verticalAlignment = this.acr);
            this.aa5(a, (b) => b.angle = this.x9);
            a.jv = this.acg;
            a.eq = this.x4;
            a.jw = this.ach;
            a.et = this.x5;
            a.jy = this.acj;
            a.ff = this.x6;
            a.jx = this.aci;
            a.fg = this.x7;
            a.jz = this.ack;
            a.fh = this.x8;
            let b = a == this.v0();
            if (b) {
                a.g5 = this.aas;
            }
            a.gf = this.z4;
            a.ag = this.vy;
            this.aa9(a);
        }
        rx() {
            super.rx();
            this.aa6(this.vz());
            this.aa8(this.v0());
        }
        aa4(a, b) {
            if (a == null) {
                return;
            }
            if (a.ay == null) {
                a.ay = new AxisLabelSettings();
                a.ay.angle = a.d4();
                a.ay.bottomMargin = a.d5();
                a.ay.leftMargin = a.d6();
                a.ay.rightMargin = a.d7();
                a.ay.topMargin = a.d8();
                a.ay.horizontalAlignment = a.jq();
                a.ay.location = a.az();
                a.ay.verticalAlignment = a.kj();
            }
            b(a.ay);
        }
        aa5(a, b) {
            if (a == null) {
                return;
            }
            if (a.be == null) {
                a.be = new TitleSettings();
                a.be.bottomMargin = a.ea();
                a.be.leftMargin = a.eb();
                a.be.rightMargin = a.ec();
                a.be.topMargin = a.ed();
                a.be.location = a.a0();
                a.be.angle = a.d9();
                a.be.horizontalAlignment = a.jr();
                a.be.verticalAlignment = a.kk();
            }
            b(a.be);
        }
        sr(a, b, c) {
            super.sr(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.abc((d) => d.angle = this.xi);
                    break;
                case "YAxisLabelAngle":
                    this.abh((d) => d.angle = this.xz);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.abc((d) => d.horizontalAlignment = this.abn);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.abh((d) => d.horizontalAlignment = this.abp);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.abc((d) => d.verticalAlignment = this.acp);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.abh((d) => d.verticalAlignment = this.acq);
                    break;
                case "XAxisLabelVisibility":
                    this.abc((d) => d.visibility = this.acu);
                    break;
                case "YAxisLabelVisibility":
                    this.abh((d) => d.visibility = this.acv);
                    break;
                case "XAxisLabel":
                    this.aba((d) => d.fz = this.yh);
                    break;
                case "YAxisLabel":
                    this.abf((d) => d.fz = this.yi);
                    break;
                case "XAxisLabelFormat":
                    this.aba((d) => d.gf = this.yz);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.aba((d) => d.ag = this.vx);
                    break;
                case "YAxisLabelFormat":
                    this.abf((d) => d.gf = this.z4);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.abf((d) => d.ag = this.vy);
                    break;
                case "XAxisTitleAngle":
                    this.abe((d) => d.angle = this.xs);
                    break;
                case "YAxisTitleAngle":
                    this.abj((d) => d.angle = this.x9);
                    break;
                case "XAxisTitleAlignment":
                    this.abe((d) => d.horizontalAlignment = this.abo);
                    break;
                case "YAxisTitleAlignment":
                    this.abj((d) => d.verticalAlignment = this.acr);
                    break;
                case "XAxisTitle":
                    this.aba((d) => d.g5 = this.zn);
                    break;
                case "YAxisTitle":
                    this.abg((d) => d.g5 = this.aas, false);
                    break;
                case "XAxisMajorStroke":
                    this.abb((d) => d.jv = this.ab9, a);
                    break;
                case "YAxisMajorStroke":
                    this.abf((d) => d.jv = this.acg);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.abb((d) => d.eq = this.xn, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.abf((d) => d.eq = this.x4);
                    break;
                case "XAxisMinorStroke":
                    this.aba((d) => d.jw = this.aca);
                    break;
                case "YAxisMinorStroke":
                    this.abf((d) => d.jw = this.ach);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.aba((d) => d.et = this.xo);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.abf((d) => d.et = this.x5);
                    break;
                case "XAxisTickLength":
                    this.aba((d) => d.fg = this.xq);
                    break;
                case "YAxisTickLength":
                    this.abf((d) => d.fg = this.x7);
                    break;
                case "XAxisTickStroke":
                    this.aba((d) => d.jz = this.acd);
                    break;
                case "YAxisTickStroke":
                    this.abf((d) => d.jz = this.ack);
                    break;
                case "XAxisTickStrokeThickness":
                    this.aba((d) => d.fh = this.xr);
                    break;
                case "YAxisTickStrokeThickness":
                    this.abf((d) => d.fh = this.x8);
                    break;
                case "XAxisStroke":
                    this.aba((d) => d.jy = this.acc);
                    break;
                case "YAxisStroke":
                    this.abf((d) => d.jy = this.acj);
                    break;
                case "XAxisStrokeThickness":
                    this.aba((d) => d.ff = this.xp);
                    break;
                case "YAxisStrokeThickness":
                    this.abf((d) => d.ff = this.x6);
                    break;
                case "XAxisExtent":
                    this.abc((d) => d.extent = this.xh);
                    break;
                case "YAxisExtent":
                    this.abh((d) => d.extent = this.xy);
                    break;
                case "XAxisStrip":
                    this.aba((d) => d.jx = this.acb);
                    break;
                case "YAxisStrip":
                    this.abf((d) => d.jx = this.aci);
                    break;
                case "XAxisInverted":
                    this.aba((d) => d.cg = this.wd);
                    break;
                case "YAxisInverted":
                    this.abf((d) => d.cg = this.we);
                    break;
                case "YAxisLabelLocation":
                    this.abi();
                    break;
                case "XAxisLabelLocation":
                    this.abd();
                    break;
            }
        }
        abi() {
            let a = this.v6(this.wa);
            if (a == 2 || a == 7) {
                this.abp = 2;
            }
            else {
                this.abp = 0;
            }
            this.abh((b) => b.location = a);
        }
        abd() {
            let a = this.v5(this.v8);
            if (a == 1 || a == 5) {
                this.acp = 0;
            }
            else {
                this.acp = 2;
            }
            this.abc((b) => b.location = a);
        }
        v6(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.b1 == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        v5(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get yh() {
            return this.yf;
        }
        set yh(a) {
            let b = this.yh;
            if (a != b) {
                this.yf = a;
                this.sr("XAxisLabel", b, this.yh);
            }
        }
        get yi() {
            return this.yg;
        }
        set yi(a) {
            let b = this.yi;
            if (a != b) {
                this.yg = a;
                this.sr("YAxisLabel", b, this.yi);
            }
        }
        get ab9() {
            return this.abt;
        }
        set ab9(a) {
            let b = this.ab9;
            if (a != b) {
                this.abt = a;
                this.sr("XAxisMajorStroke", b, this.ab9);
            }
        }
        get acg() {
            return this.ab0;
        }
        set acg(a) {
            let b = this.acg;
            if (a != b) {
                this.ab0 = a;
                this.sr("YAxisMajorStroke", b, this.acg);
            }
        }
        get xn() {
            return this.wl;
        }
        set xn(a) {
            let b = this.xn;
            if (a != b) {
                this.wl = a;
                this.sr("XAxisMajorStrokeThickness", b, this.xn);
            }
        }
        get x4() {
            return this.w2;
        }
        set x4(a) {
            let b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.sr("YAxisMajorStrokeThickness", b, this.x4);
            }
        }
        get xo() {
            return this.wm;
        }
        set xo(a) {
            let b = this.xo;
            if (a != b) {
                this.wm = a;
                this.sr("XAxisMinorStrokeThickness", b, this.xo);
            }
        }
        get x5() {
            return this.w3;
        }
        set x5(a) {
            let b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.sr("YAxisMinorStrokeThickness", b, this.x5);
            }
        }
        get acb() {
            return this.abv;
        }
        set acb(a) {
            let b = this.acb;
            if (a != b) {
                this.abv = a;
                this.sr("XAxisStrip", b, this.acb);
            }
        }
        get aci() {
            return this.ab2;
        }
        set aci(a) {
            let b = this.aci;
            if (a != b) {
                this.ab2 = a;
                this.sr("YAxisStrip", b, this.aci);
            }
        }
        get acc() {
            return this.abw;
        }
        set acc(a) {
            let b = this.acc;
            if (a != b) {
                this.abw = a;
                this.sr("XAxisStroke", b, this.acc);
            }
        }
        get acj() {
            return this.ab3;
        }
        set acj(a) {
            let b = this.acj;
            if (a != b) {
                this.ab3 = a;
                this.sr("YAxisStroke", b, this.acj);
            }
        }
        get xp() {
            return this.wn;
        }
        set xp(a) {
            let b = this.xp;
            if (a != b) {
                this.wn = a;
                this.sr("XAxisStrokeThickness", b, this.xp);
            }
        }
        get x6() {
            return this.w4;
        }
        set x6(a) {
            let b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.sr("YAxisStrokeThickness", b, this.x6);
            }
        }
        get xq() {
            return this.wo;
        }
        set xq(a) {
            let b = this.xq;
            if (a != b) {
                this.wo = a;
                this.sr("XAxisTickLength", b, this.xq);
            }
        }
        get x7() {
            return this.w5;
        }
        set x7(a) {
            let b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.sr("YAxisTickLength", b, this.x7);
            }
        }
        get acd() {
            return this.abx;
        }
        set acd(a) {
            let b = this.acd;
            if (a != b) {
                this.abx = a;
                this.sr("XAxisTickStroke", b, this.acd);
            }
        }
        get ack() {
            return this.ab4;
        }
        set ack(a) {
            let b = this.ack;
            if (a != b) {
                this.ab4 = a;
                this.sr("YAxisTickStroke", b, this.ack);
            }
        }
        get xr() {
            return this.wp;
        }
        set xr(a) {
            let b = this.xr;
            if (a != b) {
                this.wp = a;
                this.sr("XAxisTickStrokeThickness", b, this.xr);
            }
        }
        get x8() {
            return this.w6;
        }
        set x8(a) {
            let b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.sr("YAxisTickStrokeThickness", b, this.x8);
            }
        }
        get zn() {
            return this.yl;
        }
        set zn(a) {
            let b = this.zn;
            if (a != b) {
                this.yl = a;
                this.sr("XAxisTitle", b, this.zn);
            }
        }
        get aas() {
            return this.yp;
        }
        set aas(a) {
            let b = this.aas;
            if (a != b) {
                this.yp = a;
                this.sr("YAxisTitle", b, this.aas);
            }
        }
        get aca() {
            return this.abu;
        }
        set aca(a) {
            let b = this.aca;
            if (a != b) {
                this.abu = a;
                this.sr("XAxisMinorStroke", b, this.aca);
            }
        }
        get ach() {
            return this.ab1;
        }
        set ach(a) {
            let b = this.ach;
            if (a != b) {
                this.ab1 = a;
                this.sr("YAxisMinorStroke", b, this.ach);
            }
        }
        get xi() {
            return this.wg;
        }
        set xi(a) {
            let b = this.xi;
            if (a != b) {
                this.wg = a;
                this.sr("XAxisLabelAngle", b, this.xi);
            }
        }
        get xz() {
            return this.wx;
        }
        set xz(a) {
            let b = this.xz;
            if (a != b) {
                this.wx = a;
                this.sr("YAxisLabelAngle", b, this.xz);
            }
        }
        get xh() {
            return this.wf;
        }
        set xh(a) {
            let b = this.xh;
            if (a != b) {
                this.wf = a;
                this.sr("XAxisExtent", b, this.xh);
            }
        }
        get xy() {
            return this.ww;
        }
        set xy(a) {
            let b = this.xy;
            if (a != b) {
                this.ww = a;
                this.sr("YAxisExtent", b, this.xy);
            }
        }
        get xs() {
            return this.wq;
        }
        set xs(a) {
            let b = this.xs;
            if (a != b) {
                this.wq = a;
                this.sr("XAxisTitleAngle", b, this.xs);
            }
        }
        get x9() {
            return this.w7;
        }
        set x9(a) {
            let b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.sr("YAxisTitleAngle", b, this.x9);
            }
        }
        get wd() {
            return this.wb;
        }
        set wd(a) {
            let b = this.wd;
            if (a != b) {
                this.wb = a;
                this.sr("XAxisInverted", b, this.wd);
            }
        }
        get we() {
            return this.wc;
        }
        set we(a) {
            let b = this.we;
            if (a != b) {
                this.wc = a;
                this.sr("YAxisInverted", b, this.we);
            }
        }
        get abo() {
            return this.abl;
        }
        set abo(a) {
            let b = this.abo;
            if (a != b) {
                this.abl = a;
                this.sr("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abo));
            }
        }
        get acr() {
            return this.aco;
        }
        set acr(a) {
            let b = this.acr;
            if (a != b) {
                this.aco = a;
                this.sr("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acr));
            }
        }
        get abn() {
            return this.abk;
        }
        set abn(a) {
            let b = this.abn;
            if (a != b) {
                this.abk = a;
                this.sr("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abn));
            }
        }
        get_abp() {
            return this.abm;
        }
        set_abp(a) {
            let b = this.abp;
            if (a != b) {
                this.abm = a;
                this.sr("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abp));
            }
        }
        get abp() {
            return this.get_abp();
        }
        set abp(a) {
            this.set_abp(a);
        }
        get acp() {
            return this.acm;
        }
        set acp(a) {
            let b = this.acp;
            if (a != b) {
                this.acm = a;
                this.sr("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acp));
            }
        }
        get acq() {
            return this.acn;
        }
        set acq(a) {
            let b = this.acq;
            if (a != b) {
                this.acn = a;
                this.sr("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acq));
            }
        }
        get acu() {
            return this.acs;
        }
        set acu(a) {
            let b = this.acu;
            if (a != b) {
                this.acs = a;
                this.sr("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acu));
            }
        }
        get acv() {
            return this.act;
        }
        set acv(a) {
            let b = this.acv;
            if (a != b) {
                this.act = a;
                this.sr("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acv));
            }
        }
        get_wa() {
            return this.v9;
        }
        set_wa(a) {
            let b = this.wa;
            if (a != b) {
                this.v9 = a;
                this.sr("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wa));
            }
        }
        get wa() {
            return this.get_wa();
        }
        set wa(a) {
            this.set_wa(a);
        }
        get_v8() {
            return this.v7;
        }
        set_v8(a) {
            let b = this.v8;
            if (a != b) {
                this.v7 = a;
                this.sr("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.v8));
            }
        }
        get v8() {
            return this.get_v8();
        }
        set v8(a) {
            this.set_v8(a);
        }
        get yz() {
            return this.yj;
        }
        set yz(a) {
            let b = this.yj;
            if (a != b) {
                this.yj = a;
                this.sr("XAxisLabelFormat", b, this.yj);
            }
        }
        get vx() {
            return this.vv;
        }
        set vx(a) {
            let b = this.vv;
            if (a != b) {
                this.vv = a;
                this.sr("XAxisLabelFormatSpecifiers", b, this.vv);
            }
        }
        get z4() {
            return this.yn;
        }
        set z4(a) {
            let b = this.yn;
            if (a != b) {
                this.yn = a;
                this.sr("YAxisLabelFormat", b, this.yn);
            }
        }
        get vy() {
            return this.vw;
        }
        set vy(a) {
            let b = this.vw;
            if (a != b) {
                this.vw = a;
                this.sr("YAxisLabelFormatSpecifiers", b, this.vw);
            }
        }
    }
    XYChart.$t = /*@__PURE__*/ markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
