/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.aeo = null;
        _this.ahm = null;
        _this.ahk = null;
        _this.ahh = null;
        _this.ahj = null;
        _this.ahl = null;
        _this.ahi = null;
        _this.adu = null;
        _this.ah4 = null;
        _this.ah5 = null;
        _this.ah1 = null;
        _this.ah6 = null;
        _this.ah7 = null;
        _this.ah2 = null;
        _this.ah3 = null;
        _this.afc = null;
        _this.agm = 40;
        _this.aei = null;
        _this.aeg = null;
        _this.aek = null;
        _this.aep = null;
        _this.aif = null;
        _this.ae8 = null;
        _this.afy = false;
        _this.afx = false;
        _this.af5 = false;
        _this.afk = false;
        _this.ahs = 10;
        _this.agt = NaN;
        _this.agv = NaN;
        _this.agu = NaN;
        _this.agw = 0;
        _this.ad0 = 0;
        _this.ad3 = 0;
        _this.ago = 3;
        _this.agr = NaN;
        _this.agp = NaN;
        _this.agq = NaN;
        _this.ags = NaN;
        _this.ad5 = 0;
        _this.aff = true;
        _this.adw = 0;
        _this.afg = false;
        _this.aea = null;
        _this.aec = null;
        _this.af7 = null;
        _this.afi = true;
        _this.afh = false;
        _this.afj = false;
        _this.ae9 = null;
        _this.ad7 = 1;
        _this.acy = null;
        _this.acz = null;
        _this.ac0 = null;
        _this.ac1 = null;
        _this.ac3 = null;
        _this.ac2 = null;
        _this.acx = null;
        _this.acw = null;
        _this.agn = 1;
        _this.agl = 1;
        _this.agk = 2;
        _this.agj = 1;
        _this.aem = null;
        _this.aho = -2147483648;
        _this.agi = 2;
        _this.ahr = 3;
        _this.ahp = 10;
        _this.ahn = 30;
        _this.ahq = 9;
        _this.adr = null;
        _this.ads = null;
        _this.adn = null;
        _this.applyCustomIndicators = null;
        _this.al9 = null;
        _this.agx = 1;
        _this.afe = false;
        _this.aee = null;
        _this.agf = dateMinValue();
        _this.age = dateMaxValue();
        _this.agc = null;
        _this.rn();
        _this.agc = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.aly(); });
        }
        _this.alj();
        return _this;
    }
    FinancialChart.prototype.sv = function (a, b, c) {
        _super.prototype.sv.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.adv = new FinancialChartToolbar(this, this.aic);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.ak6));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.ak9));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.ala));
                    d.l(null);
                }
                if (this.adv != null) {
                    this.adv.ac = this.ad2;
                    this.adv.ai = this.dp;
                    this.adv.y = this.adx;
                    this.adv.al = this.afv;
                    if (this.ahj != null) {
                        this.adv.l(this.ahj);
                    }
                    var e = this.adv;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.ak6));
                    ;
                    var f = this.adv;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.ak9));
                    var g = this.adv;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.ala));
                }
                break;
            case "ChartType":
                if (this.adv != null) {
                    this.adv.y = this.adx;
                }
                break;
            case "VolumeType":
                if (this.adv != null) {
                    this.adv.ac = this.ad2;
                }
                break;
            case "TrendLineType":
                if (this.adv != null) {
                    this.adv.ai = this.dp;
                }
                break;
            case "IsToolbarVisible":
                if (this.adv == null) {
                    break;
                }
                this.adv.al = this.afv;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.ala = function (a, b) {
        this.ad2 = this.adv.ac;
    };
    FinancialChart.prototype.ak9 = function (a, b) {
        this.dp = this.adv.ai;
    };
    FinancialChart.prototype.ak6 = function (a, b) {
        this.adx = this.adv.y;
    };
    FinancialChart.prototype.alj = function () {
        this.aeo = new IndicatorPane();
        this.aef = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.ahm = a;
        this.al4();
        this.setGridRows();
        if (this.adv != null) {
            this.adv.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.adv != null) {
            this.adv.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.adv.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.j5;
        b.toolbarContainer = this.ahj;
        b.legendContainer = this.ahi;
        b.indicatorsContainer = this.ahh;
        b.volumeContainer = this.ahk;
        b.zoomContainer = this.ahl;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.adv == null) {
                this.adv = new FinancialChartToolbar(this, this.aic);
            }
            this.adv.w.isIndicatorMenuVisible = this.afm && this.afn;
            this.ahj = b.getSubRenderer(d);
            this.adv.l(this.ahj);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.ahi = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.ahh = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.ahk = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ahl = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.ahj = null;
            if (this.adv != null) {
                this.adv.l(null);
            }
            if (this.afd != null) {
                this.afd.provideContainer(null);
                this.afd = null;
            }
            if (this.aef != null) {
                this.aef.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.ahk);
            }
            if (this.aeo != null) {
                this.aeo.h(this.ahh);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.ahl);
                if (a != null) {
                    this.akq();
                }
                else {
                    this.afd = null;
                }
            }
            if (this.aef != null) {
                this.aef.provideContainer(this.ahi);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.alu = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.al8 = function (a, b) {
        this.alu(a, b, this.ahl);
        if (b == null) {
            return;
        }
        this.akq();
    };
    FinancialChart.prototype.akq = function () {
        var _this = this;
        if (this.ahl == null) {
            return;
        }
        if (this.afd != null) {
            this.afd.provideContainer(null);
        }
        this.afd = TypeRegistrar.create("ZoomSlider");
        this.afd.provideContainer(this.ahl);
        var a = this.afd;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.tq = new Rect(0, _this.afd.windowRect.left, _this.dataChart.ta.top, _this.afd.windowRect.width, _this.dataChart.ta.height);
            }
        });
        this.akr();
    };
    FinancialChart.prototype.al6 = function (a, b) {
        this.alu(a, b, this.ahk);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.ahm == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.afv ? this.ag3 : 0) + "px";
        a[1] = this.afr ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.afd != null) {
            if (a[5] == "0px") {
                this.afd.hide();
            }
            else {
                this.afd.show();
            }
        }
        this.ahm.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)), "auto", "1fr"));
        this.ahm.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)));
        if (this.j5 == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.aeo != null) {
            this.aeo.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.afd != null) {
            this.afd.notifySizeChanged();
        }
    };
    FinancialChart.prototype.r5 = function () {
        var e_1, _a;
        _super.prototype.r5.call(this);
        this.wa = 1;
        this.abp = 0;
        this.x7 = 0;
        this.acj = null;
        this.acc = AxisDefaults.g;
        this.xr = AxisDefaults.e;
        this.xq = AxisDefaults.f;
        this.acd = AxisDefaults.j;
        this.ab9 = null;
        this.ama = AxisDefaults.h;
        this.ahg = AxisDefaults.b;
        this.fq = true;
        this.fj = true;
        this.fk = false;
        this.a9 = 0;
        this.h6 = Defaults.j;
        this.uk = Defaults.ae;
        this.uf = Defaults.af;
        this.ug = Defaults.ag;
        this.is = NaN;
        this.ij = 40;
        this.fz = true;
        this.f6 = false;
        if (this.dataChart != null) {
            var a = this.dataChart.cu.j.e();
            this.ac6 = a.d;
            this.ac7 = a.e;
            this.ac5 = a.d;
            this.ama = this.dataChart.xv;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8BDC5C";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8961A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6DB1FF";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#82E9D9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#EA3C63";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#F8CE4F";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#A8A8B7";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#E051A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#FF903B";
            return $ret;
        })()));
        var c = new BrushCollection();
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(BrushUtil.m(d, 0.3));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.ac8 = c;
        this.ac9 = b;
    };
    FinancialChart.prototype.alq = function () {
        if (this.aeo != null) {
            this.aeo.b = null;
            this.aeo.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.alr = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.al0 = function () {
        this.alq();
    };
    FinancialChart.prototype.akp = function () {
        if (this.afd == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.j5.rootWrapper.width();
        var b = this.dataChart.tp.left + this.dataChart.tp.width;
        var c = this.dataChart.tp.left;
        var d = a - b;
        this.afd.startInset = c - this.afd.trackStartInset;
        this.afd.endInset = d - this.afd.trackEndInset;
        if (this.afd.endInset < 0) {
            var e = this.afd.endInset;
            this.afd.endInset = 0;
            this.dataChart.g2 += (e * -1);
        }
        if (this.afd.startInset < 0) {
            var f = this.afd.startInset;
            this.afd.startInset = 0;
            this.dataChart.gx += (f * -1);
        }
        this.zoomSliderChart.gx = c;
        this.zoomSliderChart.g2 = d;
        this.zoomSliderChart.gk = this.afd.barExtent;
    };
    FinancialChart.prototype.alg = function () {
        this.akp();
    };
    FinancialChart.prototype.r2 = function (a) {
        _super.prototype.r2.call(this, a);
        if (a != null) {
            a.gj = 0;
        }
    };
    FinancialChart.prototype.amb = function (a) {
        return a.s3();
    };
    FinancialChart.prototype.ame = function () {
        return this.ahi == null ? null : this.amd(this.ahi.rootWrapper);
    };
    FinancialChart.prototype.amc = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.amd(a.d.rootWrapper);
    };
    FinancialChart.prototype.amd = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.agy = function () {
        if (this.ahm == null) {
            return NaN;
        }
        var a = this.ahm.getOffset();
        return this.ahm.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.sd = function (source_, a, b) {
        _super.prototype.sd.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mh(source_, a, b);
        }
    };
    FinancialChart.prototype.se = function (source_, a, b) {
        _super.prototype.se.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mi(source_, a, b);
        }
    };
    FinancialChart.prototype.sc = function (source_) {
        _super.prototype.sc.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.ma(source_);
        }
    };
    FinancialChart.prototype.sg = function (source_, a, b, c) {
        _super.prototype.sg.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mj(source_, a, b, c);
        }
    };
    FinancialChart.prototype.r8 = function (a, b) {
        _super.prototype.r8.call(this, a, b);
        if (this.afs(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "adv", {
        get: function () {
            return this.adu;
        },
        set: function (a) {
            var b = this.adv;
            if (a != b) {
                this.adu = a;
                this.sr("Toolbar", b, this.adv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aib", {
        get: function () {
            return this.ah4;
        },
        set: function (a) {
            var b = this.aib;
            if (a != b) {
                this.ah4 = a;
                this.sr("RangeSelectorTemplate", b, this.aib);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aic", {
        get: function () {
            return this.ah5;
        },
        set: function (a) {
            var b = this.aic;
            if (a != b) {
                this.ah5 = a;
                this.sr("ToolbarTemplate", b, this.aic);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah8", {
        get: function () {
            return this.ah1;
        },
        set: function (a) {
            var b = this.ah8;
            if (a != b) {
                this.ah1 = a;
                this.sr("ChartTypePickerTemplate", b, this.ah8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aid", {
        get: function () {
            return this.ah6;
        },
        set: function (a) {
            var b = this.aid;
            if (a != b) {
                this.ah6 = a;
                this.sr("TrendLineTypePickerTemplate", b, this.aid);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aie", {
        get: function () {
            return this.ah7;
        },
        set: function (a) {
            var b = this.aie;
            if (a != b) {
                this.ah7 = a;
                this.sr("VolumeTypePickerTemplate", b, this.aie);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah9", {
        get: function () {
            return this.ah2;
        },
        set: function (a) {
            var b = this.ah9;
            if (a != b) {
                this.ah2 = a;
                this.sr("IndicatorMenuTemplate", b, this.ah9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aia", {
        get: function () {
            return this.ah3;
        },
        set: function (a) {
            var b = this.aia;
            if (a != b) {
                this.ah3 = a;
                this.sr("OverlayPickerTemplate", b, this.aia);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afd", {
        get: function () {
            return this.afc;
        },
        set: function (a) {
            var b = this.afd;
            if (a != b) {
                this.afc = a;
                this.sr("ZoomSlider", b, this.afd);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_ij = function () {
        return _super.prototype.get_ij.call(this);
    };
    FinancialChart.prototype.set_ij = function (a) {
        _super.prototype.set_ij.call(this, a);
    };
    FinancialChart.prototype.get_fz = function () {
        return _super.prototype.get_fz.call(this);
    };
    FinancialChart.prototype.set_fz = function (a) {
        _super.prototype.set_fz.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ag3", {
        get: function () {
            return this.agm;
        },
        set: function (a) {
            var b = this.ag3;
            if (a != b) {
                this.agm = a;
                this.sr("ToolbarHeight", b, this.ag3);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.vz = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.v0 = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.afd != null) {
            this.afd.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.afd != null) {
            this.afd.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.bc = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_go = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "go", {
        get: function () {
            return this.get_go();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_gn = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "gn", {
        get: function () {
            return this.get_gn();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.adh = function (a) {
        return this.adi(a);
    };
    FinancialChart.prototype.aev = function (a) {
        return this.aew(a);
    };
    FinancialChart.prototype.adg = function (a) {
        var b = this.adh(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.rj = function () {
        this.xAxis = this.adg("xAxis");
        this.yAxis = this.aev(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.aev(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.adg("volumeXAxis");
        this.af9 = new List$1(NumericYAxis.$, 0);
        this.agb = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.aev(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.adg("indicatorXAxis_0");
        this.af9.add(this.indicatorAxis);
        this.agb.add(this.indicatorXAxis);
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeXAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorAxis.ay == null) {
            this.indicatorAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.ay == null) {
            this.indicatorXAxis.ay = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.aev(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.adg("zoomSliderXAxis");
        if (this.zoomSliderAxis.ay == null) {
            this.zoomSliderAxis.ay = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.ay == null) {
            this.zoomSliderXAxis.ay = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.rf = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.ql = this.cr(a, b);
        }
    };
    FinancialChart.prototype.cq = function (a) {
        if (a != null) {
            return 1;
        }
        return _super.prototype.cq.call(this, a);
    };
    FinancialChart.prototype.tb = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.lh = true;
            this.yAxis.l8 = 10;
        }
    };
    FinancialChart.prototype.te = function () {
        this.yAxis.lh = this.af2;
        this.yAxis.l8 = this.ah0;
    };
    FinancialChart.prototype.adz = function (a) {
        var b;
        if (this.adx == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.adx;
        }
        b = this.ady(b);
        return b;
    };
    FinancialChart.prototype.ady = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ad8 = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ad1 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ain = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.adi = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.aew = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ae2 = function () {
        return this.c2(1);
    };
    FinancialChart.prototype.ae3 = function () {
        return this.c2(0);
    };
    FinancialChart.prototype.ae1 = function () {
        return this.c2(2);
    };
    FinancialChart.prototype.ae4 = function () {
        return this.c2(20);
    };
    Object.defineProperty(FinancialChart.prototype, "afl", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aej", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afo", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeh", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afm", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ael", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afn", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeq", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.c0 = function (a, b) {
        var c = this.ain(a);
        switch (this.adz(a)) {
            case 3:
                var d = this.ae2();
                this.aej.setValueMemberPath(d, c);
                this.aej.setXAxis(d, this.xAxis);
                this.aej.setYAxis(d, this.yAxis);
                this.aej.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.ae3();
                this.aej.setValueMemberPath(e, c);
                this.aej.setXAxis(e, this.xAxis);
                this.aej.setYAxis(e, this.yAxis);
                this.aej.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.ae4();
                this.aeh.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.aeh.setHighMemberPath(f, a.getMemberPathFor(12));
                this.aeh.setLowMemberPath(f, a.getMemberPathFor(13));
                this.aeh.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.aeh.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.aeh.setXAxis(f, this.xAxis);
                this.aeh.setYAxis(f, this.yAxis);
                this.aeh.setDisplayType(f, this.adx == 1 ? 1 : 0);
                this.aeh.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.td = function () {
        _super.prototype.td.call(this);
        this.ale(this.xAxis);
        this.al2(false);
        if (this.ad2 != 0 && this.volumeChart != null) {
            this.all();
        }
        this.ale(this.volumeXAxis);
        this.ale(this.indicatorXAxis);
        this.alz();
        this.al1();
        if (this.ad9 != 0) {
            this.alm();
            this.ale(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.abb = function (a, b) {
        var e_2, _a;
        _super.prototype.abb.call(this, a, b);
        a(this.volumeXAxis);
        if (this.agb != null) {
            try {
                for (var _b = __values(fromEnum(this.agb)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.abg = function (a, b) {
        var e_3, _a;
        _super.prototype.abg.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.af9 != null) {
                try {
                    for (var _b = __values(fromEnum(this.af9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.ali = function (a) {
        var b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
        if (b != null) {
            a(b);
        }
    };
    FinancialChart.prototype.abe = function (a) {
        _super.prototype.abe.call(this, a);
        this.aa5(this.volumeXAxis, a);
        this.aa5(this.indicatorXAxis, a);
        this.aa5(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.abj = function (a) {
        _super.prototype.abj.call(this, a);
        this.aa5(this.volumeAxis, a);
        this.aa5(this.indicatorAxis, a);
        this.aa5(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.abh = function (a) {
        _super.prototype.abh.call(this, a);
        this.aa4(this.volumeAxis, a);
        this.aa4(this.indicatorAxis, a);
        this.aa4(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.abc = function (a) {
        _super.prototype.abc.call(this, a);
        this.aa4(this.volumeXAxis, a);
        this.aa4(this.indicatorXAxis, a);
        this.aa4(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.r1 = function (a) {
        var _this = this;
        _super.prototype.r1.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.ul = a.uo = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.ag = this.dataChart.ag;
                a.aj = this.dataChart.aj;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.aji();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.ci = 2;
    };
    FinancialChart.prototype.aji = function () {
        if (this.aif == null) {
            FinancialChart.ahz++;
            this.aif = FinancialChart.ahz.toString();
        }
        return this.aif;
    };
    FinancialChart.prototype.ak0 = function (a, b) {
        this.akm();
        this.alg();
    };
    FinancialChart.prototype.akm = function () {
        var e_4, _a;
        if (this.yAxis.b7()) {
            return;
        }
        var a = this.yAxis.av.bd;
        if (this.ad2 != 0) {
            a = Math.max(a, this.volumeAxis.av.bd);
        }
        try {
            for (var _b = __values(fromEnum(this.af9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.av.bd);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.akn(a);
    };
    FinancialChart.prototype.akn = function (a) {
        var e_5, _a;
        if (this.yAxis.b7()) {
            return;
        }
        this.yAxis.er = this.volumeAxis.er = a;
        try {
            for (var _b = __values(fromEnum(this.af9)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.er = a;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.zoomSliderAxis.er = this.yAxis.er;
    };
    FinancialChart.prototype.aks = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                var e = c.series._inner[d];
                if (!(this.afq(e))) {
                    continue;
                }
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.akv = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            var c = this.volumeChart.series._inner[b];
            if (c.dd) {
                continue;
            }
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.akt = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.afs(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.aku = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.afs(d)) {
                continue;
            }
            var e = this.aht(d, c);
            a(d, e);
        }
        if (b) {
            this.akw(a);
        }
    };
    FinancialChart.prototype.akw = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            var c = this.zoomSliderChart.series._inner[b];
            if (c.dd) {
                continue;
            }
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.aht = function (a, b) {
        if (a.cc != this.dataChart) {
            return b;
        }
        var c = this.bd == null || this.bd.dataSeries == null ? 0 : this.bd.dataSeries.count;
        var d = this.aed == null ? 0 : this.aed.count;
        return b - (c * d);
    };
    FinancialChart.prototype.rr = function (a) {
        _super.prototype.rr.call(this, a);
        this.akv(a);
        this.aks(a);
        this.akw(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.ae8;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.ae8 = a;
                this.sr("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.all = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.afs(d) || d.dd) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.ad2;
            f = this.ad1(f);
            switch (f) {
                case 2:
                    e = this.ae3();
                    break;
                case 3:
                    e = this.ae1();
                    break;
                default:
                case 1:
                    e = this.ae2();
                    break;
            }
            this.aej.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.aej.setXAxis(e, this.volumeXAxis);
            this.aej.setYAxis(e, this.volumeAxis);
            this.aej.setValueMemberPath(e, this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > b ? this.bd.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.title = d.title + " Volume";
            e.o9 = ArrayExtension.getModulus$1(Brush.$, this.ada, b);
            e.pe = ArrayExtension.getModulus$1(Brush.$, this.adb, b);
            e.g4 = this.ag4;
            a.add(e);
        }
        var g = this.gk("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.r6(i, h);
        }
    };
    FinancialChart.prototype.afp = function (a) {
        if (!this.afl) {
            return false;
        }
        return this.aej.matchesType(a);
    };
    FinancialChart.prototype.aft = function (a) {
        if (!this.afo) {
            return false;
        }
        return this.aeh.matchesType(a);
    };
    FinancialChart.prototype.afq = function (a) {
        if (!this.afm) {
            return false;
        }
        return this.ael.matchesType(a);
    };
    FinancialChart.prototype.afs = function (a) {
        if (!this.afn) {
            return false;
        }
        return this.aeq.matchesType(a);
    };
    FinancialChart.prototype.alk = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.aeb == null ? 0 : this.aeb.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.aeb._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.afs(l) || l.dd) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.ae5("Custom");
                    this.ael.handleCustomIndicatorEvent(n, runOn(this, this.aky));
                    m = n;
                }
                else {
                    m = this.ae7(this.aeb._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ael.setXAxis(m, this.agb._inner[e]);
                this.ael.setYAxis(m, this.af9._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ael.setOpenMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(11));
                this.ael.setHighMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(12));
                this.ael.setLowMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(13));
                this.ael.setCloseMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(14));
                this.ael.setVolumeMemberPath(m, this.bd.dataSeries._inner[j].getMemberPathFor(15));
                m.title = l.title + " " + i;
                m.o9 = ArrayExtension.getModulus$1(Brush.$, this.ac4, e);
                m.g4 = this.ag0;
                if (this.afq(m)) {
                    this.ael.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.ac5, e));
                    this.ael.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.aen, e));
                }
                if (this.ahv != -2147483648 && this.afq(m)) {
                    this.ael.setPeriodOverride(m, this.ahv);
                }
                if (this.afq(m)) {
                    this.ael.setSmoothingPeriod(m, this.ahy);
                }
                if (this.afq(m)) {
                    this.ael.setSignalPeriod(m, this.ahx);
                }
                if (this.afq(m)) {
                    this.ael.setShortPeriod(m, this.ahw);
                    this.ael.setLongPeriod(m, this.ahu);
                }
                this.r6(m, e);
                f.add(m);
            }
            var o = this.gk(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.r6(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.ae5 = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.ae7 = function (a) {
        return this.ae5(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.al2 = function (a) {
        if (this.adv == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.adv.as = b.actualMinimumValue;
        this.adv.ar = b.actualMaximumValue;
        if (a) {
            this.adv.au = b.visibleMinimum;
            this.adv.at = b.visibleMaximum;
        }
        this.adv.bn();
    };
    FinancialChart.prototype.j6 = function () {
        var e_6, _a, e_7, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.j6.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.vx();
            $ret.toolbar = _this.adv == null ? null : _this.adv.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.vx();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.vx());
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.amb(this.dataChart).x;
            a.mainChartTop = this.amb(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.amb(this.volumeChart).x;
            a.volumeChartTop = this.amb(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.amb(this.zoomSliderChart).x;
            a.zoomChartTop = this.amb(this.zoomSliderChart).y;
        }
        if (this.adv != null) {
            var c = this.amc(this.adv);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.amb(d).x);
                    a.indicatorChartTops.add(this.amb(d).y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        var e = this.ame();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.aef == null ? null : this.aef.exportVisualData();
        return a;
    };
    FinancialChart.prototype.aik = function () {
        var a = this.j6();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.ae6 = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.al1 = function () {
        var e_8, _a, e_9, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.afs(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        if (this.aed == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.afs(g) || g.dd) {
                continue;
            }
            e++;
            for (var h = 0; h < this.aed.count; h++) {
                var i = this.aed._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.ae6(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.ae6(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.aeq.setXAxis(j, this.xAxis);
                this.aeq.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.aed.count + h;
                j.o9 = ArrayExtension.getModulus$1(Brush.$, this.ac8, k);
                j.pe = ArrayExtension.getModulus$1(Brush.$, this.ac9, k);
                j.g4 = this.ag2;
                j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.bd.dataSeries._inner[e];
                this.aeq.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.aeq.setHighMemberPath(j, m.getMemberPathFor(12));
                this.aeq.setLowMemberPath(j, m.getMemberPathFor(13));
                this.aeq.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.aeq.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].index = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.r6(q, p);
        }
    };
    FinancialChart.prototype.alz = function () {
        var e_10, _a;
        if (this.afy) {
            return;
        }
        this.afy = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.alf(b);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        if ((this.aeb == null || this.aeb.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.af9 != null) {
                this.af9.clear();
            }
            if (this.agb != null) {
                this.agb.clear();
            }
            this.alq();
            this.al0();
            this.afy = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.af9.clear();
        this.agb.clear();
        var c = this.aeb == null ? 0 : this.aeb.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.ald(g);
            var h = f >= c;
            if (h) {
                g.kh = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.kh = this.aim(this.aeb._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.cd) {
                        j = this.adh(0);
                    }
                    else {
                        j = this.adh(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.af9.add(i);
                this.agb.add(j);
                if (this.fg) {
                    this.aa8(i);
                }
                if (this.fg) {
                    this.aa6(j);
                }
            }
        }
        this.alk();
        this.alq();
        if (this.adv != null) {
            this.adv.ae = this.aeb;
        }
        this.ako();
        this.al0();
        this.afy = false;
    };
    FinancialChart.prototype.ry = function () {
        var e_11, _a, e_12, _b;
        _super.prototype.ry.call(this);
        this.aa6(this.xAxis);
        this.aa6(this.volumeXAxis);
        if (this.agb != null) {
            try {
                for (var _c = __values(fromEnum(this.agb)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.aa6(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.aa8(this.yAxis);
        this.aa8(this.volumeAxis);
        if (this.af9 != null) {
            try {
                for (var _e = __values(fromEnum(this.af9)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.aa8(b);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.aa6(this.zoomSliderXAxis);
        this.aa8(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_f5 = function () {
        return !this.afw;
    };
    Object.defineProperty(FinancialChart.prototype, "af4", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.al7 = function (a, b) {
        this.alt(a, b);
        this.ako();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.alm();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.alr();
        this.al8(a, b);
    };
    FinancialChart.prototype.alm = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.afs(c) || c.dd) {
                continue;
            }
            var d = void 0;
            var e = this.ad9;
            e = this.ad8(e);
            var f = this.aht(c, b);
            if (e == 1) {
                switch (this.adz(this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.ae4();
                    this.aeh.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.ae4();
                    this.aeh.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.ae3();
                    break;
                case 6:
                    d = this.ae1();
                    break;
                default:
                case 4:
                    d = this.ae2();
                    break;
            }
            var g = this.bd != null && this.bd.dataSeries != null && this.bd.dataSeries.count > f ? this.bd.dataSeries._inner[f] : null;
            if (d.dj && !d.ds) {
                this.aej.setCategoryMode(d, 1);
                this.aej.setXAxis(d, this.zoomSliderXAxis);
                this.aej.setYAxis(d, this.zoomSliderAxis);
                this.aej.setValueMemberPath(d, g == null ? null : this.ain(g));
            }
            else if (d.ds) {
                this.aeh.setCategoryMode(d, 1);
                this.aeh.setXAxis(d, this.zoomSliderXAxis);
                this.aeh.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.aeh.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.aeh.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.aeh.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.aeh.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.aeh.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.title = c.title;
            d.g4 = this.iy;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.r6(i, h);
        }
    };
    FinancialChart.prototype.sl = function (a, b, c) {
        var e_13, _a;
        _super.prototype.sl.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.aky = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.cc);
        }
        e -= this.aeb == null ? 0 : this.aeb.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.alv = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.fg) {
            this.aa6(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "af3", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.akz = function (a, b) {
        this.alz();
    };
    FinancialChart.prototype.afu = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.alp = function () {
        var e_14, _a;
        var a = this.adt != null ? this.adt : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.afu(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.ads = b;
        if (this.adv != null) {
            this.adv.u = this.ads;
        }
    };
    FinancialChart.prototype.ak3 = function (a, b) {
        this.alp();
    };
    FinancialChart.prototype.ak8 = function (a, b) {
        this.aed = this.adv.ag;
    };
    FinancialChart.prototype.ak7 = function (a, b) {
        this.aeb = this.adv.ae;
    };
    FinancialChart.prototype.ak1 = function (a, b) {
        this.alz();
    };
    FinancialChart.prototype.ak2 = function (a, b) {
        this.al1();
    };
    FinancialChart.prototype.alc = function (a, b) {
        var c = a;
        if (c.bf == null) {
            return;
        }
        if (this.afw) {
            this.alo(c.bf);
        }
    };
    FinancialChart.prototype.alf = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.ak0));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.er = this.volumeAxis.er = this.indicatorAxis.er = 0;
            this.xAxis.ay.visibility = this.acu;
        }
    };
    FinancialChart.prototype.ald = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.tq = new Rect(0, this.dataChart.ta.x, a.tq.y, this.dataChart.ta.width, a.tq.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.ak0));
        this.r0(a);
    };
    FinancialChart.prototype.ako = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.aa4(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.agb._inner[a];
            var c = a < this_1.agb.count - 1 || this_1.volumeChart != null;
            this_1.aa4(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.agb.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.alt = function (a, b) {
        if (a != null) {
            this.alf(a);
        }
        if (b != null) {
            this.ald(b);
        }
    };
    FinancialChart.prototype.al5 = function (a, b) {
        this.alt(a, b);
        this.ako();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.all();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.al6(a, b);
    };
    FinancialChart.prototype.ak4 = function (a, b) {
        this.al3();
    };
    FinancialChart.prototype.al3 = function () {
        if (this.adv == null || +(this.adv.au) == +(dateMaxValue()) || +(this.adv.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.adv.au, this.adv.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.afx = true;
        this.dataChart.tq = new Rect(0, b.left, this.dataChart.tq.top, b.width, this.dataChart.tq.height);
        if (this.afd != null) {
            this.afd.windowRect = this.dataChart.ta;
        }
        if (this.afw) {
            this.alo(this.dataChart);
        }
        this.afx = false;
    };
    FinancialChart.prototype.alb = function (a, b) {
        this.alp();
        this.al2(!this.afx);
    };
    FinancialChart.prototype.akx = function (a, b) {
        var _this = this;
        if (!this.afx) {
            if (this.afw) {
                this.alo(a);
            }
            var c = false;
            var d = this.sy(function () { return _this.al2(true); }, c);
            c = d.p1;
            if (this.afd != null) {
                this.afd.windowRect = this.dataChart.ta;
            }
        }
    };
    FinancialChart.prototype.alx = function (a, b, c, d) {
        var e_15, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.afx = true;
            a.tq = new Rect(0, d, a.ta.top, c, a.ta.height);
            this.afx = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.cg, a.te);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.gg();
                var j = i.ar(a.ta);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.ei(j.c, h);
                var m = b.ei(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        var n = a.ta.width;
        if (c != -1) {
            n = c;
        }
        var o = a.ta.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.afx = true;
        var p = new Rect(0, o, e, n, f - e);
        a.tq = p;
        this.afx = false;
    };
    FinancialChart.prototype.alw = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.alx(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.alx(this.volumeChart, this.volumeAxis, this.dataChart.ta.width, this.dataChart.ta.left);
            }
        }
        else if (a == this.volumeChart) {
            this.alx(this.volumeChart, this.volumeAxis, -1, -1);
            this.alx(this.dataChart, this.yAxis, this.volumeChart.ta.width, this.volumeChart.ta.left);
        }
    };
    FinancialChart.prototype.alo = function (a) {
        var _this = this;
        this.sx(function () { return _this.alw(a); });
    };
    FinancialChart.prototype.ak5 = function (a, b) {
        if (this.afw) {
            this.alo(a);
        }
    };
    FinancialChart.prototype.al4 = function () {
        if (!this.af4) {
            return;
        }
        this.akr();
        if (this.ad9 == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.alm();
        }
    };
    FinancialChart.prototype.akr = function () {
        var container_ = this.ahl.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.afd != null && containerParent_ != null && !this.af5) {
            this.af5 = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.afd;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.aly = function () {
        var _this = this;
        if (this.ad4 != 1) {
            return;
        }
        this.aba(function (a) {
            var e_16, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        });
    };
    FinancialChart.prototype.tj = function (a, b, c) {
        _super.prototype.tj.call(this, a, b, c);
        if (this.bd.dataSeries.count > 0) {
            if (this.ad4 == 1 && stringIsNullOrEmpty(this.li)) {
                this.b3.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.lk)) {
                this.b3.setYMemberPath(a, this.ain(c));
            }
            if (stringIsNullOrEmpty(this.le)) {
                this.b3.setLabelMemberPath(a, this.ain(c));
            }
            if (stringIsNullOrEmpty(this.lb)) {
                this.b3.setContentMemberPath(a, this.ain(c));
            }
        }
    };
    FinancialChart.prototype.aim = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.aa6 = function (a) {
        var e_17, _a;
        var _this = this;
        _super.prototype.aa6.call(this, a);
        var b = a;
        this.ale(b);
        if (a.bf != null) {
            try {
                for (var _b = __values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.afp(c)) {
                        this.aej.setXAxis(c, b);
                    }
                    else if (this.aft(c)) {
                        this.aeh.setXAxis(c, b);
                    }
                    else if (this.afq(c)) {
                        this.ael.setXAxis(c, b);
                    }
                    else if (this.afs(c)) {
                        this.aeq.setXAxis(c, b);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        this.ali(function (d) {
            d.zoomMaximumCategoryRange = _this.ag5;
            d.zoomMaximumItemSpan = _this.ag6;
            d.zoomToCategoryRange = _this.ag7;
            d.zoomToCategoryStart = _this.ag8;
            d.zoomToItemSpan = _this.ag9;
        });
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.jv = this.ama;
            a.eq = this.ahg;
            this.aa4(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.agh;
        e.maximumValue = this.agg;
        a.b0 = this.afz;
    };
    FinancialChart.prototype.aa8 = function (a) {
        var e_18, _a;
        _super.prototype.aa8.call(this, a);
        if (a.bf != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.afp(b)) {
                        this.aej.setYAxis(b, this.yAxis);
                    }
                    else if (this.aft(b)) {
                        this.aeh.setYAxis(b, this.yAxis);
                    }
                    else if (this.afq(b)) {
                        this.ael.setYAxis(b, this.yAxis);
                    }
                    else if (this.afs(b)) {
                        this.aeq.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        a.k9 = this.af0;
        a.l4 = this.ahe;
        a.l3 = this.ahd;
        if (a == this.yAxis) {
            a.l0 = this.ahc;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.aa4(a, function (d) { return d.visibility = 1; });
        }
        a.b0 = this.af1;
    };
    FinancialChart.prototype.ale = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.fz = XYChart.yt(a, this.bd.dataSeries);
        if (this.bd.dataSeries.count > 0) {
            var b = this.bd.dataSeries._inner[0].getMemberPathFor(17);
            a.hx(b);
        }
    };
    FinancialChart.prototype.r6 = function (a, b) {
        _super.prototype.r6.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.cc;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.d6) {
            a.ms(this.ac6 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac6, b) : null, this.ac7 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac7, b) : null);
        }
        var e = this.afq(a);
        if (this.afs(a)) {
            a.o9 = this.ac8 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac8, b) : null;
            a.pe = this.ac9 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac9, b) : null;
            a.g4 = this.ag2;
        }
        else if (e) {
            a.o9 = this.ac4 != null ? ArrayExtension.getModulus$1(Brush.$, this.ac4, b) : null;
            a.g4 = this.ag0;
        }
        else if (!a.dd && (d || c)) {
            a.o9 = this.ab != null ? ArrayExtension.getModulus$1(Brush.$, this.ab, b) : null;
            a.pe = this.af != null ? ArrayExtension.getModulus$1(Brush.$, this.af, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.cc;
        if (f) {
            a.g4 = this.ag4;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.afr ? this.aef : null;
    };
    FinancialChart.prototype.sr = function (a, b, c) {
        var e_19, _a, e_20, _b;
        var _this = this;
        _super.prototype.sr.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.lh = this.af2;
                if (this.volumeAxis != null) {
                    this.volumeAxis.lh = this.af2;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.lh = this.af2;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.l8 = this.ah0;
                if (this.volumeAxis != null) {
                    this.volumeAxis.l8 = this.ah0;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.l8 = this.ah0;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.ad2 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.all();
                }
                break;
            case "VolumeChart":
                this.al5(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.ak0));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.akx));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.ak5));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.ak0));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.akx));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.ak5));
                }
                this.al4();
                break;
            case "XAxisMode":
                this.xAxis = this.adh(this.ad4);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.adh(this.ad4);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.adh(this.ad4);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.adh(this.ad4);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.aa4(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.ako();
                if (this.ad4 == 1) {
                    this.aly();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.aev(this.ad6);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.aev(this.ad6);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.aev(this.ad6);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.ak4));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.ak7));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.ak8));
                }
                if (this.adv != null) {
                    this.adv.ae = this.aeb;
                    this.adv.ag = this.aed;
                    this.adv.u = this.ads;
                    this.al2(true);
                    var j = this.adv;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.ak4));
                    var k = this.adv;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.ak7));
                    var l = this.adv;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.ak8));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.alb));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.fg) {
                    this.aa6(this.xAxis);
                    this.ro();
                }
                this.al2(false);
                this.al3();
                this.alp();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.alb));
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.ali(function (p) { return p.zoomMaximumCategoryRange = _this.ag5; });
                break;
            case "XAxisZoomMaximumItemSpan":
                this.ali(function (p) { return p.zoomMaximumItemSpan = _this.ag6; });
                break;
            case "XAxisZoomToCategoryRange":
                this.ali(function (p) { return p.zoomToCategoryRange = _this.ag7; });
                break;
            case "XAxisZoomToCategoryStart":
                this.ali(function (p) { return p.zoomToCategoryStart = _this.ag8; });
                break;
            case "XAxisZoomToItemSpan":
                this.ali(function (p) { return p.zoomToItemSpan = _this.ag9; });
                break;
            case "ChartType":
                this.td();
                break;
            case "VolumeXAxis":
                this.alv(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.alv(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.alz();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.fg) {
                    this.aa8(this.yAxis);
                    this.aa8(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.alc));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.all();
                }
                if (this.fg) {
                    this.aa8(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.alc));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_19 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        try {
                            for (var _e = (e_20 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_20_1) {
                            e_20 = { error: e_20_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_20)
                                    throw e_20.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.ad6 == 1) {
                            y = this.aev(this.ad6);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.fg) {
                            this.aa8(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.uo = this.f6 && this.f5;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.uo = this.f6 && this.f5;
                }
                if (this.afw) {
                    this.alw(this.dataChart);
                }
                else {
                    this.volumeChart.vv = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.ak1));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.ak1));
                }
                this.alz();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.ak2));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.ak2));
                }
                this.al1();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.abf(function (ad) { return ad.k9 = _this.af0; });
                break;
            case "YAxisMinimumValue":
                this.abg(function (ad) { return ad.l4 = _this.ahe; }, false);
                break;
            case "YAxisMaximumValue":
                this.abg(function (ad) { return ad.l3 = _this.ahd; }, false);
                break;
            case "YAxisInterval":
                this.abg(function (ad) { return ad.l0 = _this.ahc; }, false);
                break;
            case "Thickness":
            case "ZoomSliderType":
                this.al4();
                break;
            case "ZoomSliderChart":
                if (!this.af3) {
                    return;
                }
                this.al7(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.aku(function (ad, ae) {
                    if (ad.d6) {
                        ad.ms(_this.ac6 != null ? ArrayExtension.getModulus$1(Brush.$, _this.ac6, ae) : null, _this.ac7 != null ? ArrayExtension.getModulus$1(Brush.$, _this.ac7, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.akt(function (ad, ae) { return ad.o9 = _this.ac8 != null ? ArrayExtension.getModulus$1(Brush.$, _this.ac8, ae) : null; });
                break;
            case "OverlayOutlines":
                this.akt(function (ad, ae) { return ad.pe = _this.ac9 != null ? ArrayExtension.getModulus$1(Brush.$, _this.ac9, ae) : null; });
                break;
            case "OverlayThickness":
                this.akt(function (ad, ae) { return ad.g4 = _this.ag2; });
                break;
            case "OverlayMultiplier":
                this.akt(function (ad, ae) { return _this.aeq.setMultiplier(ad, _this.ag1); });
                break;
            case "VolumeBrushes":
                this.akv(function (ad, ae) { return ad.o9 = ArrayExtension.getModulus$1(Brush.$, _this.ada, ae); });
                break;
            case "VolumeOutlines":
                this.akv(function (ad, ae) { return ad.pe = ArrayExtension.getModulus$1(Brush.$, _this.adb, ae); });
                break;
            case "VolumeThickness":
                this.akv(function (ad, ae) { return ad.g4 = _this.ag4; });
                break;
            case "IndicatorNegativeBrushes":
                this.aks(function (ad, ae) { return _this.ael.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.ac5, ae)); });
                break;
            case "IndicatorBrushes":
                this.aks(function (ad, ae) { return ad.o9 = ArrayExtension.getModulus$1(Brush.$, _this.ac4, ae); });
                break;
            case "IndicatorThickness":
                this.aks(function (ad, ae) { return ad.g4 = _this.ag0; });
                break;
            case "IndicatorDisplayTypes":
                this.aks(function (ad, ae) { return _this.ael.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.aen, ae)); });
                break;
            case "IndicatorPeriod":
                this.aks(function (ad, ae) {
                    if (_this.ahv == -2147483648) {
                        return;
                    }
                    _this.ael.setPeriodOverride(ad, _this.ahv);
                });
                break;
            case "IndicatorMultiplier":
                this.aks(function (ad, ae) { return _this.ael.setMultiplier(ad, _this.agz); });
                break;
            case "IndicatorSmoothingPeriod":
                this.aks(function (ad, ae) { return _this.ael.setSmoothingPeriod(ad, _this.ahy); });
                break;
            case "IndicatorShortPeriod":
                this.aks(function (ad, ae) { return _this.ael.setShortPeriod(ad, _this.ahw); });
                break;
            case "IndicatorLongPeriod":
                this.aks(function (ad, ae) { return _this.ael.setLongPeriod(ad, _this.ahu); });
                break;
            case "IndicatorSignalPeriod":
                this.aks(function (ad, ae) { return _this.ael.setSignalPeriod(ad, _this.ahx); });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.ak3));
                }
                if (this.adt != null) {
                    var ae = this.adt;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.ak3));
                }
                this.alp();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.akz));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.akz));
                }
                this.alz();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.aku(function (ah, ai) { return ah.o9 = _this.ab != null ? ArrayExtension.getModulus$1(Brush.$, _this.ab, ai) : null; }, true);
                break;
            case "Outlines":
                this.aku(function (ah, ai) { return ah.pe = _this.af != null ? ArrayExtension.getModulus$1(Brush.$, _this.af, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.acu == 0 && this.zoomSliderXAxis != null) {
                    this.aa4(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.ako();
                break;
            case "YAxisLabelVisibility":
                if (this.acv != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.aa4(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.jv = this.ama;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.eq = this.ahg;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.afr && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.aef : null;
                        }
                    };
                    this.aku(ai, false);
                    this.akt(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.alm();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.fg) {
                        this.aa8(this.zoomSliderAxis);
                    }
                    this.aa4(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.aba(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.agh;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.aba(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.agg;
                    }
                });
                break;
            case FinancialChart.ajv:
                this.abb(function (ak) { return ak.b0 = _this.afz; }, a);
                break;
            case FinancialChart.aj6:
                this.abf(function (ak) { return ak.b0 = _this.af1; });
                break;
        }
    };
    FinancialChart.prototype.get_b1 = function () {
        return 1;
    };
    Object.defineProperty(FinancialChart.prototype, "b1", {
        get: function () {
            return this.get_b1();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af2", {
        get: function () {
            return this.afk;
        },
        set: function (a) {
            var b = this.af2;
            if (a != b) {
                this.afk = a;
                this.sr("YAxisIsLogarithmic", b, this.af2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ah0", {
        get: function () {
            return this.ahs;
        },
        set: function (a) {
            var b = this.ah0;
            if (a != b) {
                this.ahs = a;
                this.sr("YAxisLogarithmBase", b, this.ah0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahc", {
        get: function () {
            return this.agt;
        },
        set: function (a) {
            var b = this.ahc;
            if (a != b) {
                this.agt = a;
                this.sr("YAxisInterval", b, this.ahc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahe", {
        get: function () {
            return this.agv;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.agv = a;
                this.sr("YAxisMinimumValue", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahd", {
        get: function () {
            return this.agu;
        },
        set: function (a) {
            var b = this.ahd;
            if (a != b) {
                this.agu = a;
                this.sr("YAxisMaximumValue", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahf", {
        get: function () {
            return this.agw;
        },
        set: function (a) {
            var b = this.ahf;
            if (a != b) {
                this.agw = a;
                this.sr("YAxisMinorInterval", b, this.ahf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahb", {
        get: function () {
            return this.yAxis.lw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aha", {
        get: function () {
            return this.yAxis.lv;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad2", {
        get: function () {
            return this.ad0;
        },
        set: function (a) {
            var b = this.ad2;
            if (a != b) {
                this.ad0 = a;
                this.sr("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ad2));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad4", {
        get: function () {
            return this.ad3;
        },
        set: function (a) {
            var b = this.ad4;
            if (a != b) {
                this.ad3 = a;
                this.sr("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.ad4));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag5", {
        get: function () {
            return this.ago;
        },
        set: function (a) {
            var b = this.ag5;
            if (a != b) {
                this.ago = a;
                this.sr("XAxisZoomMaximumCategoryRange", b, this.ag5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag8", {
        get: function () {
            return this.agr;
        },
        set: function (a) {
            var b = this.ag8;
            if (a != b) {
                this.agr = a;
                this.sr("XAxisZoomToCategoryStart", b, this.ag8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag6", {
        get: function () {
            return this.agp;
        },
        set: function (a) {
            var b = this.ag6;
            if (a != b) {
                this.agp = a;
                this.sr("XAxisZoomMaximumItemSpan", b, this.ag6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag7", {
        get: function () {
            return this.agq;
        },
        set: function (a) {
            var b = this.ag7;
            if (a != b) {
                this.agq = a;
                this.sr("XAxisZoomToCategoryRange", b, this.ag7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag9", {
        get: function () {
            return this.ags;
        },
        set: function (a) {
            var b = this.ag9;
            if (a != b) {
                this.ags = a;
                this.sr("XAxisZoomToItemSpan", b, this.ag9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad6", {
        get: function () {
            return this.ad5;
        },
        set: function (a) {
            var b = this.ad6;
            if (a != b) {
                this.ad5 = a;
                this.sr("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.ad6));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afv", {
        get: function () {
            return this.aff;
        },
        set: function (a) {
            var b = this.afv;
            if (a != b) {
                this.aff = a;
                this.sr("IsToolbarVisible", b, this.afv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adx", {
        get: function () {
            return this.adw;
        },
        set: function (a) {
            var b = this.adx;
            if (a != b) {
                this.adw = a;
                this.sr("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.adx));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_abp = function () {
        return _super.prototype.get_abp.call(this);
    };
    FinancialChart.prototype.set_abp = function (a) {
        _super.prototype.set_abp.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "afw", {
        get: function () {
            return this.afg;
        },
        set: function (a) {
            var b = this.afw;
            if (a != b) {
                this.afg = a;
                this.sr("IsWindowSyncedToVisibleRange", b, this.afw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aeb", {
        get: function () {
            return this.aea;
        },
        set: function (a) {
            var b = this.aeb;
            if (a != b) {
                this.aea = a;
                this.sr("IndicatorTypes", b, this.aeb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aed", {
        get: function () {
            return this.aec;
        },
        set: function (a) {
            var b = this.aed;
            if (a != b) {
                this.aec = a;
                this.sr("OverlayTypes", b, this.aed);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.af7;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.af7 = a;
                this.sr("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af0", {
        get: function () {
            return this.afi;
        },
        set: function (a) {
            var b = this.af0;
            if (a != b) {
                this.afi = a;
                this.sr("YAxisAbbreviateLargeNumbers", b, this.af0);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_is = function () {
        return _super.prototype.get_is.call(this);
    };
    FinancialChart.prototype.set_is = function (a) {
        _super.prototype.set_is.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "afz", {
        get: function () {
            return this.afh;
        },
        set: function (a) {
            var b = this.afz;
            if (a != b) {
                this.afh = a;
                this.sr(FinancialChart.ajv, b, this.afz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af1", {
        get: function () {
            return this.afj;
        },
        set: function (a) {
            var b = this.af1;
            if (a != b) {
                this.afj = a;
                this.sr(FinancialChart.aj6, b, this.af1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.ae9;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.ae9 = a;
                this.sr("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.aeu;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.aeu = a;
                this.sr("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.adf;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.adf = a;
                this.sr("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad9", {
        get: function () {
            return this.ad7;
        },
        set: function (a) {
            var b = this.ad9;
            if (a != b) {
                this.ad7 = a;
                this.sr("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.ad9));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac6", {
        get: function () {
            return this.acy;
        },
        set: function (a) {
            var b = this.ac6;
            if (a != b) {
                this.acy = a;
                this.sr("NegativeBrushes", b, this.ac6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac7", {
        get: function () {
            return this.acz;
        },
        set: function (a) {
            var b = this.ac7;
            if (a != b) {
                this.acz = a;
                this.sr("NegativeOutlines", b, this.ac7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac8", {
        get: function () {
            return this.ac0;
        },
        set: function (a) {
            var b = this.ac8;
            if (a != b) {
                this.ac0 = a;
                this.sr("OverlayBrushes", b, this.ac8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac9", {
        get: function () {
            return this.ac1;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ac1 = a;
                this.sr("OverlayOutlines", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adb", {
        get: function () {
            return this.ac3;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ac3 = a;
                this.sr("VolumeOutlines", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ada", {
        get: function () {
            return this.ac2;
        },
        set: function (a) {
            var b = this.ada;
            if (a != b) {
                this.ac2 = a;
                this.sr("VolumeBrushes", b, this.ada);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac5", {
        get: function () {
            return this.acx;
        },
        set: function (a) {
            var b = this.ac5;
            if (a != b) {
                this.acx = a;
                this.sr("IndicatorNegativeBrushes", b, this.ac5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac4", {
        get: function () {
            return this.acw;
        },
        set: function (a) {
            var b = this.ac4;
            if (a != b) {
                this.acw = a;
                this.sr("IndicatorBrushes", b, this.ac4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag4", {
        get: function () {
            return this.agn;
        },
        set: function (a) {
            var b = this.ag4;
            if (a != b) {
                this.agn = a;
                this.sr("VolumeThickness", b, this.ag4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag2", {
        get: function () {
            return this.agl;
        },
        set: function (a) {
            var b = this.ag2;
            if (a != b) {
                this.agl = a;
                this.sr("OverlayThickness", b, this.ag2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag1", {
        get: function () {
            return this.agk;
        },
        set: function (a) {
            var b = this.ag1;
            if (a != b) {
                this.agk = a;
                this.sr("OverlayMultiplier", b, this.ag1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ag0", {
        get: function () {
            return this.agj;
        },
        set: function (a) {
            var b = this.ag0;
            if (a != b) {
                this.agj = a;
                this.sr("IndicatorThickness", b, this.ag0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aen", {
        get: function () {
            return this.aem;
        },
        set: function (a) {
            var b = this.aen;
            if (a != b) {
                this.aem = a;
                this.sr("IndicatorDisplayTypes", b, this.aen);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahv", {
        get: function () {
            return this.aho;
        },
        set: function (a) {
            var b = this.ahv;
            if (a != b) {
                this.aho = a;
                this.sr("IndicatorPeriod", b, this.ahv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agz", {
        get: function () {
            return this.agi;
        },
        set: function (a) {
            var b = this.agz;
            if (a != b) {
                this.agi = a;
                this.sr("IndicatorMultiplier", b, this.agz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahy", {
        get: function () {
            return this.ahr;
        },
        set: function (a) {
            var b = this.ahy;
            if (a != b) {
                this.ahr = a;
                this.sr("IndicatorSmoothingPeriod", b, this.ahy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahw", {
        get: function () {
            return this.ahp;
        },
        set: function (a) {
            var b = this.ahw;
            if (a != b) {
                this.ahp = a;
                this.sr("IndicatorShortPeriod", b, this.ahw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahu", {
        get: function () {
            return this.ahn;
        },
        set: function (a) {
            var b = this.ahu;
            if (a != b) {
                this.ahn = a;
                this.sr("IndicatorLongPeriod", b, this.ahu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahx", {
        get: function () {
            return this.ahq;
        },
        set: function (a) {
            var b = this.ahx;
            if (a != b) {
                this.ahq = a;
                this.sr("IndicatorSignalPeriod", b, this.ahx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adt", {
        get: function () {
            return this.adr;
        },
        set: function (a) {
            var b = this.adt;
            if (a != b) {
                this.adr = a;
                this.sr("RangeSelectorOptions", b, this.adt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.adn;
            if (a != b) {
                this.adn = a;
                this.sr("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_f6 = function () {
        return _super.prototype.get_f6.call(this);
    };
    FinancialChart.prototype.set_f6 = function (a) {
        _super.prototype.set_f6.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ama", {
        get: function () {
            return this.al9;
        },
        set: function (a) {
            var b = this.ama;
            if (a != b) {
                this.al9 = a;
                this.sr("ZoomSliderXAxisMajorStroke", b, this.ama);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahg", {
        get: function () {
            return this.agx;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.agx = a;
                this.sr("ZoomSliderXAxisMajorStrokeThickness", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afr", {
        get: function () {
            return this.afe;
        },
        set: function (a) {
            var b = this.afr;
            if (a != b) {
                this.afe = a;
                this.sr("IsLegendVisible", b, this.afr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aef", {
        get: function () {
            return this.aee;
        },
        set: function (a) {
            var b = this.aef;
            if (a != b) {
                this.aee = a;
                this.sr("FinancialChartLegend", b, this.aef);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.ade;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.ade = a;
                this.sr("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.aet;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.aet = a;
                this.sr("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.aes;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.aes = a;
                this.sr("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.add;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.add = a;
                this.sr("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.aer;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.aer = a;
                this.sr("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.adc;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.adc = a;
                this.sr("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "af9", {
        get: function () {
            return this.af6;
        },
        set: function (a) {
            var b = this.af9;
            if (a != b) {
                this.af6 = a;
                this.sr("IndicatorAxes", b, this.af9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agb", {
        get: function () {
            return this.af8;
        },
        set: function (a) {
            var b = this.agb;
            if (a != b) {
                this.af8 = a;
                this.sr("IndicatorXAxes", b, this.agb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agh", {
        get: function () {
            return this.agf;
        },
        set: function (a) {
            var b = this.agh;
            if (+a != +b) {
                this.agf = a;
                this.sr("XAxisMinimumValue", b, this.agh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agg", {
        get: function () {
            return this.age;
        },
        set: function (a) {
            var b = this.agg;
            if (+a != +b) {
                this.age = a;
                this.sr("XAxisMaximumValue", b, this.agg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.agc;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ahz = 0;
    FinancialChart.ajv = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.aj6 = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.aib : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.ah8 : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.ah9 : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_21, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
