/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.v1 = null;
        _this.v2 = null;
        _this.wi = 0;
        _this.wk = 5;
        _this.wj = 0;
        _this.wh = 5;
        _this.wz = 5;
        _this.w1 = 0;
        _this.w0 = 5;
        _this.wy = 0;
        _this.abs = null;
        _this.abz = null;
        _this.abq = null;
        _this.abr = null;
        _this.wt = 0;
        _this.xa = 0;
        _this.ws = NaN;
        _this.w9 = NaN;
        _this.wv = NaN;
        _this.xc = NaN;
        _this.wu = NaN;
        _this.xb = NaN;
        _this.wr = NaN;
        _this.w8 = NaN;
        _this.aby = null;
        _this.ab5 = null;
        _this.yk = null;
        _this.yo = null;
        _this.ym = null;
        _this.yq = null;
        _this.yf = null;
        _this.yg = null;
        _this.abt = null;
        _this.ab0 = null;
        _this.wl = DeviceUtils.g(1);
        _this.w2 = DeviceUtils.g(1);
        _this.wm = DeviceUtils.g(1);
        _this.w3 = DeviceUtils.g(1);
        _this.abv = null;
        _this.ab2 = null;
        _this.abw = null;
        _this.ab3 = null;
        _this.wn = DeviceUtils.g(1);
        _this.w4 = DeviceUtils.g(1);
        _this.wo = DeviceUtils.g(8);
        _this.w5 = 0;
        _this.abx = null;
        _this.ab4 = null;
        _this.wp = DeviceUtils.g(1);
        _this.w6 = DeviceUtils.g(1);
        _this.yl = null;
        _this.yp = null;
        _this.abu = null;
        _this.ab1 = null;
        _this.wg = 0;
        _this.wx = 0;
        _this.wf = NaN;
        _this.ww = NaN;
        _this.wq = 0;
        _this.w7 = -90;
        _this.wb = false;
        _this.wc = false;
        _this.abl = 1;
        _this.aco = 1;
        _this.abk = 1;
        _this.abm = 2;
        _this.acm = 0;
        _this.acn = 1;
        _this.acs = 0;
        _this.act = 0;
        _this.v9 = 4;
        _this.v7 = 4;
        _this.yj = null;
        _this.vv = null;
        _this.yn = null;
        _this.vw = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.vz();
            var c = this.v0();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.r5 = function () {
        _super.prototype.r5.call(this);
        var a = this.vz();
        var b = this.v0();
        if (a != null && a.ay != null) {
            this.ab8 = a.ay.textColor;
        }
        if (b != null && b.ay != null) {
            this.acf = b.ay.textColor;
        }
        this.acd = AxisDefaults.j;
        this.ack = AxisDefaults.j;
        this.ab9 = AxisDefaults.h;
        this.acg = AxisDefaults.h;
        this.acc = AxisDefaults.g;
        this.acj = AxisDefaults.g;
    };
    XYChart.prototype.su = function (a, b, c) {
        var _this = this;
        _super.prototype.su.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.abc(function (d) { return d.leftMargin = _this.xk; });
                break;
            case "XAxisLabelTopMargin":
                this.abc(function (d) { return d.topMargin = _this.xm; });
                break;
            case "XAxisLabelRightMargin":
                this.abc(function (d) { return d.rightMargin = _this.xl; });
                break;
            case "XAxisLabelBottomMargin":
                this.abc(function (d) { return d.bottomMargin = _this.xj; });
                break;
            case "YAxisLabelLeftMargin":
                this.abh(function (d) { return d.leftMargin = _this.x1; });
                break;
            case "YAxisLabelTopMargin":
                this.abh(function (d) { return d.topMargin = _this.x3; });
                break;
            case "YAxisLabelRightMargin":
                this.abh(function (d) { return d.rightMargin = _this.x2; });
                break;
            case "YAxisLabelBottomMargin":
                this.abh(function (d) { return d.bottomMargin = _this.x0; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.ab6 = this.u2(this.ab8);
                this.ab7 = this.u2(this.acf);
                break;
            case "XAxisLabelTextColor":
                this.ab6 = this.u2(this.ab8);
                break;
            case "YAxisLabelTextColor":
                this.ab7 = this.u2(this.acf);
                break;
            case "ActualXAxisLabelTextColor":
                this.abc(function (d) { return d.textColor = _this.ab6; });
                break;
            case "ActualYAxisLabelTextColor":
                this.abh(function (d) { return d.textColor = _this.ab7; });
                break;
            case "XAxisTitleMargin":
                this.abe(function (d) { return d.margin = _this.xv; });
                break;
            case "YAxisTitleMargin":
                this.abj(function (d) { return d.margin = _this.yc; });
                break;
            case "XAxisTitleLeftMargin":
                this.abe(function (d) { return d.leftMargin = _this.xu; });
                break;
            case "YAxisTitleLeftMargin":
                this.abj(function (d) { return d.leftMargin = _this.yb; });
                break;
            case "XAxisTitleTopMargin":
                this.abe(function (d) { return d.topMargin = _this.xx; });
                break;
            case "YAxisTitleTopMargin":
                this.abj(function (d) { return d.topMargin = _this.ye; });
                break;
            case "XAxisTitleRightMargin":
                this.abe(function (d) { return d.rightMargin = _this.xw; });
                break;
            case "YAxisTitleRightMargin":
                this.abj(function (d) { return d.rightMargin = _this.yd; });
                break;
            case "XAxisTitleBottomMargin":
                this.abe(function (d) { return d.bottomMargin = _this.xt; });
                break;
            case "YAxisTitleBottomMargin":
                this.abj(function (d) { return d.bottomMargin = _this.ya; });
                break;
            case "XAxisTitleTextColor":
                this.abe(function (d) { return d.textColor = _this.ace; });
                break;
            case "YAxisTitleTextColor":
                this.abj(function (d) { return d.textColor = _this.acl; });
                break;
            case "XAxisFormatLabel":
                this.aba(function (d) { return d.at = _this.v3; });
                break;
            case "YAxisFormatLabel":
                this.abf(function (d) { return d.at = _this.v4; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "v3", {
        get: function () {
            return this.v1;
        },
        set: function (a) {
            var b = this.v3;
            if (a != b) {
                this.v1 = a;
                this.sr("XAxisFormatLabel", b, this.v3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "v4", {
        get: function () {
            return this.v2;
        },
        set: function (a) {
            var b = this.v4;
            if (a != b) {
                this.v2 = a;
                this.sr("YAxisFormatLabel", b, this.v4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xk", {
        get: function () {
            return this.wi;
        },
        set: function (a) {
            var b = this.xk;
            if (a != b) {
                this.wi = a;
                this.sr("XAxisLabelLeftMargin", b, this.xk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xm", {
        get: function () {
            return this.wk;
        },
        set: function (a) {
            var b = this.xm;
            if (a != b) {
                this.wk = a;
                this.sr("XAxisLabelTopMargin", b, this.xm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xl", {
        get: function () {
            return this.wj;
        },
        set: function (a) {
            var b = this.xl;
            if (a != b) {
                this.wj = a;
                this.sr("XAxisLabelRightMargin", b, this.xl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xj", {
        get: function () {
            return this.wh;
        },
        set: function (a) {
            var b = this.xj;
            if (a != b) {
                this.wh = a;
                this.sr("XAxisLabelBottomMargin", b, this.xj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x1", {
        get: function () {
            return this.wz;
        },
        set: function (a) {
            var b = this.x1;
            if (a != b) {
                this.wz = a;
                this.sr("YAxisLabelLeftMargin", b, this.x1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x3", {
        get: function () {
            return this.w1;
        },
        set: function (a) {
            var b = this.x3;
            if (a != b) {
                this.w1 = a;
                this.sr("YAxisLabelTopMargin", b, this.x3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x2", {
        get: function () {
            return this.w0;
        },
        set: function (a) {
            var b = this.x2;
            if (a != b) {
                this.w0 = a;
                this.sr("YAxisLabelRightMargin", b, this.x2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x0", {
        get: function () {
            return this.wy;
        },
        set: function (a) {
            var b = this.x0;
            if (a != b) {
                this.wy = a;
                this.sr("YAxisLabelBottomMargin", b, this.x0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab8", {
        get: function () {
            return this.abs;
        },
        set: function (a) {
            var b = this.ab8;
            if (a != b) {
                this.abs = a;
                this.sr("XAxisLabelTextColor", b, this.ab8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acf", {
        get: function () {
            return this.abz;
        },
        set: function (a) {
            var b = this.acf;
            if (a != b) {
                this.abz = a;
                this.sr("YAxisLabelTextColor", b, this.acf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab6", {
        get: function () {
            return this.abq;
        },
        set: function (a) {
            var b = this.abq;
            if (a != b) {
                this.abq = a;
                this.sr("ActualXAxisLabelTextColor", b, this.ab6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab7", {
        get: function () {
            return this.abr;
        },
        set: function (a) {
            var b = this.abr;
            if (a != b) {
                this.abr = a;
                this.sr("ActualYAxisLabelTextColor", b, this.ab7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xv", {
        get: function () {
            return this.wt;
        },
        set: function (a) {
            var b = this.xv;
            if (a != b) {
                this.wt = a;
                this.sr("XAxisTitleMargin", b, this.xv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yc", {
        get: function () {
            return this.xa;
        },
        set: function (a) {
            var b = this.yc;
            if (a != b) {
                this.xa = a;
                this.sr("YAxisTitleMargin", b, this.yc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xu", {
        get: function () {
            return this.ws;
        },
        set: function (a) {
            var b = this.xu;
            if (a != b) {
                this.ws = a;
                this.sr("XAxisTitleLeftMargin", b, this.xu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yb", {
        get: function () {
            return this.w9;
        },
        set: function (a) {
            var b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.sr("YAxisTitleLeftMargin", b, this.yb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xx", {
        get: function () {
            return this.wv;
        },
        set: function (a) {
            var b = this.xx;
            if (a != b) {
                this.wv = a;
                this.sr("XAxisTitleTopMargin", b, this.xx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ye", {
        get: function () {
            return this.xc;
        },
        set: function (a) {
            var b = this.ye;
            if (a != b) {
                this.xc = a;
                this.sr("YAxisTitleTopMargin", b, this.ye);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xw", {
        get: function () {
            return this.wu;
        },
        set: function (a) {
            var b = this.xw;
            if (a != b) {
                this.wu = a;
                this.sr("XAxisTitleRightMargin", b, this.xw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yd", {
        get: function () {
            return this.xb;
        },
        set: function (a) {
            var b = this.yd;
            if (a != b) {
                this.xb = a;
                this.sr("YAxisTitleRightMargin", b, this.yd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xt", {
        get: function () {
            return this.wr;
        },
        set: function (a) {
            var b = this.xt;
            if (a != b) {
                this.wr = a;
                this.sr("XAxisTitleBottomMargin", b, this.xt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ya", {
        get: function () {
            return this.w8;
        },
        set: function (a) {
            var b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.sr("YAxisTitleBottomMargin", b, this.ya);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ace", {
        get: function () {
            return this.aby;
        },
        set: function (a) {
            var b = this.ace;
            if (a != b) {
                this.aby = a;
                this.sr("XAxisTitleTextColor", b, this.ace);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acl", {
        get: function () {
            return this.ab5;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.ab5 = a;
                this.sr("YAxisTitleTextColor", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.sv = function (a, b, c) {
        var _this = this;
        _super.prototype.sv.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.abc(function (d) { return d.textStyle = _this.y8; });
                break;
            case "YAxisLabelTextStyle":
                this.abh(function (d) { return d.textStyle = _this.aad; });
                break;
            case "XAxisTitleTextStyle":
                this.abe(function (d) { return d.textStyle = _this.zw; });
                break;
            case "YAxisTitleTextStyle":
                this.abj(function (d) { return d.textStyle = _this.aa1; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "y8", {
        get: function () {
            return this.yk;
        },
        set: function (a) {
            var b = this.y8;
            if (a != b) {
                this.yk = a;
                this.sr("XAxisLabelTextStyle", b, this.y8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aad", {
        get: function () {
            return this.yo;
        },
        set: function (a) {
            var b = this.aad;
            if (a != b) {
                this.yo = a;
                this.sr("YAxisLabelTextStyle", b, this.aad);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zw", {
        get: function () {
            return this.ym;
        },
        set: function (a) {
            var b = this.zw;
            if (a != b) {
                this.ym = a;
                this.sr("XAxisTitleTextStyle", b, this.zw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa1", {
        get: function () {
            return this.yq;
        },
        set: function (a) {
            var b = this.aa1;
            if (a != b) {
                this.yq = a;
                this.sr("YAxisTitleTextStyle", b, this.aa1);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.aa7 = function (a) {
        var _this = this;
        this.aa4(a, function (b) { return b.leftMargin = _this.xk; });
        this.aa4(a, function (b) { return b.topMargin = _this.xm; });
        this.aa4(a, function (b) { return b.rightMargin = _this.xl; });
        this.aa4(a, function (b) { return b.bottomMargin = _this.xj; });
        this.aa4(a, function (b) { return b.textColor = _this.ab6; });
        this.aa5(a, function (b) { return b.textColor = _this.ace; });
        this.aa5(a, function (b) { return b.leftMargin = _this.xu; });
        this.aa5(a, function (b) { return b.topMargin = _this.xx; });
        this.aa5(a, function (b) { return b.rightMargin = _this.xw; });
        this.aa5(a, function (b) { return b.bottomMargin = _this.xt; });
        this.aa4(a, function (b) { return b.textStyle = _this.y8; });
        this.aa5(a, function (b) { return b.textStyle = _this.zw; });
    };
    XYChart.prototype.aa9 = function (a) {
        var _this = this;
        this.aa4(a, function (b) { return b.leftMargin = _this.x1; });
        this.aa4(a, function (b) { return b.topMargin = _this.x3; });
        this.aa4(a, function (b) { return b.rightMargin = _this.x2; });
        this.aa4(a, function (b) { return b.bottomMargin = _this.x0; });
        this.aa4(a, function (b) { return b.textColor = _this.ab7; });
        this.aa5(a, function (b) { return b.textColor = _this.acl; });
        this.aa5(a, function (b) { return b.leftMargin = _this.yb; });
        this.aa5(a, function (b) { return b.topMargin = _this.ye; });
        this.aa5(a, function (b) { return b.rightMargin = _this.yd; });
        this.aa5(a, function (b) { return b.bottomMargin = _this.ya; });
        this.aa4(a, function (b) { return b.textStyle = _this.aad; });
        this.aa5(a, function (b) { return b.textStyle = _this.aa1; });
    };
    XYChart.prototype.tc = function (a) {
        var b = this.bc(a);
        var c = this.c0(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.oa(a);
        c.title = this.ob(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.aba = function (a) {
        this.abb(a, null);
    };
    XYChart.prototype.abb = function (a, b) {
        a(this.vz());
    };
    XYChart.prototype.abg = function (a, b) {
        a(this.v0());
    };
    XYChart.prototype.abf = function (a) {
        this.abg(a, true);
    };
    XYChart.prototype.rp = function (a, b) {
        this.aba(a);
        this.abg(a, b);
    };
    XYChart.prototype.abe = function (a) {
        this.aa5(this.vz(), a);
    };
    XYChart.prototype.abj = function (a) {
        this.aa5(this.v0(), a);
    };
    XYChart.prototype.abh = function (a) {
        this.aa4(this.v0(), a);
    };
    XYChart.prototype.abc = function (a) {
        this.aa4(this.vz(), a);
    };
    XYChart.prototype.xd = function (a) {
        var b = this.vz();
        return b.ei(a, new ScalerParams(1, this.va, this.u9, b.cg));
    };
    XYChart.prototype.xf = function (a) {
        var b = this.vz();
        return b.el(a, new ScalerParams(1, this.va, this.u9, b.cg));
    };
    XYChart.prototype.xe = function (a) {
        var b = this.v0();
        return b.ei(a, new ScalerParams(1, this.va, this.u9, b.cg));
    };
    XYChart.prototype.xg = function (a) {
        var b = this.v0();
        return b.el(a, new ScalerParams(1, this.va, this.u9, b.cg));
    };
    XYChart.prototype.s9 = function (a) {
        _super.prototype.s9.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.vz();
            var c = this.v0();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.yt = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.r0 = function (a) {
        _super.prototype.r0.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.vz());
            this.dataChart.axes.add(this.v0());
        }
    };
    XYChart.prototype.aa6 = function (a) {
        var _this = this;
        if (a != null && this.j5 != null && a.fk == null) {
            a.provideRenderer(this.j5);
        }
        a.jv = this.ab9;
        a.eq = this.xn;
        a.jw = this.aca;
        a.et = this.xo;
        a.jy = this.acc;
        a.ff = this.xp;
        a.jx = this.acb;
        a.fg = this.xq;
        a.jz = this.acd;
        a.fh = this.xr;
        a.c3 = true;
        a.ct = this.f8;
        a.cv = this.f8;
        var b = a == this.vz();
        if (b) {
            a.g5 = this.zn;
        }
        a.fz = this.yh;
        a.gf = this.yz;
        a.ag = this.vx;
        this.aa4(a, function (c) { return c.angle = _this.xi; });
        this.aa4(a, function (c) {
            if (c.extent != _this.xh) {
                c.extent = _this.xh;
            }
        });
        this.aa4(a, function (c) { return c.horizontalAlignment = _this.abn; });
        this.aa4(a, function (c) { return c.verticalAlignment = _this.acp; });
        this.aa4(a, function (c) { return c.visibility = _this.acu; });
        this.aa4(a, function (c) { return c.location = _this.v5(_this.v8); });
        this.aa5(a, function (c) { return c.horizontalAlignment = _this.abo; });
        this.aa5(a, function (c) { return c.angle = _this.xs; });
        this.aa7(a);
    };
    XYChart.prototype.aa8 = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.j5 != null && a.fk == null) {
            a.provideRenderer(this.j5);
        }
        a.ct = this.f8;
        a.cv = this.f8;
        this.aa4(a, function (b) { return b.angle = _this.xz; });
        this.aa4(a, function (b) {
            if (b.extent != _this.xy) {
                b.extent = _this.xy;
            }
        });
        this.aa4(a, function (b) { return b.horizontalAlignment = _this.abp; });
        this.aa4(a, function (b) { return b.verticalAlignment = _this.acq; });
        this.aa4(a, function (b) { return b.visibility = _this.acv; });
        this.aa4(a, function (b) { return b.location = _this.v6(_this.wa); });
        this.aa5(a, function (b) { return b.verticalAlignment = _this.acr; });
        this.aa5(a, function (b) { return b.angle = _this.x9; });
        a.jv = this.acg;
        a.eq = this.x4;
        a.jw = this.ach;
        a.et = this.x5;
        a.jy = this.acj;
        a.ff = this.x6;
        a.jx = this.aci;
        a.fg = this.x7;
        a.jz = this.ack;
        a.fh = this.x8;
        var b = a == this.v0();
        if (b) {
            a.g5 = this.aas;
        }
        a.gf = this.z4;
        a.ag = this.vy;
        this.aa9(a);
    };
    XYChart.prototype.rx = function () {
        _super.prototype.rx.call(this);
        this.aa6(this.vz());
        this.aa8(this.v0());
    };
    XYChart.prototype.aa4 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.ay == null) {
            a.ay = new AxisLabelSettings();
            a.ay.angle = a.d4();
            a.ay.bottomMargin = a.d5();
            a.ay.leftMargin = a.d6();
            a.ay.rightMargin = a.d7();
            a.ay.topMargin = a.d8();
            a.ay.horizontalAlignment = a.jq();
            a.ay.location = a.az();
            a.ay.verticalAlignment = a.kj();
        }
        b(a.ay);
    };
    XYChart.prototype.aa5 = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.be == null) {
            a.be = new TitleSettings();
            a.be.bottomMargin = a.ea();
            a.be.leftMargin = a.eb();
            a.be.rightMargin = a.ec();
            a.be.topMargin = a.ed();
            a.be.location = a.a0();
            a.be.angle = a.d9();
            a.be.horizontalAlignment = a.jr();
            a.be.verticalAlignment = a.kk();
        }
        b(a.be);
    };
    XYChart.prototype.sr = function (a, b, c) {
        var _this = this;
        _super.prototype.sr.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.abc(function (d) { return d.angle = _this.xi; });
                break;
            case "YAxisLabelAngle":
                this.abh(function (d) { return d.angle = _this.xz; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.abc(function (d) { return d.horizontalAlignment = _this.abn; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.abh(function (d) { return d.horizontalAlignment = _this.abp; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.abc(function (d) { return d.verticalAlignment = _this.acp; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.abh(function (d) { return d.verticalAlignment = _this.acq; });
                break;
            case "XAxisLabelVisibility":
                this.abc(function (d) { return d.visibility = _this.acu; });
                break;
            case "YAxisLabelVisibility":
                this.abh(function (d) { return d.visibility = _this.acv; });
                break;
            case "XAxisLabel":
                this.aba(function (d) { return d.fz = _this.yh; });
                break;
            case "YAxisLabel":
                this.abf(function (d) { return d.fz = _this.yi; });
                break;
            case "XAxisLabelFormat":
                this.aba(function (d) { return d.gf = _this.yz; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.aba(function (d) { return d.ag = _this.vx; });
                break;
            case "YAxisLabelFormat":
                this.abf(function (d) { return d.gf = _this.z4; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.abf(function (d) { return d.ag = _this.vy; });
                break;
            case "XAxisTitleAngle":
                this.abe(function (d) { return d.angle = _this.xs; });
                break;
            case "YAxisTitleAngle":
                this.abj(function (d) { return d.angle = _this.x9; });
                break;
            case "XAxisTitleAlignment":
                this.abe(function (d) { return d.horizontalAlignment = _this.abo; });
                break;
            case "YAxisTitleAlignment":
                this.abj(function (d) { return d.verticalAlignment = _this.acr; });
                break;
            case "XAxisTitle":
                this.aba(function (d) { return d.g5 = _this.zn; });
                break;
            case "YAxisTitle":
                this.abg(function (d) { return d.g5 = _this.aas; }, false);
                break;
            case "XAxisMajorStroke":
                this.abb(function (d) { return d.jv = _this.ab9; }, a);
                break;
            case "YAxisMajorStroke":
                this.abf(function (d) { return d.jv = _this.acg; });
                break;
            case "XAxisMajorStrokeThickness":
                this.abb(function (d) { return d.eq = _this.xn; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.abf(function (d) { return d.eq = _this.x4; });
                break;
            case "XAxisMinorStroke":
                this.aba(function (d) { return d.jw = _this.aca; });
                break;
            case "YAxisMinorStroke":
                this.abf(function (d) { return d.jw = _this.ach; });
                break;
            case "XAxisMinorStrokeThickness":
                this.aba(function (d) { return d.et = _this.xo; });
                break;
            case "YAxisMinorStrokeThickness":
                this.abf(function (d) { return d.et = _this.x5; });
                break;
            case "XAxisTickLength":
                this.aba(function (d) { return d.fg = _this.xq; });
                break;
            case "YAxisTickLength":
                this.abf(function (d) { return d.fg = _this.x7; });
                break;
            case "XAxisTickStroke":
                this.aba(function (d) { return d.jz = _this.acd; });
                break;
            case "YAxisTickStroke":
                this.abf(function (d) { return d.jz = _this.ack; });
                break;
            case "XAxisTickStrokeThickness":
                this.aba(function (d) { return d.fh = _this.xr; });
                break;
            case "YAxisTickStrokeThickness":
                this.abf(function (d) { return d.fh = _this.x8; });
                break;
            case "XAxisStroke":
                this.aba(function (d) { return d.jy = _this.acc; });
                break;
            case "YAxisStroke":
                this.abf(function (d) { return d.jy = _this.acj; });
                break;
            case "XAxisStrokeThickness":
                this.aba(function (d) { return d.ff = _this.xp; });
                break;
            case "YAxisStrokeThickness":
                this.abf(function (d) { return d.ff = _this.x6; });
                break;
            case "XAxisExtent":
                this.abc(function (d) { return d.extent = _this.xh; });
                break;
            case "YAxisExtent":
                this.abh(function (d) { return d.extent = _this.xy; });
                break;
            case "XAxisStrip":
                this.aba(function (d) { return d.jx = _this.acb; });
                break;
            case "YAxisStrip":
                this.abf(function (d) { return d.jx = _this.aci; });
                break;
            case "XAxisInverted":
                this.aba(function (d) { return d.cg = _this.wd; });
                break;
            case "YAxisInverted":
                this.abf(function (d) { return d.cg = _this.we; });
                break;
            case "YAxisLabelLocation":
                this.abi();
                break;
            case "XAxisLabelLocation":
                this.abd();
                break;
        }
    };
    XYChart.prototype.abi = function () {
        var a = this.v6(this.wa);
        if (a == 2 || a == 7) {
            this.abp = 2;
        }
        else {
            this.abp = 0;
        }
        this.abh(function (b) { return b.location = a; });
    };
    XYChart.prototype.abd = function () {
        var a = this.v5(this.v8);
        if (a == 1 || a == 5) {
            this.acp = 0;
        }
        else {
            this.acp = 2;
        }
        this.abc(function (b) { return b.location = a; });
    };
    XYChart.prototype.v6 = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.b1 == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.v5 = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "yh", {
        get: function () {
            return this.yf;
        },
        set: function (a) {
            var b = this.yh;
            if (a != b) {
                this.yf = a;
                this.sr("XAxisLabel", b, this.yh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yi", {
        get: function () {
            return this.yg;
        },
        set: function (a) {
            var b = this.yi;
            if (a != b) {
                this.yg = a;
                this.sr("YAxisLabel", b, this.yi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab9", {
        get: function () {
            return this.abt;
        },
        set: function (a) {
            var b = this.ab9;
            if (a != b) {
                this.abt = a;
                this.sr("XAxisMajorStroke", b, this.ab9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acg", {
        get: function () {
            return this.ab0;
        },
        set: function (a) {
            var b = this.acg;
            if (a != b) {
                this.ab0 = a;
                this.sr("YAxisMajorStroke", b, this.acg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xn", {
        get: function () {
            return this.wl;
        },
        set: function (a) {
            var b = this.xn;
            if (a != b) {
                this.wl = a;
                this.sr("XAxisMajorStrokeThickness", b, this.xn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x4", {
        get: function () {
            return this.w2;
        },
        set: function (a) {
            var b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.sr("YAxisMajorStrokeThickness", b, this.x4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xo", {
        get: function () {
            return this.wm;
        },
        set: function (a) {
            var b = this.xo;
            if (a != b) {
                this.wm = a;
                this.sr("XAxisMinorStrokeThickness", b, this.xo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x5", {
        get: function () {
            return this.w3;
        },
        set: function (a) {
            var b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.sr("YAxisMinorStrokeThickness", b, this.x5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acb", {
        get: function () {
            return this.abv;
        },
        set: function (a) {
            var b = this.acb;
            if (a != b) {
                this.abv = a;
                this.sr("XAxisStrip", b, this.acb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aci", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.aci;
            if (a != b) {
                this.ab2 = a;
                this.sr("YAxisStrip", b, this.aci);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acc", {
        get: function () {
            return this.abw;
        },
        set: function (a) {
            var b = this.acc;
            if (a != b) {
                this.abw = a;
                this.sr("XAxisStroke", b, this.acc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acj", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.acj;
            if (a != b) {
                this.ab3 = a;
                this.sr("YAxisStroke", b, this.acj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xp", {
        get: function () {
            return this.wn;
        },
        set: function (a) {
            var b = this.xp;
            if (a != b) {
                this.wn = a;
                this.sr("XAxisStrokeThickness", b, this.xp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x6", {
        get: function () {
            return this.w4;
        },
        set: function (a) {
            var b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.sr("YAxisStrokeThickness", b, this.x6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xq", {
        get: function () {
            return this.wo;
        },
        set: function (a) {
            var b = this.xq;
            if (a != b) {
                this.wo = a;
                this.sr("XAxisTickLength", b, this.xq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x7", {
        get: function () {
            return this.w5;
        },
        set: function (a) {
            var b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.sr("YAxisTickLength", b, this.x7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acd", {
        get: function () {
            return this.abx;
        },
        set: function (a) {
            var b = this.acd;
            if (a != b) {
                this.abx = a;
                this.sr("XAxisTickStroke", b, this.acd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ack", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.ab4 = a;
                this.sr("YAxisTickStroke", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xr", {
        get: function () {
            return this.wp;
        },
        set: function (a) {
            var b = this.xr;
            if (a != b) {
                this.wp = a;
                this.sr("XAxisTickStrokeThickness", b, this.xr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x8", {
        get: function () {
            return this.w6;
        },
        set: function (a) {
            var b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.sr("YAxisTickStrokeThickness", b, this.x8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zn", {
        get: function () {
            return this.yl;
        },
        set: function (a) {
            var b = this.zn;
            if (a != b) {
                this.yl = a;
                this.sr("XAxisTitle", b, this.zn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aas", {
        get: function () {
            return this.yp;
        },
        set: function (a) {
            var b = this.aas;
            if (a != b) {
                this.yp = a;
                this.sr("YAxisTitle", b, this.aas);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aca", {
        get: function () {
            return this.abu;
        },
        set: function (a) {
            var b = this.aca;
            if (a != b) {
                this.abu = a;
                this.sr("XAxisMinorStroke", b, this.aca);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ach", {
        get: function () {
            return this.ab1;
        },
        set: function (a) {
            var b = this.ach;
            if (a != b) {
                this.ab1 = a;
                this.sr("YAxisMinorStroke", b, this.ach);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xi", {
        get: function () {
            return this.wg;
        },
        set: function (a) {
            var b = this.xi;
            if (a != b) {
                this.wg = a;
                this.sr("XAxisLabelAngle", b, this.xi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xz", {
        get: function () {
            return this.wx;
        },
        set: function (a) {
            var b = this.xz;
            if (a != b) {
                this.wx = a;
                this.sr("YAxisLabelAngle", b, this.xz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xh", {
        get: function () {
            return this.wf;
        },
        set: function (a) {
            var b = this.xh;
            if (a != b) {
                this.wf = a;
                this.sr("XAxisExtent", b, this.xh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xy", {
        get: function () {
            return this.ww;
        },
        set: function (a) {
            var b = this.xy;
            if (a != b) {
                this.ww = a;
                this.sr("YAxisExtent", b, this.xy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xs", {
        get: function () {
            return this.wq;
        },
        set: function (a) {
            var b = this.xs;
            if (a != b) {
                this.wq = a;
                this.sr("XAxisTitleAngle", b, this.xs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "x9", {
        get: function () {
            return this.w7;
        },
        set: function (a) {
            var b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.sr("YAxisTitleAngle", b, this.x9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wd", {
        get: function () {
            return this.wb;
        },
        set: function (a) {
            var b = this.wd;
            if (a != b) {
                this.wb = a;
                this.sr("XAxisInverted", b, this.wd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "we", {
        get: function () {
            return this.wc;
        },
        set: function (a) {
            var b = this.we;
            if (a != b) {
                this.wc = a;
                this.sr("YAxisInverted", b, this.we);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abo", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.abo;
            if (a != b) {
                this.abl = a;
                this.sr("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abo));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acr", {
        get: function () {
            return this.aco;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.aco = a;
                this.sr("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acr));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abn", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.abn;
            if (a != b) {
                this.abk = a;
                this.sr("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abn));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_abp = function () {
        return this.abm;
    };
    XYChart.prototype.set_abp = function (a) {
        var b = this.abp;
        if (a != b) {
            this.abm = a;
            this.sr("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.abp));
        }
    };
    Object.defineProperty(XYChart.prototype, "abp", {
        get: function () {
            return this.get_abp();
        },
        set: function (a) {
            this.set_abp(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acp", {
        get: function () {
            return this.acm;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.acm = a;
                this.sr("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acp));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acq", {
        get: function () {
            return this.acn;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.acn = a;
                this.sr("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.acq));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acu", {
        get: function () {
            return this.acs;
        },
        set: function (a) {
            var b = this.acu;
            if (a != b) {
                this.acs = a;
                this.sr("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acu));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acv", {
        get: function () {
            return this.act;
        },
        set: function (a) {
            var b = this.acv;
            if (a != b) {
                this.act = a;
                this.sr("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acv));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_wa = function () {
        return this.v9;
    };
    XYChart.prototype.set_wa = function (a) {
        var b = this.wa;
        if (a != b) {
            this.v9 = a;
            this.sr("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wa));
        }
    };
    Object.defineProperty(XYChart.prototype, "wa", {
        get: function () {
            return this.get_wa();
        },
        set: function (a) {
            this.set_wa(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_v8 = function () {
        return this.v7;
    };
    XYChart.prototype.set_v8 = function (a) {
        var b = this.v8;
        if (a != b) {
            this.v7 = a;
            this.sr("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.v8));
        }
    };
    Object.defineProperty(XYChart.prototype, "v8", {
        get: function () {
            return this.get_v8();
        },
        set: function (a) {
            this.set_v8(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yz", {
        get: function () {
            return this.yj;
        },
        set: function (a) {
            var b = this.yj;
            if (a != b) {
                this.yj = a;
                this.sr("XAxisLabelFormat", b, this.yj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "vx", {
        get: function () {
            return this.vv;
        },
        set: function (a) {
            var b = this.vv;
            if (a != b) {
                this.vv = a;
                this.sr("XAxisLabelFormatSpecifiers", b, this.vv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z4", {
        get: function () {
            return this.yn;
        },
        set: function (a) {
            var b = this.yn;
            if (a != b) {
                this.yn = a;
                this.sr("YAxisLabelFormat", b, this.yn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "vy", {
        get: function () {
            return this.vw;
        },
        set: function (a) {
            var b = this.vw;
            if (a != b) {
                this.vw = a;
                this.sr("YAxisLabelFormatSpecifiers", b, this.vw);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
