import { Base, INotifyPropertyChanged, IEnumerable, Type, PropertyChangedEventArgs } from "igniteui-react-core";
import { IDataLegendTarget } from "igniteui-react-core";
import { IToolbarTarget } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { IDomainChartWidget } from "./IDomainChartWidget";
import { XamDataChart } from "./XamDataChart";
import { DataSeriesAdapterImplementation } from "igniteui-react-core";
import { DataSeriesType } from "igniteui-react-core";
import { IDataSeriesAdapterRule } from "igniteui-react-core";
import { MarkerType } from "./MarkerType";
import { IAnnotationLayerProxy } from "./IAnnotationLayerProxy";
import { Color } from "igniteui-react-core";
import { ToolCommandStateChanged } from "igniteui-react-core";
import { DataToolTipLayerGroupingMode } from "igniteui-react-core";
import { DataTooltipGroupedPositionX } from "igniteui-react-core";
import { DataTooltipGroupedPositionY } from "igniteui-react-core";
import { DataAbbreviationMode } from "igniteui-react-core";
import { DataLegendValueMode } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DataLegendHeaderDateMode } from "igniteui-react-core";
import { DataLegendHeaderTimeMode } from "igniteui-react-core";
import { DataLegendSummaryType } from "igniteui-react-core";
import { LegendItemBadgeShape } from "igniteui-react-core";
import { DataLegendUnitsMode } from "igniteui-react-core";
import { DataLegendLabelMode } from "igniteui-react-core";
import { DomainType } from "./DomainType";
import { ChartSortDescriptionCollection } from "./ChartSortDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-react-core";
import { ChartSummaryDescriptionCollection } from "./ChartSummaryDescriptionCollection";
import { BrushCollection } from "igniteui-react-core";
import { IChartLegend } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { UnknownValuePlotting } from "igniteui-react-core";
import { SeriesOutlineMode } from "./SeriesOutlineMode";
import { MarkerOutlineMode } from "./MarkerOutlineMode";
import { MarkerFillMode } from "./MarkerFillMode";
import { MarkerTypeCollection } from "./MarkerTypeCollection";
import { MarkerAutomaticBehavior } from "./MarkerAutomaticBehavior";
import { TrendLineType } from "igniteui-react-core";
import { ComputedPlotAreaMarginMode } from "./ComputedPlotAreaMarginMode";
import { SeriesPlotAreaMarginHorizontalMode } from "./SeriesPlotAreaMarginHorizontalMode";
import { SeriesPlotAreaMarginVerticalMode } from "./SeriesPlotAreaMarginVerticalMode";
import { SeriesHighlightingMode } from "./SeriesHighlightingMode";
import { SeriesHighlightingBehavior } from "./SeriesHighlightingBehavior";
import { LegendHighlightingMode } from "./LegendHighlightingMode";
import { LegendItemBadgeMode } from "igniteui-react-core";
import { ToolTipType } from "./ToolTipType";
import { CrosshairsDisplayMode } from "./CrosshairsDisplayMode";
import { CalloutPlacementPositionsCollection } from "./CalloutPlacementPositionsCollection";
import { ValueModeCollection } from "./ValueModeCollection";
import { SeriesViewerScrollbarMode } from "./SeriesViewerScrollbarMode";
import { SeriesViewerHorizontalScrollbarPosition } from "./SeriesViewerHorizontalScrollbarPosition";
import { SeriesViewerVerticalScrollbarPosition } from "./SeriesViewerVerticalScrollbarPosition";
import { Series } from "./Series";
import { IDataLegend } from "igniteui-react-core";
import { ICommandStateChangedListener } from "igniteui-react-core";
import { DataSeries } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ObservableColorCollection } from "igniteui-react-core";
import { DataSeriesMarker } from "igniteui-react-core";
import { IDataLegendSeries } from "igniteui-react-core";
import { ToolActionInfo } from "igniteui-react-core";
import { ToolCommand } from "igniteui-react-core";
import { ICommandAvailabilityListener } from "igniteui-react-core";
import { ChartSeriesEventArgs } from "./ChartSeriesEventArgs";
import { DomainChartSeriesPointerEventArgs } from "./DomainChartSeriesPointerEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { CalloutRenderStyleUpdatingEventArgs } from "./CalloutRenderStyleUpdatingEventArgs";
/**
 * @hidden
 */
export declare abstract class DomainChart extends Base implements INotifyPropertyChanged, IDataLegendTarget, IToolbarTarget {
    static $t: Type;
    protected j5: any;
    provideContainer(a: any): void;
    destroy(): void;
    private r4;
    protected r5(): void;
    protected r1(a: XamDataChart): void;
    protected ry(): void;
    protected r7(a: Series, b: number): void;
    protected su(a: string, b: any, c: any): void;
    private j3;
    get tooltipTemplate(): any;
    set tooltipTemplate(a: any);
    private gi;
    get tooltipTemplates(): List$1<any>;
    set tooltipTemplates(a: List$1<any>);
    private ha;
    get im(): number;
    set im(a: number);
    private j2;
    private get toolTip();
    private set toolTip(value);
    private hn;
    get i0(): number;
    set i0(a: number);
    private ho;
    get i1(): number;
    set i1(a: number);
    private hp;
    get i2(): number;
    set i2(a: number);
    private hm;
    get iz(): number;
    set iz(a: number);
    private hi;
    get iv(): number;
    set iv(a: number);
    private hk;
    get ix(): number;
    set ix(a: number);
    private hj;
    get iw(): number;
    set iw(a: number);
    private hh;
    get iu(): number;
    set iu(a: number);
    private ub;
    get u3(): Brush;
    set u3(a: Brush);
    private uc;
    get u4(): Brush;
    set u4(a: Brush);
    private g7;
    protected get_ij(): number;
    protected set_ij(a: number): void;
    get ij(): number;
    set ij(a: number);
    private hq;
    get i3(): number;
    set i3(a: number);
    private hg;
    get it(): number;
    set it(a: number);
    private gu;
    get h5(): number;
    set h5(a: number);
    private jq;
    get jy(): number;
    set jy(a: number);
    private d1;
    get d2(): (time: number) => number;
    set d2(a: (time: number) => number);
    protected r2(a: XamDataChart): void;
    protected r8(a: Series, b: number): void;
    protected rz(): void;
    private r9;
    jh: (arg1: HTMLElement) => any[];
    private tk;
    private j7;
    private f7;
    private ji;
    protected sv(a: string, b: any, c: any): void;
    private b9;
    get ca(): IDomainChartWidget;
    set ca(a: IDomainChartWidget);
    private kz;
    get p3(): string;
    set p3(a: string);
    private k1;
    get qe(): string;
    set qe(a: string);
    private du;
    get dataChart(): XamDataChart;
    set dataChart(a: XamDataChart);
    bd: DataSeriesAdapterImplementation;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    constructor();
    protected r3(): void;
    protected abstract get go(): List$1<DataSeriesType>;
    protected abstract get gn(): List$1<IDataSeriesAdapterRule>;
    protected gm: List$1<MarkerType>;
    protected f2(a: DataSeriesType): boolean;
    notifyResized(): void;
    sh(): void;
    ro(): void;
    rw(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected s1(a: string): void;
    protected abstract rp(a: (arg1: Axis) => void, b: boolean): void;
    protected rq(a: (arg1: Series) => void): void;
    protected rr(a: (arg1: Series, arg2: number) => void): void;
    protected ru(a: (arg1: Series) => void): void;
    protected rv(a: (arg1: Series, arg2: number) => void): void;
    protected rs(a: (arg1: Series) => void): void;
    protected rt(a: (arg1: Series, arg2: number) => void): void;
    ta(): void;
    protected sj(a: (arg1: XamDataChart) => void): void;
    protected sk(a: (arg1: XamDataChart) => void, b: boolean): void;
    protected sl(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    protected f4(a: DataSeries): boolean;
    protected fv(): boolean;
    private static readonly kf;
    private jp;
    protected oa(a: DataSeries): string;
    private static ke;
    protected ob(a: DataSeries, b: DataSeriesType): string;
    protected abstract bc(a: DataSeries): DataSeriesType;
    protected abstract c0(a: DataSeries, b: DataSeriesType): Series;
    n9(): string;
    private f0;
    protected td(): void;
    protected c2(seriesType_: DataSeriesType): Series;
    private cu;
    private cw;
    private cy;
    private cz;
    private cv;
    private cx;
    private c1;
    private b2;
    protected get b3(): IAnnotationLayerProxy;
    private get fr();
    private ft;
    private tl;
    protected fw(): boolean;
    protected fx(): boolean;
    protected get_fu(): boolean;
    protected get fu(): boolean;
    protected gk(a: string, b: boolean): List$1<Series>;
    protected ri(a: Series, b: boolean): void;
    protected tj(a: Series, b: Series, c: DataSeries): void;
    protected abstract tc(a: DataSeries): void;
    protected abstract tb(a: DataSeries): void;
    protected tf(): void;
    private tg;
    protected th(a: Series): void;
    protected abstract te(): void;
    private sm;
    protected rm(): void;
    protected uw(a: number): Brush;
    protected uz(a: number): Brush;
    protected ux(a: number): Brush;
    protected uy(a: number): Brush;
    protected u7(a: number): Color;
    protected el(a: Color): ObservableColorCollection;
    protected ac(a: Color): BrushCollection;
    protected gh: List$1<Color>;
    protected get gj(): List$1<Color>;
    protected get_gb(): boolean;
    protected get gb(): boolean;
    j6(): any;
    sa(a: string, b: string): void;
    sb(a: string, b: string, c: Series): void;
    cp(a: DataSeriesMarker): MarkerType;
    private b6;
    private e2;
    attachDataLegend(a: IDataLegend): void;
    protected rh(a: IDataLegend): void;
    detachDataLegend(a: IDataLegend): void;
    protected rl(a: IDataLegend): void;
    getDataLegendSeries(): IDataLegendSeries[];
    protected p(): IDataLegendSeries[];
    tm(a: number): void;
    tn(a: number): void;
    ti(): void;
    protected get_f3(): boolean;
    get f3(): boolean;
    private b7;
    get b8(): IDomainChartToolbarProvider;
    private ss;
    getDesiredToolbarActions(): ToolActionInfo[];
    onToolCommandExecuting(a: ToolCommand): void;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private gf;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    sg(source_: any, a: number, b: any, c: any): void;
    sc(source_: any): void;
    sd(source_: any, a: number, b: any): void;
    se(source_: any, a: number, b: any): void;
    private bu;
    get bv(): DataToolTipLayerGroupingMode;
    set bv(a: DataToolTipLayerGroupingMode);
    private gy;
    get h9(): number;
    set h9(a: number);
    private gz;
    get ia(): number;
    set ia(a: number);
    private gw;
    get h7(): number;
    set h7(a: number);
    private gx;
    get h8(): number;
    set h8(a: number);
    private bq;
    get br(): DataTooltipGroupedPositionX;
    set br(a: DataTooltipGroupedPositionX);
    private bs;
    get bt(): DataTooltipGroupedPositionY;
    set bt(a: DataTooltipGroupedPositionY);
    private ev;
    get fm(): boolean;
    set fm(a: boolean);
    static readonly mv: string;
    get m(): string[];
    set m(a: string[]);
    private e;
    get j(): string[];
    set j(a: string[]);
    private b;
    get l(): string[];
    set l(a: string[]);
    private d;
    get i(): string[];
    set i(a: string[]);
    private a;
    get bb(): DataAbbreviationMode;
    set bb(a: DataAbbreviationMode);
    private ba;
    get ju(): number;
    set ju(a: number);
    private jl;
    get jv(): number;
    set jv(a: number);
    private jm;
    get bp(): DataLegendValueMode;
    set bp(a: DataLegendValueMode);
    private bo;
    get nn(): string;
    set nn(a: string);
    private kr;
    get fn(): boolean;
    set fn(a: boolean);
    private ew;
    get nt(): string;
    set nt(a: string);
    private ks;
    get n(): any[];
    set n(a: any[]);
    private f;
    get vt(): Thickness;
    set vt(a: Thickness);
    private vj;
    get fo(): boolean;
    set fo(a: boolean);
    private ex;
    get n2(): string;
    set n2(a: string);
    private kt;
    get fp(): boolean;
    set fp(a: boolean);
    private ey;
    get vu(): Thickness;
    set vu(a: Thickness);
    private vk;
    get ut(): Brush;
    set ut(a: Brush);
    private t6;
    private eb;
    get ek(): FontInfo;
    set ek(a: FontInfo);
    get md(): string;
    set md(a: string);
    private kl;
    get k(): any[];
    set k(a: any[]);
    private c;
    get l9(): string;
    set l9(a: string);
    private kk;
    get bf(): DataLegendHeaderDateMode;
    set bf(a: DataLegendHeaderDateMode);
    private be;
    get bh(): DataLegendHeaderTimeMode;
    set bh(a: DataLegendHeaderTimeMode);
    private bg;
    get mi(): string;
    set mi(a: string);
    private km;
    get ul(): Brush;
    set ul(a: Brush);
    private ty;
    get vn(): Thickness;
    set vn(a: Thickness);
    private vd;
    get vm(): Thickness;
    set vm(a: Thickness);
    private vc;
    get fl(): boolean;
    set fl(a: boolean);
    private eu;
    private d3;
    get ec(): FontInfo;
    set ec(a: FontInfo);
    get uo(): Brush;
    set uo(a: Brush);
    private t1;
    private d6;
    get ef(): FontInfo;
    set ef(a: FontInfo);
    get bl(): DataLegendSummaryType;
    set bl(a: DataLegendSummaryType);
    private bk;
    get m1(): string;
    set m1(a: string);
    private ko;
    get vq(): Thickness;
    set vq(a: Thickness);
    private vg;
    get vp(): Thickness;
    set vp(a: Thickness);
    private vf;
    get uq(): Brush;
    set uq(a: Brush);
    private t3;
    private d8;
    get eh(): FontInfo;
    set eh(a: FontInfo);
    get mw(): string;
    set mw(a: string);
    private kn;
    get un(): Brush;
    set un(a: Brush);
    private t0;
    private d5;
    get ee(): FontInfo;
    set ee(a: FontInfo);
    get m7(): string;
    set m7(a: string);
    private kp;
    get up(): Brush;
    set up(a: Brush);
    private t2;
    private d7;
    get eg(): FontInfo;
    set eg(a: FontInfo);
    get vl(): Thickness;
    set vl(a: Thickness);
    private vb;
    get ch(): LegendItemBadgeShape;
    set ch(a: LegendItemBadgeShape);
    private cf;
    get bn(): DataLegendUnitsMode;
    set bn(a: DataLegendUnitsMode);
    private bm;
    get nh(): string;
    set nh(a: string);
    private kq;
    get us(): Brush;
    set us(a: Brush);
    private t5;
    get vs(): Thickness;
    set vs(a: Thickness);
    private vi;
    private ea;
    get ej(): FontInfo;
    set ej(a: FontInfo);
    get vr(): Thickness;
    set vr(a: Thickness);
    private vh;
    get ur(): Brush;
    set ur(a: Brush);
    private t4;
    private d9;
    get ei(): FontInfo;
    set ei(a: FontInfo);
    get bj(): DataLegendLabelMode;
    set bj(a: DataLegendLabelMode);
    private bi;
    get um(): Brush;
    set um(a: Brush);
    private tz;
    get vo(): Thickness;
    set vo(a: Thickness);
    private ve;
    private d4;
    get ed(): FontInfo;
    set ed(a: FontInfo);
    seriesAdded: (sender: any, args: ChartSeriesEventArgs) => void;
    s2(a: Series): void;
    seriesRemoved: (sender: any, args: ChartSeriesEventArgs) => void;
    s8(a: Series): void;
    seriesPointerEnter: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    s4(a: Series, b: any): void;
    seriesPointerLeave: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    s5(a: Series, b: any): void;
    seriesPointerMove: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    s6(a: Series, b: any): void;
    seriesPointerDown: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    s3(a: Series, b: any): void;
    seriesPointerUp: (sender: any, args: DomainChartSeriesPointerEventArgs) => void;
    s7(a: Series, b: any): void;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    s0(a: any, b: CalloutStyleUpdatingEventArgs): void;
    calloutRenderStyleUpdating: (sender: any, args: CalloutRenderStyleUpdatingEventArgs) => void;
    sz(a: any, b: CalloutRenderStyleUpdatingEventArgs): void;
    private gl;
    sx(a: () => void): void;
    private em;
    sy(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected get_f5(): boolean;
    protected get f5(): boolean;
    protected r0(a: XamDataChart): void;
    protected ag(a: BrushCollection): BrushCollection;
    protected u2(a: Brush): Brush;
    protected r6(a: Series, b: number): void;
    protected abstract rj(): void;
    protected get fg(): boolean;
    private ep;
    protected rn(): void;
    protected rx(): void;
    protected s9(a: XamDataChart): void;
    protected rg(a: Series, b: number): void;
    protected abstract rf(a: Series, b: number): void;
    protected cr(a: Series, b: number): MarkerType;
    protected cq(a: Series): MarkerType;
    protected ka(): any;
    protected get_fy(): boolean;
    protected get fy(): boolean;
    protected gs(): IEnumerable;
    protected sr(a: string, b: any, c: any): void;
    private ge;
    private gg;
    private sn;
    private re;
    private sp;
    private st;
    abstract get b1(): DomainType;
    private au;
    private aq;
    private ap;
    private dw;
    private a2;
    private dz;
    private d0;
    private fa;
    private e9;
    private fb;
    private e8;
    private at;
    private as;
    private ar;
    private dx;
    private a1;
    get a0(): ChartSortDescriptionCollection;
    get aw(): ChartSortDescriptionCollection;
    get av(): ChartSortDescriptionCollection;
    get dy(): FilterExpressionCollection;
    get a4(): ChartSummaryDescriptionCollection;
    get az(): ChartSortDescriptionCollection;
    get ay(): ChartSortDescriptionCollection;
    get ax(): ChartSortDescriptionCollection;
    get a3(): ChartSummaryDescriptionCollection;
    private kw;
    get ov(): string;
    set ov(a: string);
    private ku;
    get oc(): string;
    set oc(a: string);
    private kv;
    get ot(): string;
    set ot(a: string);
    private kx;
    get ox(): string;
    set ox(a: string);
    private j1;
    get itemsSource(): any;
    set itemsSource(a: any);
    private j0;
    get actualItemsSource(): any;
    set actualItemsSource(a: any);
    private h;
    get q(): string[];
    set q(a: string[]);
    private g;
    get o(): string[];
    set o(a: string[]);
    private t;
    get ab(): BrushCollection;
    set ab(a: BrushCollection);
    private w;
    get af(): BrushCollection;
    set af(a: BrushCollection);
    private r;
    get z(): BrushCollection;
    set z(a: BrushCollection);
    private s;
    get aa(): BrushCollection;
    set aa(a: BrushCollection);
    private b4;
    get legend(): IChartLegend;
    set legend(a: IChartLegend);
    private e1;
    protected get_fz(): boolean;
    protected set_fz(a: boolean): void;
    get fz(): boolean;
    set fz(a: boolean);
    private e4;
    protected get_f6(): boolean;
    protected set_f6(a: boolean): void;
    get f6(): boolean;
    set f6(a: boolean);
    private e6;
    protected get_f9(): boolean;
    protected set_f9(a: boolean): void;
    get f9(): boolean;
    set f9(a: boolean);
    private fc;
    protected get_gc(): boolean;
    protected set_gc(a: boolean): void;
    get gc(): boolean;
    set gc(a: boolean);
    private e3;
    protected get_f1(): boolean;
    protected set_f1(a: boolean): void;
    get f1(): boolean;
    set f1(a: boolean);
    private u8;
    get va(): Rect;
    set va(a: Rect);
    get u9(): Rect;
    private k0;
    get p7(): string;
    set p7(a: string);
    private ky;
    get pw(): string;
    set pw(a: string);
    private tp;
    get tr(): HorizontalAlignment;
    set tr(a: HorizontalAlignment);
    private to;
    get tq(): HorizontalAlignment;
    set tq(a: HorizontalAlignment);
    private dq;
    get dr(): UnknownValuePlotting;
    set dr(a: UnknownValuePlotting);
    private hf;
    protected get_is(): number;
    protected set_is(a: number): void;
    get is(): number;
    set is(a: number);
    private hl;
    get iy(): number;
    set iy(a: number);
    private c7;
    get c8(): SeriesOutlineMode;
    set c8(a: SeriesOutlineMode);
    private cn;
    get co(): MarkerOutlineMode;
    set co(a: MarkerOutlineMode);
    private cl;
    get cm(): MarkerFillMode;
    set cm(a: MarkerFillMode);
    private g8;
    get ik(): number;
    set ik(a: number);
    private g9;
    get il(): number;
    set il(a: number);
    private cs;
    get ct(): MarkerTypeCollection;
    set ct(a: MarkerTypeCollection);
    private cj;
    get ck(): MarkerAutomaticBehavior;
    set ck(a: MarkerAutomaticBehavior);
    private u;
    get ad(): BrushCollection;
    set ad(a: BrushCollection);
    private v;
    get ae(): BrushCollection;
    set ae(a: BrushCollection);
    private jo;
    get jx(): number;
    set jx(a: number);
    private gt;
    get h4(): number;
    set h4(a: number);
    private eo;
    get ff(): boolean;
    set ff(a: boolean);
    private x;
    get ah(): BrushCollection;
    set ah(a: BrushCollection);
    private dn;
    get dp(): TrendLineType;
    set dp(a: TrendLineType);
    private hr;
    get i4(): number;
    set i4(a: number);
    private en;
    get fe(): boolean;
    set fe(a: boolean);
    private hc;
    get ip(): number;
    set ip(a: number);
    private he;
    get ir(): number;
    set ir(a: number);
    private hd;
    get iq(): number;
    set iq(a: number);
    private hb;
    get io(): number;
    set io(a: number);
    protected sq(): void;
    private a5;
    get a6(): ComputedPlotAreaMarginMode;
    set a6(a: ComputedPlotAreaMarginMode);
    protected a7(): ComputedPlotAreaMarginMode;
    private c9;
    get da(): SeriesPlotAreaMarginHorizontalMode;
    set da(a: SeriesPlotAreaMarginHorizontalMode);
    private db;
    get dc(): SeriesPlotAreaMarginVerticalMode;
    set dc(a: SeriesPlotAreaMarginVerticalMode);
    private c5;
    get c6(): SeriesHighlightingMode;
    set c6(a: SeriesHighlightingMode);
    private c3;
    get c4(): SeriesHighlightingBehavior;
    set c4(a: SeriesHighlightingBehavior);
    private cb;
    get cc(): LegendHighlightingMode;
    set cc(a: LegendHighlightingMode);
    private cg;
    get ci(): LegendItemBadgeShape;
    set ci(a: LegendItemBadgeShape);
    private cd;
    get ce(): LegendItemBadgeMode;
    set ce(a: LegendItemBadgeMode);
    private jr;
    get jz(): number;
    set jz(a: number);
    private dl;
    get dm(): ToolTipType;
    set dm(a: ToolTipType);
    private a8;
    get a9(): CrosshairsDisplayMode;
    set a9(a: CrosshairsDisplayMode);
    private et;
    get fk(): boolean;
    set fk(a: boolean);
    private tx;
    get uk(): Brush;
    set uk(a: Brush);
    private gv;
    get h6(): number;
    set h6(a: number);
    private tw;
    get uj(): Brush;
    set uj(a: Brush);
    private es;
    get fj(): boolean;
    set fj(a: boolean);
    private ts;
    get uf(): Brush;
    set uf(a: Brush);
    private tu;
    get uh(): Brush;
    set uh(a: Brush);
    private tt;
    get ug(): Brush;
    set ug(a: Brush);
    private tv;
    get ui(): Brush;
    set ui(a: Brush);
    private jj;
    get js(): number;
    set js(a: number);
    private jk;
    get jt(): number;
    set jt(a: number);
    private e5;
    get f8(): boolean;
    set f8(a: boolean);
    private e7;
    get ga(): boolean;
    set ga(a: boolean);
    private ez;
    get fq(): boolean;
    set fq(a: boolean);
    private t7;
    get uu(): Brush;
    set uu(a: Brush);
    private t8;
    get uv(): Brush;
    set uv(a: Brush);
    private jn;
    get jw(): number;
    set jw(a: number);
    private er;
    get fi(): boolean;
    set fi(a: boolean);
    private eq;
    get fh(): boolean;
    set fh(a: boolean);
    private gq;
    get calloutsItemsSource(): IEnumerable;
    set calloutsItemsSource(a: IEnumerable);
    private aj;
    get ak(): CalloutPlacementPositionsCollection;
    set ak(a: CalloutPlacementPositionsCollection);
    private ki;
    get li(): string;
    set li(a: string);
    private kj;
    get lk(): string;
    set lk(a: string);
    private kh;
    get le(): string;
    set le(a: string);
    private kg;
    get lb(): string;
    set lb(a: string);
    private ds;
    get dt(): ValueModeCollection;
    set dt(a: ValueModeCollection);
    private y;
    get ai(): BrushCollection;
    set ai(a: BrushCollection);
    private hs;
    get i5(): number;
    set i5(a: number);
    get dh(): SeriesViewerScrollbarMode;
    set dh(a: SeriesViewerScrollbarMode);
    private df;
    get di(): SeriesViewerScrollbarMode;
    set di(a: SeriesViewerScrollbarMode);
    private dg;
    get de(): SeriesViewerHorizontalScrollbarPosition;
    set de(a: SeriesViewerHorizontalScrollbarPosition);
    private dd;
    get dk(): SeriesViewerVerticalScrollbarPosition;
    set dk(a: SeriesViewerVerticalScrollbarPosition);
    private dj;
    get u0(): Brush;
    set u0(a: Brush);
    private t9;
    get u1(): Brush;
    set u1(a: Brush);
    private ua;
    get ig(): number;
    set ig(a: number);
    private g4;
    get ie(): number;
    set ie(a: number);
    private g3;
    get ib(): number;
    set ib(a: number);
    private g0;
    get ic(): number;
    set ic(a: number);
    private g1;
    get id(): number;
    set id(a: number);
    private g2;
    get ii(): number;
    set ii(a: number);
    private g6;
    get ih(): number;
    set ih(a: number);
    private g5;
    get fs(): boolean;
    set fs(a: boolean);
    private e0;
    static readonly oo: string;
    get u5(): Brush;
    set u5(a: Brush);
    private ud;
    get u6(): Brush;
    set u6(a: Brush);
    private ue;
    get i9(): number;
    set i9(a: number);
    private hw;
    get i8(): number;
    set i8(a: number);
    private hv;
    get i6(): number;
    set i6(a: number);
    private ht;
    get jc(): number;
    set jc(a: number);
    private hz;
    get i7(): number;
    set i7(a: number);
    private hu;
    get jb(): number;
    set jb(a: number);
    private hy;
    get ja(): number;
    set ja(a: number);
    private hx;
    get gd(): boolean;
    set gd(a: boolean);
    private fd;
    static readonly q3: string;
    get je(): number;
    set je(a: number);
    private h1;
    get jd(): number;
    set jd(a: number);
    private h0;
    get jg(): number;
    set jg(a: number);
    private h3;
    get jf(): number;
    set jf(a: number);
    private h2;
}
/**
 * @hidden
 */
export interface IDomainChartToolbarProvider {
    container: any;
    commandChanged: (arg1: ToolCommandStateChanged) => void;
    getDesiredToolbarActions(a: DomainChart, b: ToolActionInfo[]): ToolActionInfo[];
    onToolCommandExecuting(a: DomainChart, b: ToolCommand): void;
    onTargetPropertyChanged(a: DomainChart, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare let IDomainChartToolbarProvider_$type: Type;
