import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { YAxisLabelLocation } from "./YAxisLabelLocation";
import { XAxisLabelLocation } from "./XAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected r5(): void;
    protected su(a: string, b: any, c: any): void;
    private v1;
    get v3(): (item: any) => string;
    set v3(a: (item: any) => string);
    private v2;
    get v4(): (item: any) => string;
    set v4(a: (item: any) => string);
    private wi;
    get xk(): number;
    set xk(a: number);
    private wk;
    get xm(): number;
    set xm(a: number);
    private wj;
    get xl(): number;
    set xl(a: number);
    private wh;
    get xj(): number;
    set xj(a: number);
    private wz;
    get x1(): number;
    set x1(a: number);
    private w1;
    get x3(): number;
    set x3(a: number);
    private w0;
    get x2(): number;
    set x2(a: number);
    private wy;
    get x0(): number;
    set x0(a: number);
    private abs;
    get ab8(): Brush;
    set ab8(a: Brush);
    private abz;
    get acf(): Brush;
    set acf(a: Brush);
    private abq;
    get ab6(): Brush;
    set ab6(a: Brush);
    private abr;
    get ab7(): Brush;
    set ab7(a: Brush);
    private wt;
    get xv(): number;
    set xv(a: number);
    private xa;
    get yc(): number;
    set yc(a: number);
    private ws;
    get xu(): number;
    set xu(a: number);
    private w9;
    get yb(): number;
    set yb(a: number);
    private wv;
    get xx(): number;
    set xx(a: number);
    private xc;
    get ye(): number;
    set ye(a: number);
    private wu;
    get xw(): number;
    set xw(a: number);
    private xb;
    get yd(): number;
    set yd(a: number);
    private wr;
    get xt(): number;
    set xt(a: number);
    private w8;
    get ya(): number;
    set ya(a: number);
    private aby;
    get ace(): Brush;
    set ace(a: Brush);
    private ab5;
    get acl(): Brush;
    set acl(a: Brush);
    protected sv(a: string, b: any, c: any): void;
    private yk;
    get y8(): string;
    set y8(a: string);
    private yo;
    get aad(): string;
    set aad(a: string);
    private ym;
    get zw(): string;
    set zw(a: string);
    private yq;
    get aa1(): string;
    set aa1(a: string);
    private aa7;
    private aa9;
    protected tc(a: DataSeries): void;
    protected abstract vz(): Axis;
    protected abstract v0(): Axis;
    protected aba(a: (arg1: Axis) => void): void;
    protected abb(a: (arg1: Axis) => void, b: string): void;
    protected abg(a: (arg1: Axis) => void, b: boolean): void;
    protected abf(a: (arg1: Axis) => void): void;
    protected rp(a: (arg1: Axis) => void, b: boolean): void;
    protected abe(a: (arg1: TitleSettings) => void): void;
    protected abj(a: (arg1: TitleSettings) => void): void;
    protected abh(a: (arg1: AxisLabelSettings) => void): void;
    protected abc(a: (arg1: AxisLabelSettings) => void): void;
    xd(a: number): number;
    xf(a: number): number;
    xe(a: number): number;
    xg(a: number): number;
    protected s9(a: XamDataChart): void;
    static yt(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected r0(a: XamDataChart): void;
    protected aa6(a: Axis): void;
    protected aa8(a: Axis): void;
    protected rx(): void;
    protected aa4(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected aa5(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected sr(a: string, b: any, c: any): void;
    abi(): void;
    abd(): void;
    v6(a: YAxisLabelLocation): AxisLabelsLocation;
    v5(a: XAxisLabelLocation): AxisLabelsLocation;
    private yf;
    get yh(): any;
    set yh(a: any);
    private yg;
    get yi(): any;
    set yi(a: any);
    private abt;
    get ab9(): Brush;
    set ab9(a: Brush);
    private ab0;
    get acg(): Brush;
    set acg(a: Brush);
    private wl;
    get xn(): number;
    set xn(a: number);
    private w2;
    get x4(): number;
    set x4(a: number);
    private wm;
    get xo(): number;
    set xo(a: number);
    private w3;
    get x5(): number;
    set x5(a: number);
    private abv;
    get acb(): Brush;
    set acb(a: Brush);
    private ab2;
    get aci(): Brush;
    set aci(a: Brush);
    private abw;
    get acc(): Brush;
    set acc(a: Brush);
    private ab3;
    get acj(): Brush;
    set acj(a: Brush);
    private wn;
    get xp(): number;
    set xp(a: number);
    private w4;
    get x6(): number;
    set x6(a: number);
    private wo;
    get xq(): number;
    set xq(a: number);
    private w5;
    get x7(): number;
    set x7(a: number);
    private abx;
    get acd(): Brush;
    set acd(a: Brush);
    private ab4;
    get ack(): Brush;
    set ack(a: Brush);
    private wp;
    get xr(): number;
    set xr(a: number);
    private w6;
    get x8(): number;
    set x8(a: number);
    private yl;
    get zn(): string;
    set zn(a: string);
    private yp;
    get aas(): string;
    set aas(a: string);
    private abu;
    get aca(): Brush;
    set aca(a: Brush);
    private ab1;
    get ach(): Brush;
    set ach(a: Brush);
    private wg;
    get xi(): number;
    set xi(a: number);
    private wx;
    get xz(): number;
    set xz(a: number);
    private wf;
    get xh(): number;
    set xh(a: number);
    private ww;
    get xy(): number;
    set xy(a: number);
    private wq;
    get xs(): number;
    set xs(a: number);
    private w7;
    get x9(): number;
    set x9(a: number);
    private wb;
    get wd(): boolean;
    set wd(a: boolean);
    private wc;
    get we(): boolean;
    set we(a: boolean);
    private abl;
    get abo(): HorizontalAlignment;
    set abo(a: HorizontalAlignment);
    private aco;
    get acr(): VerticalAlignment;
    set acr(a: VerticalAlignment);
    private abk;
    get abn(): HorizontalAlignment;
    set abn(a: HorizontalAlignment);
    private abm;
    protected get_abp(): HorizontalAlignment;
    protected set_abp(a: HorizontalAlignment): void;
    get abp(): HorizontalAlignment;
    set abp(a: HorizontalAlignment);
    private acm;
    get acp(): VerticalAlignment;
    set acp(a: VerticalAlignment);
    private acn;
    get acq(): VerticalAlignment;
    set acq(a: VerticalAlignment);
    private acs;
    get acu(): Visibility;
    set acu(a: Visibility);
    private act;
    get acv(): Visibility;
    set acv(a: Visibility);
    private v9;
    protected get_wa(): YAxisLabelLocation;
    protected set_wa(a: YAxisLabelLocation): void;
    get wa(): YAxisLabelLocation;
    set wa(a: YAxisLabelLocation);
    private v7;
    protected get_v8(): XAxisLabelLocation;
    protected set_v8(a: XAxisLabelLocation): void;
    get v8(): XAxisLabelLocation;
    set v8(a: XAxisLabelLocation);
    private yj;
    get yz(): string;
    set yz(a: string);
    private vv;
    get vx(): any[];
    set vx(a: any[]);
    private yn;
    get z4(): string;
    set z4(a: string);
    private vw;
    get vy(): any[];
    set vy(a: any[]);
}
